/******************************************************************
 * @file  ape_cnt.s.c
 * @brief:    [file description] 
 * @author: xuekun.zhang
 * @Date 2022年6月24日
 * COPYRIGHT NOTICE: (c) smartlogictech. All rights reserved. 
 * Change_date         Owner         Change_content
 * 2022年6月24日        xuekun.zhang       create file

*****************************************************************/

/**************************include******************************/
#include "ape_cnt.h"
#include "ucp_utility.h"
#include "ucp_sfr_c.h"
#include "apcs.h"

/**************************function******************************/
void ape_cnt_init()
{
    uint8_t apeId = get_core_id() & 0x1;//g_apeid & 0x1;//
    uint8_t apcId = get_core_id() >> 1;//g_apeid >> 1;//

    CLK_CTL_REG0 |= BIT0;
    if(0 == apeId)
    {
        APC_CTRL_REG |= BIT8;  //启动 APC0-3 的 CNT0
        do_write(((volatile uint32_t*)(&APC0_CNT0_TSG_CTRL_CNTCR) + (0x14000*apcId)), 1);//不同APC间隔地址0x50000
    }
    else
    {
        APC_CTRL_REG |= BIT9; //启动 APC0-3 的 CNT1
        do_write(((volatile uint32_t*)(&APC0_CNT1_TSG_CTRL_CNTCR) + (0x14000*apcId)), 1);//不同APC间隔地址0x50000
    }

    return;
}

int32_t apeid_cnt_ad_val[8] = {0x04A80008,0x04A82008,0x04AD0008,0x04AD2008,0x04B20008,0x04B22008,0x04B70008,0x04B72008};

