﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_test_case118.h
*  Create Date: 24/03/04
*  Description: eCPRI Test Case118 Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      24/03/04        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_TEST_CASE118_H_
#define _ECPRI_TEST_CASE118_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ecpri_test.h"
#include "ucp_drv_common.h"

#ifdef ECS_RFM0
#endif

#ifdef ECS_RFM1
#include "ecpri_driver.h"
#endif


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
#ifdef ECS_RFM0
/* eCPRI test ECS_RFM0 init */
void ecpri_test_ecs0_init(void);
/* eCPRI test PL packet process */
void ecpri_test_pl_pkt_proc(uint32_t pkt_addr, uint16_t pkt_len);
/* eCPRI test ECS_RFM0 status check */
void ecpri_test_ecs0_status_check(void);
/* eCPRI test ECS_RFM0 result update */
void ecpri_test_ecs0_result_update(void);
#endif
#ifdef ECS_RFM1
/* eCPRI test ECS_RFM1 init */
void ecpri_test_ecs1_init(void);
/* eCPRI test ECS_RFM1 status check */
void ecpri_test_ecs1_status_check(void);
/* eCPRI test ECS_RFM1 result update */
void ecpri_test_ecs1_result_update(void);
#endif


#endif /* _ECPRI_TEST_CASE118_H_ */

