//******************** (C) COPYRIGHT 2019 SmartLogic*******************************
// FileName           : csu.h
// Author             : chenwl, weilu.chen@smartlogictech.com
// Date First Issued  : 2021-11-23 02:49:13 PM
// Last Modified      : 2021-11-23 08:11:05 AM
// Description        :
// ------------------------------------------------------------
// Modification History:
// Version    Date       Author    Modification Description
//
//**********************************************************************************
#ifndef __CSU_H__
#define __CSU_H__


#define APC_CSU_BASE          0x00400000 //SPU config
#define APC0_CSU_BASE         0x04A90000
#define APC1_CSU_BASE         0x04AE0000
#define APC2_CSU_BASE         0x04B30000
#define APC3_CSU_BASE         0x04B80000
#define ECSRFM_CSU_BASE       0x08610000
#define PETRFM_CSU_BASE       0x08F50000
#define AP_CSU_BASE           0x04258000
#define RFC_CSU_BASE          0x04DE0000
#define JS_CSU_BASE           0x05F60000
#define JECS_CSU_BASE         0x08470000


#define APC_CSU_ALLPENDEVENTMASK0                 (*((volatile uint32_t *)(APC_CSU_BASE+0x000*4)))
#define APC_CSU_ALLPENDEVENTMASK1                 (*((volatile uint32_t *)(APC_CSU_BASE+0x001*4)))
#define APC_CSU_EVENTMASKL                        (*((volatile uint32_t *)(APC_CSU_BASE+0x002*4)))
#define APC_CSU_EVENTMASKH                        (*((volatile uint32_t *)(APC_CSU_BASE+0x003*4)))
#define APC_CSU_INTMASKL                          (*((volatile uint32_t *)(APC_CSU_BASE+0x004*4)))
#define APC_CSU_INTMASKH                          (*((volatile uint32_t *)(APC_CSU_BASE+0x005*4)))
#define APC_CSU_TAGMASK                           (*((volatile uint32_t *)(APC_CSU_BASE+0x007*4)))
#define APC_CSU_DMATYPE                           (*((volatile uint32_t *)(APC_CSU_BASE+0x008*4)))
#define APC_CSU_ARMCMDRECV                        (*((volatile uint32_t *)(APC_CSU_BASE+0x00A*4)))
#define APC_CSU_ALLPENDEVENT0                     (*((volatile uint32_t *)(APC_CSU_BASE+0x00C*4)))
#define APC_CSU_ALLPENDEVENT1                     (*((volatile uint32_t *)(APC_CSU_BASE+0x00D*4)))
#define APC_CSU_EM_BS_SMSEL_PREDATANUM            (*((volatile uint32_t *)(APC_CSU_BASE+0x010*4)))
#define APC_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(APC_CSU_BASE+0x010*4)))
#define APC_CSU_ALMOSTFULLSENDTHRED               (*((volatile uint32_t *)(APC_CSU_BASE+0x011*4)))
#define JECS_CSU_ALMOSTFULLSENDTHRED1             (*((volatile uint32_t *)(JECS_CSU_BASE+0x012*4)))
#define APC_CSU_FINDDMATAG                        (*((volatile uint32_t *)(APC_CSU_BASE+0x014*4)))
#define APC_CSU_CMDFIFO0_CMD                      (*((volatile uint32_t *)(APC_CSU_BASE+0x018*4)))
#define APC_CSU_CMDFIFO1_CMD                      (*((volatile uint32_t *)(APC_CSU_BASE+0x019*4)))
#define APC_CSU_CMDFIFO2_CMD                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01A*4)))
#define APC_CSU_CMDFIFO3_CMD                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01B*4)))
#define APC_CSU_CMDFIFO0_NUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01C*4)))
#define APC_CSU_CMDFIFO1_NUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01D*4)))
#define APC_CSU_CMDFIFO2_NUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01E*4)))
#define APC_CSU_CMDFIFO3_NUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x01F*4)))
#define APC_CSU_PRICMDVALID0                      (*((volatile uint32_t *)(APC_CSU_BASE+0x020*4)))
#define APC_CSU_PRICMDVALID1                      (*((volatile uint32_t *)(APC_CSU_BASE+0x021*4)))
#define APC_CSU_PRICMDVALID2                      (*((volatile uint32_t *)(APC_CSU_BASE+0x022*4)))
#define APC_CSU_PRICMDVALID3                      (*((volatile uint32_t *)(APC_CSU_BASE+0x023*4)))
#define APC_CSU_CMDECODATAL32BIT0                 (*((volatile uint32_t *)(APC_CSU_BASE+0x024*4)))
#define APC_CSU_CMDECODATAL32BIT1                 (*((volatile uint32_t *)(APC_CSU_BASE+0x025*4)))
#define APC_CSU_CMDECODATAL32BIT2                 (*((volatile uint32_t *)(APC_CSU_BASE+0x026*4)))
#define APC_CSU_CMDECODATAL32BIT3                 (*((volatile uint32_t *)(APC_CSU_BASE+0x027*4)))
#define APC_CSU_CMDHIGHDATA                       (*((volatile uint32_t *)(APC_CSU_BASE+0x028*4)))
#define APC_CSU_CMDFIFO0                          (*((volatile uint32_t *)(APC_CSU_BASE+0x02C*4)))
#define APC_CSU_CMDFIFO1                          (*((volatile uint32_t *)(APC_CSU_BASE+0x02D*4)))
#define APC_CSU_CMDFIFO2                          (*((volatile uint32_t *)(APC_CSU_BASE+0x02E*4)))
#define APC_CSU_CMDFIFO3                          (*((volatile uint32_t *)(APC_CSU_BASE+0x02F*4)))
#define APC_CSU_READYLISTNUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x030*4)))
#define APC_CSU_CMDFIFO0_TAGNUM                   (*((volatile uint32_t *)(APC_CSU_BASE+0x034*4)))
#define APC_CSU_CMDFIFO1_TAGNUM                   (*((volatile uint32_t *)(APC_CSU_BASE+0x035*4)))
#define APC_CSU_CMDFIFO2_TAGNUM                   (*((volatile uint32_t *)(APC_CSU_BASE+0x036*4)))
#define APC_CSU_CMDFIFO3_TAGNUM                   (*((volatile uint32_t *)(APC_CSU_BASE+0x037*4)))
#define APC_CSU_DMASTATUS                         (*((volatile uint32_t *)(APC_CSU_BASE+0x038*4)))
#define APC_CSU_CMDSTALL_LISTSTALL                (*((volatile uint32_t *)(APC_CSU_BASE+0x039*4)))
#define APC_CSU_QOUSTATUS                         (*((volatile uint32_t *)(APC_CSU_BASE+0x03A*4)))
#define APC_CSU_EVENTINTCLEAR                     (*((volatile uint32_t *)(APC_CSU_BASE+0x03C*4)))
#define APC_CSU_MAILBOX_PRIDATAREG0               (*((volatile uint32_t *)(APC_CSU_BASE+0x100*4)))
#define APC_CSU_MAILBOX_PRIDATAREG1               (*((volatile uint32_t *)(APC_CSU_BASE+0x101*4)))
#define APC_CSU_MAILBOX_PRIDATAREG2               (*((volatile uint32_t *)(APC_CSU_BASE+0x102*4)))
#define APC_CSU_MAILBOX_PRIDATAREG3               (*((volatile uint32_t *)(APC_CSU_BASE+0x103*4)))
#define APC_CSU_MAILBOX_PRIDATAREG4               (*((volatile uint32_t *)(APC_CSU_BASE+0x104*4)))
#define APC_CSU_MAILBOX_PRIDATAREG5               (*((volatile uint32_t *)(APC_CSU_BASE+0x105*4)))
#define APC_CSU_MAILBOX_PRIDATAREG6               (*((volatile uint32_t *)(APC_CSU_BASE+0x106*4)))
#define APC_CSU_MAILBOX_PRIDATAREG7               (*((volatile uint32_t *)(APC_CSU_BASE+0x107*4)))
#define APC_CSU_MAILBOX_PRIDATAREG8               (*((volatile uint32_t *)(APC_CSU_BASE+0x108*4)))
#define APC_CSU_MAILBOX_PRIDATAREG9               (*((volatile uint32_t *)(APC_CSU_BASE+0x109*4)))
#define APC_CSU_MAILBOX_PRIDATAREG10              (*((volatile uint32_t *)(APC_CSU_BASE+0x10A*4)))
#define APC_CSU_MAILBOX_PRIDATAREG11              (*((volatile uint32_t *)(APC_CSU_BASE+0x10B*4)))
#define APC_CSU_MAILBOX_PRIDATAREG12              (*((volatile uint32_t *)(APC_CSU_BASE+0x10C*4)))
#define APC_CSU_MAILBOX_PRIDATAREG13              (*((volatile uint32_t *)(APC_CSU_BASE+0x10D*4)))
#define APC_CSU_MAILBOX_PRIDATAREG14              (*((volatile uint32_t *)(APC_CSU_BASE+0x10E*4)))
#define APC_CSU_MAILBOX_PRIDATAREG15              (*((volatile uint32_t *)(APC_CSU_BASE+0x10F*4)))
#define APC_CSU_MAILBOX_BASENUM                   (*((volatile uint32_t *)(APC_CSU_BASE+0x120*4)))
#define APC_CSU_MAILBOX_BASECNT                   (*((volatile uint32_t *)(APC_CSU_BASE+0x121*4)))
#define APC_CSU_MAILBOX_VALIDREG                  (*((volatile uint32_t *)(APC_CSU_BASE+0x122*4)))
#define APC_CSU_MAILBOX_INTMASK0                  (*((volatile uint32_t *)(APC_CSU_BASE+0x124*4)))
#define APC_CSU_MAILBOX_INTMASK1                  (*((volatile uint32_t *)(APC_CSU_BASE+0x125*4)))
#define APC_CSU_MAILBOX_INTMASK2                  (*((volatile uint32_t *)(APC_CSU_BASE+0x126*4)))
#define APC_CSU_MAILBOX_INTMASK3                  (*((volatile uint32_t *)(APC_CSU_BASE+0x127*4)))
#define APC_CSU_MAILBOX_EVENTMASK0                (*((volatile uint32_t *)(APC_CSU_BASE+0x130*4)))
#define APC_CSU_MAILBOX_EVENTMASK1                (*((volatile uint32_t *)(APC_CSU_BASE+0x131*4)))
#define APC_CSU_MAILBOX_CNTREG0                   (*((volatile uint32_t *)(APC_CSU_BASE+0x180*4)))
#define APC_CSU_MAILBOX_CNTREG1                   (*((volatile uint32_t *)(APC_CSU_BASE+0x181*4)))
#define APC_CSU_MAILBOX_CNTREG2                   (*((volatile uint32_t *)(APC_CSU_BASE+0x182*4)))
#define APC_CSU_MAILBOX_CNTREG3                   (*((volatile uint32_t *)(APC_CSU_BASE+0x183*4)))
#define APC_CSU_MAILBOX_CNTREG4                   (*((volatile uint32_t *)(APC_CSU_BASE+0x184*4)))
#define APC_CSU_MAILBOX_CNTREG5                   (*((volatile uint32_t *)(APC_CSU_BASE+0x185*4)))
#define APC_CSU_MAILBOX_CNTREG6                   (*((volatile uint32_t *)(APC_CSU_BASE+0x186*4)))
#define APC_CSU_MAILBOX_CNTREG7                   (*((volatile uint32_t *)(APC_CSU_BASE+0x187*4)))
#define APC_CSU_MAILBOX_CNTREG8                   (*((volatile uint32_t *)(APC_CSU_BASE+0x188*4)))
#define APC_CSU_MAILBOX_CNTREG9                   (*((volatile uint32_t *)(APC_CSU_BASE+0x189*4)))
#define APC_CSU_MAILBOX_CNTREG10                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18A*4)))
#define APC_CSU_MAILBOX_CNTREG11                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18B*4)))
#define APC_CSU_MAILBOX_CNTREG12                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18C*4)))
#define APC_CSU_MAILBOX_CNTREG13                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18D*4)))
#define APC_CSU_MAILBOX_CNTREG14                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18E*4)))
#define APC_CSU_MAILBOX_CNTREG15                  (*((volatile uint32_t *)(APC_CSU_BASE+0x18F*4)))
#define APC_CSU_DMAADDRL0                         (*((volatile uint32_t *)(APC_CSU_BASE+0x200*4)))
#define APC_CSU_DMAADDRH0                         (*((volatile uint32_t *)(APC_CSU_BASE+0x201*4)))
#define APC_CSU_DMAYSTEPL0                        (*((volatile uint32_t *)(APC_CSU_BASE+0x202*4)))
#define APC_CSU_DMAYSTEPH0                        (*((volatile uint32_t *)(APC_CSU_BASE+0x203*4)))
#define APC_CSU_DMAZSTEPL0                        (*((volatile uint32_t *)(APC_CSU_BASE+0x204*4)))
#define APC_CSU_DMAZSTEPH0                        (*((volatile uint32_t *)(APC_CSU_BASE+0x205*4)))
#define APC_CSU_DMAYNUMXNUM0                      (*((volatile uint32_t *)(APC_CSU_BASE+0x206*4)))
#define APC_CSU_DMASIZEGRANALLNUM0                (*((volatile uint32_t *)(APC_CSU_BASE+0x207*4)))
#define APC_CSU_DMAADDRL1                         (*((volatile uint32_t *)(APC_CSU_BASE+0x208*4)))
#define APC_CSU_DMAADDRH1                         (*((volatile uint32_t *)(APC_CSU_BASE+0x209*4)))
#define APC_CSU_DMAYSTEPL1                        (*((volatile uint32_t *)(APC_CSU_BASE+0x20A*4)))
#define APC_CSU_DMAYSTEPH1                        (*((volatile uint32_t *)(APC_CSU_BASE+0x20B*4)))
#define APC_CSU_DMAZSTEPL1                        (*((volatile uint32_t *)(APC_CSU_BASE+0x20C*4)))
#define APC_CSU_DMAZSTEPH1                        (*((volatile uint32_t *)(APC_CSU_BASE+0x20D*4)))
#define APC_CSU_DMAYNUMXNUM1                      (*((volatile uint32_t *)(APC_CSU_BASE+0x20E*4)))
#define APC_CSU_DMASIZEGRANALLNUM1                (*((volatile uint32_t *)(APC_CSU_BASE+0x20F*4)))
#define APC_CSU_DMAADDRL2                         (*((volatile uint32_t *)(APC_CSU_BASE+0x210*4)))
#define APC_CSU_DMAADDRH2                         (*((volatile uint32_t *)(APC_CSU_BASE+0x211*4)))
#define APC_CSU_DMAYSTEPL2                        (*((volatile uint32_t *)(APC_CSU_BASE+0x212*4)))
#define APC_CSU_DMAYSTEPH2                        (*((volatile uint32_t *)(APC_CSU_BASE+0x213*4)))
#define APC_CSU_DMAZSTEPL2                        (*((volatile uint32_t *)(APC_CSU_BASE+0x214*4)))
#define APC_CSU_DMAZSTEPH2                        (*((volatile uint32_t *)(APC_CSU_BASE+0x215*4)))
#define APC_CSU_DMAYNUMXNUM2                      (*((volatile uint32_t *)(APC_CSU_BASE+0x216*4)))
#define APC_CSU_DMASIZEGRANALLNUM2                (*((volatile uint32_t *)(APC_CSU_BASE+0x217*4)))
#define APC_CSU_DMAADDRL3                         (*((volatile uint32_t *)(APC_CSU_BASE+0x218*4)))
#define APC_CSU_DMAADDRH3                         (*((volatile uint32_t *)(APC_CSU_BASE+0x219*4)))
#define APC_CSU_DMAYSTEPL3                        (*((volatile uint32_t *)(APC_CSU_BASE+0x21A*4)))
#define APC_CSU_DMAYSTEPH3                        (*((volatile uint32_t *)(APC_CSU_BASE+0x21B*4)))
#define APC_CSU_DMAZSTEPL3                        (*((volatile uint32_t *)(APC_CSU_BASE+0x21C*4)))
#define APC_CSU_DMAZSTEPH3                        (*((volatile uint32_t *)(APC_CSU_BASE+0x21D*4)))
#define APC_CSU_DMAYNUMXNUM3                      (*((volatile uint32_t *)(APC_CSU_BASE+0x21E*4)))
#define APC_CSU_DMASIZEGRANALLNUM3                (*((volatile uint32_t *)(APC_CSU_BASE+0x21F*4)))
#define APC_CSU_DMAADDRL4                         (*((volatile uint32_t *)(APC_CSU_BASE+0x220*4)))
#define APC_CSU_DMAADDRH4                         (*((volatile uint32_t *)(APC_CSU_BASE+0x221*4)))
#define APC_CSU_DMAYSTEPL4                        (*((volatile uint32_t *)(APC_CSU_BASE+0x222*4)))
#define APC_CSU_DMAYSTEPH4                        (*((volatile uint32_t *)(APC_CSU_BASE+0x223*4)))
#define APC_CSU_DMAZSTEPL4                        (*((volatile uint32_t *)(APC_CSU_BASE+0x224*4)))
#define APC_CSU_DMAZSTEPH4                        (*((volatile uint32_t *)(APC_CSU_BASE+0x225*4)))
#define APC_CSU_DMAYNUMXNUM4                      (*((volatile uint32_t *)(APC_CSU_BASE+0x226*4)))
#define APC_CSU_DMASIZEGRANALLNUM4                (*((volatile uint32_t *)(APC_CSU_BASE+0x227*4)))
#define APC_CSU_DMAADDRL5                         (*((volatile uint32_t *)(APC_CSU_BASE+0x228*4)))
#define APC_CSU_DMAADDRH5                         (*((volatile uint32_t *)(APC_CSU_BASE+0x229*4)))
#define APC_CSU_DMAYSTEPL5                        (*((volatile uint32_t *)(APC_CSU_BASE+0x22A*4)))
#define APC_CSU_DMAYSTEPH5                        (*((volatile uint32_t *)(APC_CSU_BASE+0x22B*4)))
#define APC_CSU_DMAZSTEPL5                        (*((volatile uint32_t *)(APC_CSU_BASE+0x22C*4)))
#define APC_CSU_DMAZSTEPH5                        (*((volatile uint32_t *)(APC_CSU_BASE+0x22D*4)))
#define APC_CSU_DMAYNUMXNUM5                      (*((volatile uint32_t *)(APC_CSU_BASE+0x22E*4)))
#define APC_CSU_DMASIZEGRANALLNUM5                (*((volatile uint32_t *)(APC_CSU_BASE+0x22F*4)))
#define APC_CSU_DMAADDRL6                         (*((volatile uint32_t *)(APC_CSU_BASE+0x230*4)))
#define APC_CSU_DMAADDRH6                         (*((volatile uint32_t *)(APC_CSU_BASE+0x231*4)))
#define APC_CSU_DMAYSTEPL6                        (*((volatile uint32_t *)(APC_CSU_BASE+0x232*4)))
#define APC_CSU_DMAYSTEPH6                        (*((volatile uint32_t *)(APC_CSU_BASE+0x233*4)))
#define APC_CSU_DMAZSTEPL6                        (*((volatile uint32_t *)(APC_CSU_BASE+0x234*4)))
#define APC_CSU_DMAZSTEPH6                        (*((volatile uint32_t *)(APC_CSU_BASE+0x235*4)))
#define APC_CSU_DMAYNUMXNUM6                      (*((volatile uint32_t *)(APC_CSU_BASE+0x236*4)))
#define APC_CSU_DMASIZEGRANALLNUM6                (*((volatile uint32_t *)(APC_CSU_BASE+0x237*4)))
#define APC_CSU_DMAADDRL7                         (*((volatile uint32_t *)(APC_CSU_BASE+0x238*4)))
#define APC_CSU_DMAADDRH7                         (*((volatile uint32_t *)(APC_CSU_BASE+0x239*4)))
#define APC_CSU_DMAYSTEPL7                        (*((volatile uint32_t *)(APC_CSU_BASE+0x23A*4)))
#define APC_CSU_DMAYSTEPH7                        (*((volatile uint32_t *)(APC_CSU_BASE+0x23B*4)))
#define APC_CSU_DMAZSTEPL7                        (*((volatile uint32_t *)(APC_CSU_BASE+0x23C*4)))
#define APC_CSU_DMAZSTEPH7                        (*((volatile uint32_t *)(APC_CSU_BASE+0x23D*4)))
#define APC_CSU_DMAYNUMXNUM7                      (*((volatile uint32_t *)(APC_CSU_BASE+0x23E*4)))
#define APC_CSU_DMASIZEGRANALLNUM7                (*((volatile uint32_t *)(APC_CSU_BASE+0x23F*4)))
#define APC_CSU_DMAADDRL8                         (*((volatile uint32_t *)(APC_CSU_BASE+0x240*4)))
#define APC_CSU_DMAADDRH8                         (*((volatile uint32_t *)(APC_CSU_BASE+0x241*4)))
#define APC_CSU_DMAYSTEPL8                        (*((volatile uint32_t *)(APC_CSU_BASE+0x242*4)))
#define APC_CSU_DMAYSTEPH8                        (*((volatile uint32_t *)(APC_CSU_BASE+0x243*4)))
#define APC_CSU_DMAZSTEPL8                        (*((volatile uint32_t *)(APC_CSU_BASE+0x244*4)))
#define APC_CSU_DMAZSTEPH8                        (*((volatile uint32_t *)(APC_CSU_BASE+0x245*4)))
#define APC_CSU_DMAYNUMXNUM8                      (*((volatile uint32_t *)(APC_CSU_BASE+0x246*4)))
#define APC_CSU_DMASIZEGRANALLNUM8                (*((volatile uint32_t *)(APC_CSU_BASE+0x247*4)))
#define APC_CSU_DMAADDRL9                         (*((volatile uint32_t *)(APC_CSU_BASE+0x248*4)))
#define APC_CSU_DMAADDRH9                         (*((volatile uint32_t *)(APC_CSU_BASE+0x249*4)))
#define APC_CSU_DMAYSTEPL9                        (*((volatile uint32_t *)(APC_CSU_BASE+0x24A*4)))
#define APC_CSU_DMAYSTEPH9                        (*((volatile uint32_t *)(APC_CSU_BASE+0x24B*4)))
#define APC_CSU_DMAZSTEPL9                        (*((volatile uint32_t *)(APC_CSU_BASE+0x24C*4)))
#define APC_CSU_DMAZSTEPH9                        (*((volatile uint32_t *)(APC_CSU_BASE+0x24D*4)))
#define APC_CSU_DMAYNUMXNUM9                      (*((volatile uint32_t *)(APC_CSU_BASE+0x24E*4)))
#define APC_CSU_DMASIZEGRANALLNUM9                (*((volatile uint32_t *)(APC_CSU_BASE+0x24F*4)))
#define APC_CSU_DMAADDRL10                        (*((volatile uint32_t *)(APC_CSU_BASE+0x250*4)))
#define APC_CSU_DMAADDRH10                        (*((volatile uint32_t *)(APC_CSU_BASE+0x251*4)))
#define APC_CSU_DMAYSTEPL10                       (*((volatile uint32_t *)(APC_CSU_BASE+0x252*4)))
#define APC_CSU_DMAYSTEPH10                       (*((volatile uint32_t *)(APC_CSU_BASE+0x253*4)))
#define APC_CSU_DMAZSTEPL10                       (*((volatile uint32_t *)(APC_CSU_BASE+0x254*4)))
#define APC_CSU_DMAZSTEPH10                       (*((volatile uint32_t *)(APC_CSU_BASE+0x255*4)))
#define APC_CSU_DMAYNUMXNUM10                     (*((volatile uint32_t *)(APC_CSU_BASE+0x256*4)))
#define APC_CSU_DMASIZEGRANALLNUM10               (*((volatile uint32_t *)(APC_CSU_BASE+0x257*4)))
#define APC_CSU_DMAADDRL11                        (*((volatile uint32_t *)(APC_CSU_BASE+0x258*4)))
#define APC_CSU_DMAADDRH11                        (*((volatile uint32_t *)(APC_CSU_BASE+0x259*4)))
#define APC_CSU_DMAYSTEPL11                       (*((volatile uint32_t *)(APC_CSU_BASE+0x25A*4)))
#define APC_CSU_DMAYSTEPH11                       (*((volatile uint32_t *)(APC_CSU_BASE+0x25B*4)))
#define APC_CSU_DMAZSTEPL11                       (*((volatile uint32_t *)(APC_CSU_BASE+0x25C*4)))
#define APC_CSU_DMAZSTEPH11                       (*((volatile uint32_t *)(APC_CSU_BASE+0x25D*4)))
#define APC_CSU_DMAYNUMXNUM11                     (*((volatile uint32_t *)(APC_CSU_BASE+0x25E*4)))
#define APC_CSU_DMASIZEGRANALLNUM11               (*((volatile uint32_t *)(APC_CSU_BASE+0x25F*4)))
#define APC_CSU_DMAADDRL12                        (*((volatile uint32_t *)(APC_CSU_BASE+0x260*4)))
#define APC_CSU_DMAADDRH12                        (*((volatile uint32_t *)(APC_CSU_BASE+0x261*4)))
#define APC_CSU_DMAYSTEPL12                       (*((volatile uint32_t *)(APC_CSU_BASE+0x262*4)))
#define APC_CSU_DMAYSTEPH12                       (*((volatile uint32_t *)(APC_CSU_BASE+0x263*4)))
#define APC_CSU_DMAZSTEPL12                       (*((volatile uint32_t *)(APC_CSU_BASE+0x264*4)))
#define APC_CSU_DMAZSTEPH12                       (*((volatile uint32_t *)(APC_CSU_BASE+0x265*4)))
#define APC_CSU_DMAYNUMXNUM12                     (*((volatile uint32_t *)(APC_CSU_BASE+0x266*4)))
#define APC_CSU_DMASIZEGRANALLNUM12               (*((volatile uint32_t *)(APC_CSU_BASE+0x267*4)))
#define APC_CSU_DMAADDRL13                        (*((volatile uint32_t *)(APC_CSU_BASE+0x268*4)))
#define APC_CSU_DMAADDRH13                        (*((volatile uint32_t *)(APC_CSU_BASE+0x269*4)))
#define APC_CSU_DMAYSTEPL13                       (*((volatile uint32_t *)(APC_CSU_BASE+0x26A*4)))
#define APC_CSU_DMAYSTEPH13                       (*((volatile uint32_t *)(APC_CSU_BASE+0x26B*4)))
#define APC_CSU_DMAZSTEPL13                       (*((volatile uint32_t *)(APC_CSU_BASE+0x26C*4)))
#define APC_CSU_DMAZSTEPH13                       (*((volatile uint32_t *)(APC_CSU_BASE+0x26D*4)))
#define APC_CSU_DMAYNUMXNUM13                     (*((volatile uint32_t *)(APC_CSU_BASE+0x26E*4)))
#define APC_CSU_DMASIZEGRANALLNUM13               (*((volatile uint32_t *)(APC_CSU_BASE+0x26F*4)))
#define APC_CSU_DMAADDRL14                        (*((volatile uint32_t *)(APC_CSU_BASE+0x270*4)))
#define APC_CSU_DMAADDRH14                        (*((volatile uint32_t *)(APC_CSU_BASE+0x271*4)))
#define APC_CSU_DMAYSTEPL14                       (*((volatile uint32_t *)(APC_CSU_BASE+0x272*4)))
#define APC_CSU_DMAYSTEPH14                       (*((volatile uint32_t *)(APC_CSU_BASE+0x273*4)))
#define APC_CSU_DMAZSTEPL14                       (*((volatile uint32_t *)(APC_CSU_BASE+0x274*4)))
#define APC_CSU_DMAZSTEPH14                       (*((volatile uint32_t *)(APC_CSU_BASE+0x275*4)))
#define APC_CSU_DMAYNUMXNUM14                     (*((volatile uint32_t *)(APC_CSU_BASE+0x276*4)))
#define APC_CSU_DMASIZEGRANALLNUM14               (*((volatile uint32_t *)(APC_CSU_BASE+0x277*4)))
#define APC_CSU_DMAADDRL15                        (*((volatile uint32_t *)(APC_CSU_BASE+0x278*4)))
#define APC_CSU_DMAADDRH15                        (*((volatile uint32_t *)(APC_CSU_BASE+0x279*4)))
#define APC_CSU_DMAYSTEPL15                       (*((volatile uint32_t *)(APC_CSU_BASE+0x27A*4)))
#define APC_CSU_DMAYSTEPH15                       (*((volatile uint32_t *)(APC_CSU_BASE+0x27B*4)))
#define APC_CSU_DMAZSTEPL15                       (*((volatile uint32_t *)(APC_CSU_BASE+0x27C*4)))
#define APC_CSU_DMAZSTEPH15                       (*((volatile uint32_t *)(APC_CSU_BASE+0x27D*4)))
#define APC_CSU_DMAYNUMXNUM15                     (*((volatile uint32_t *)(APC_CSU_BASE+0x27E*4)))
#define APC_CSU_DMASIZEGRANALLNUM15               (*((volatile uint32_t *)(APC_CSU_BASE+0x27F*4)))
#define APC_CSU_QOUCMDNUM_QOUCMDPOS               (*((volatile uint32_t *)(APC_CSU_BASE+0x300*4)))
#define APC_CSU_QOUCMDADDR                        (*((volatile uint32_t *)(APC_CSU_BASE+0x301*4)))
#define APC_CSU_QOUCMDDATA                        (*((volatile uint32_t *)(APC_CSU_BASE+0x302*4)))
#define APC_CSU_QOUSTATUSPOPDATA                  (*((volatile uint32_t *)(APC_CSU_BASE+0x303*4)))
#define APC_CSU_QOUCMPDATA0                       (*((volatile uint32_t *)(APC_CSU_BASE+0x304*4)))
#define APC_CSU_QOUCMPDATA1                       (*((volatile uint32_t *)(APC_CSU_BASE+0x305*4)))
#define APC_CSU_QOUCMPDATA2                       (*((volatile uint32_t *)(APC_CSU_BASE+0x306*4)))
#define APC_CSU_QOUCMPDATA3                       (*((volatile uint32_t *)(APC_CSU_BASE+0x307*4)))
#define APC_CSU_SPUID                             (*((volatile uint32_t *)(APC_CSU_BASE+0x30B*4)))
#define APC_CSU_PRICMDDATA_L32BIT0                (*((volatile uint32_t *)(APC_CSU_BASE+0x310*4)))
#define APC_CSU_PRICMDDATA_H14BIT0                (*((volatile uint32_t *)(APC_CSU_BASE+0x311*4)))
#define APC_CSU_PRICMDDATA_L32BIT1                (*((volatile uint32_t *)(APC_CSU_BASE+0x312*4)))
#define APC_CSU_PRICMDDATA_H14BIT1                (*((volatile uint32_t *)(APC_CSU_BASE+0x313*4)))
#define APC_CSU_PRICMDDATA_L32BIT2                (*((volatile uint32_t *)(APC_CSU_BASE+0x314*4)))
#define APC_CSU_PRICMDDATA_H14BIT2                (*((volatile uint32_t *)(APC_CSU_BASE+0x315*4)))
#define APC_CSU_PRICMDDATA_L32BIT3                (*((volatile uint32_t *)(APC_CSU_BASE+0x316*4)))
#define APC_CSU_PRICMDDATA_H14BIT3                (*((volatile uint32_t *)(APC_CSU_BASE+0x317*4)))
#define APC_CSU_SORTDATA_NUM                      (*((volatile uint32_t *)(APC_CSU_BASE+0x380*4)))
#define APC_CSU_SORTDATA_DATA0                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C0*4)))
#define APC_CSU_SORTDATA_DATA1                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C1*4)))
#define APC_CSU_SORTDATA_DATA2                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C2*4)))
#define APC_CSU_SORTDATA_DATA3                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C3*4)))
#define APC_CSU_SORTDATA_DATA4                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C4*4)))
#define APC_CSU_SORTDATA_DATA5                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C5*4)))
#define APC_CSU_SORTDATA_DATA6                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C6*4)))
#define APC_CSU_SORTDATA_DATA7                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C7*4)))
#define APC_CSU_SORTDATA_DATA8                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C8*4)))
#define APC_CSU_SORTDATA_DATA9                    (*((volatile uint32_t *)(APC_CSU_BASE+0x3C9*4)))
#define APC_CSU_SORTDATA_DATA10                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CA*4)))
#define APC_CSU_SORTDATA_DATA11                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CB*4)))
#define APC_CSU_SORTDATA_DATA12                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CC*4)))
#define APC_CSU_SORTDATA_DATA13                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CD*4)))
#define APC_CSU_SORTDATA_DATA14                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CE*4)))
#define APC_CSU_SORTDATA_DATA15                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3CF*4)))
#define APC_CSU_SORTDATA_DATA16                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D0*4)))
#define APC_CSU_SORTDATA_DATA17                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D1*4)))
#define APC_CSU_SORTDATA_DATA18                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D2*4)))
#define APC_CSU_SORTDATA_DATA19                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D3*4)))
#define APC_CSU_SORTDATA_DATA20                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D4*4)))
#define APC_CSU_SORTDATA_DATA21                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D5*4)))
#define APC_CSU_SORTDATA_DATA22                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D6*4)))
#define APC_CSU_SORTDATA_DATA23                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D7*4)))
#define APC_CSU_SORTDATA_DATA24                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D8*4)))
#define APC_CSU_SORTDATA_DATA25                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3D9*4)))
#define APC_CSU_SORTDATA_DATA26                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DA*4)))
#define APC_CSU_SORTDATA_DATA27                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DB*4)))
#define APC_CSU_SORTDATA_DATA28                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DC*4)))
#define APC_CSU_SORTDATA_DATA29                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DD*4)))
#define APC_CSU_SORTDATA_DATA30                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DE*4)))
#define APC_CSU_SORTDATA_DATA31                   (*((volatile uint32_t *)(APC_CSU_BASE+0x3DF*4)))
#define APC_CSU_SORTDATA_ID0                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E0*4)))
#define APC_CSU_SORTDATA_ID1                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E1*4)))
#define APC_CSU_SORTDATA_ID2                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E2*4)))
#define APC_CSU_SORTDATA_ID3                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E3*4)))
#define APC_CSU_SORTDATA_ID4                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E4*4)))
#define APC_CSU_SORTDATA_ID5                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E5*4)))
#define APC_CSU_SORTDATA_ID6                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E6*4)))
#define APC_CSU_SORTDATA_ID7                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E7*4)))
#define APC_CSU_SORTDATA_ID8                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E8*4)))
#define APC_CSU_SORTDATA_ID9                      (*((volatile uint32_t *)(APC_CSU_BASE+0x3E9*4)))
#define APC_CSU_SORTDATA_ID10                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3EA*4)))
#define APC_CSU_SORTDATA_ID11                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3EB*4)))
#define APC_CSU_SORTDATA_ID12                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3EC*4)))
#define APC_CSU_SORTDATA_ID13                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3ED*4)))
#define APC_CSU_SORTDATA_ID14                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3EE*4)))
#define APC_CSU_SORTDATA_ID15                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3EF*4)))
#define APC_CSU_SORTDATA_ID16                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F0*4)))
#define APC_CSU_SORTDATA_ID17                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F1*4)))
#define APC_CSU_SORTDATA_ID18                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F2*4)))
#define APC_CSU_SORTDATA_ID19                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F3*4)))
#define APC_CSU_SORTDATA_ID20                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F4*4)))
#define APC_CSU_SORTDATA_ID21                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F5*4)))
#define APC_CSU_SORTDATA_ID22                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F6*4)))
#define APC_CSU_SORTDATA_ID23                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F7*4)))
#define APC_CSU_SORTDATA_ID24                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F8*4)))
#define APC_CSU_SORTDATA_ID25                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3F9*4)))
#define APC_CSU_SORTDATA_ID26                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FA*4)))
#define APC_CSU_SORTDATA_ID27                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FB*4)))
#define APC_CSU_SORTDATA_ID28                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FC*4)))
#define APC_CSU_SORTDATA_ID29                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FD*4)))
#define APC_CSU_SORTDATA_ID30                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FE*4)))
#define APC_CSU_SORTDATA_ID31                     (*((volatile uint32_t *)(APC_CSU_BASE+0x3FF*4)))


#define APC0_CSU_STARTSPU0                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x000*4)))
#define APC0_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x000*4)))
#define APC0_CSU_STARTSPU1                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x001*4)))
#define APC0_CSU_EVENTMASK                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x002*4)))
#define APC0_CSU_INTMASK                          (*((volatile uint32_t *)(APC0_CSU_BASE+0x004*4)))
#define APC0_CSU_ELEVELMASK                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x005*4)))
#define APC0_CSU_TAGMASK0                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x006*4)))
#define APC0_CSU_TAGMASK1                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x007*4)))
#define APC0_CSU_TAGMASK2                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x008*4)))
#define APC0_CSU_TAGMASK3                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x009*4)))
#define APC0_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x00A*4)))
#define APC0_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(APC0_CSU_BASE+0x00B*4)))
#define APC0_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x00C*4)))
#define APC0_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x00D*4)))
#define APC0_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(APC0_CSU_BASE+0x010*4)))
#define APC0_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(APC0_CSU_BASE+0x010*4)))
#define APC0_CSU_FINDDMATAG                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x014*4)))
#define APC0_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x018*4)))
#define APC0_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x019*4)))
#define APC0_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01A*4)))
#define APC0_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01B*4)))
#define APC0_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01C*4)))
#define APC0_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01D*4)))
#define APC0_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01E*4)))
#define APC0_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x01F*4)))
#define APC0_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x020*4)))
#define APC0_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x021*4)))
#define APC0_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x022*4)))
#define APC0_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x023*4)))
#define APC0_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(APC0_CSU_BASE+0x024*4)))
#define APC0_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(APC0_CSU_BASE+0x025*4)))
#define APC0_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(APC0_CSU_BASE+0x026*4)))
#define APC0_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(APC0_CSU_BASE+0x027*4)))
#define APC0_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x028*4)))
#define APC0_CSU_CMDFIFO0                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x02C*4)))
#define APC0_CSU_CMDFIFO1                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x02D*4)))
#define APC0_CSU_CMDFIFO2                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x02E*4)))
#define APC0_CSU_CMDFIFO3                         (*((volatile uint32_t *)(APC0_CSU_BASE+0x02F*4)))
#define APC0_CSU_READYLISTNUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x030*4)))
#define APC0_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x034*4)))
#define APC0_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x035*4)))
#define APC0_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x036*4)))
#define APC0_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x037*4)))
#define APC0_CSU_DMASTATUS                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x038*4)))
#define APC0_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(APC0_CSU_BASE+0x039*4)))
#define APC0_CSU_QOUSTATUS                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x03A*4)))
#define APC0_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x03C*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(APC0_CSU_BASE+0x100*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(APC0_CSU_BASE+0x101*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(APC0_CSU_BASE+0x102*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(APC0_CSU_BASE+0x103*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(APC0_CSU_BASE+0x104*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(APC0_CSU_BASE+0x105*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(APC0_CSU_BASE+0x106*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(APC0_CSU_BASE+0x107*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(APC0_CSU_BASE+0x108*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(APC0_CSU_BASE+0x109*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10A*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10B*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10C*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10D*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10E*4)))
#define APC0_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(APC0_CSU_BASE+0x10F*4)))
#define APC0_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x120*4)))
#define APC0_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x121*4)))
#define APC0_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x122*4)))
#define APC0_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x124*4)))
#define APC0_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x125*4)))
#define APC0_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x126*4)))
#define APC0_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x127*4)))
#define APC0_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(APC0_CSU_BASE+0x130*4)))
#define APC0_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(APC0_CSU_BASE+0x131*4)))
#define APC0_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x180*4)))
#define APC0_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x181*4)))
#define APC0_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x182*4)))
#define APC0_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x183*4)))
#define APC0_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x184*4)))
#define APC0_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x185*4)))
#define APC0_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x186*4)))
#define APC0_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x187*4)))
#define APC0_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x188*4)))
#define APC0_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x189*4)))
#define APC0_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18A*4)))
#define APC0_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18B*4)))
#define APC0_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18C*4)))
#define APC0_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18D*4)))
#define APC0_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18E*4)))
#define APC0_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x18F*4)))
#define APC0_CSU_DMAADDRL0                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x200*4)))
#define APC0_CSU_DMAADDRH0                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x201*4)))
#define APC0_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x202*4)))
#define APC0_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x203*4)))
#define APC0_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x204*4)))
#define APC0_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x205*4)))
#define APC0_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x206*4)))
#define APC0_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(APC0_CSU_BASE+0x207*4)))
#define APC0_CSU_DMAADDRL1                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x208*4)))
#define APC0_CSU_DMAADDRH1                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x209*4)))
#define APC0_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x20A*4)))
#define APC0_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x20B*4)))
#define APC0_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x20C*4)))
#define APC0_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x20D*4)))
#define APC0_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x20E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(APC0_CSU_BASE+0x20F*4)))
#define APC0_CSU_DMAADDRL2                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x210*4)))
#define APC0_CSU_DMAADDRH2                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x211*4)))
#define APC0_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x212*4)))
#define APC0_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x213*4)))
#define APC0_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x214*4)))
#define APC0_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x215*4)))
#define APC0_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x216*4)))
#define APC0_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(APC0_CSU_BASE+0x217*4)))
#define APC0_CSU_DMAADDRL3                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x218*4)))
#define APC0_CSU_DMAADDRH3                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x219*4)))
#define APC0_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x21A*4)))
#define APC0_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x21B*4)))
#define APC0_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x21C*4)))
#define APC0_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x21D*4)))
#define APC0_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x21E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(APC0_CSU_BASE+0x21F*4)))
#define APC0_CSU_DMAADDRL4                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x220*4)))
#define APC0_CSU_DMAADDRH4                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x221*4)))
#define APC0_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x222*4)))
#define APC0_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x223*4)))
#define APC0_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x224*4)))
#define APC0_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x225*4)))
#define APC0_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x226*4)))
#define APC0_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(APC0_CSU_BASE+0x227*4)))
#define APC0_CSU_DMAADDRL5                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x228*4)))
#define APC0_CSU_DMAADDRH5                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x229*4)))
#define APC0_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x22A*4)))
#define APC0_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x22B*4)))
#define APC0_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x22C*4)))
#define APC0_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x22D*4)))
#define APC0_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x22E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(APC0_CSU_BASE+0x22F*4)))
#define APC0_CSU_DMAADDRL6                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x230*4)))
#define APC0_CSU_DMAADDRH6                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x231*4)))
#define APC0_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x232*4)))
#define APC0_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x233*4)))
#define APC0_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x234*4)))
#define APC0_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x235*4)))
#define APC0_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x236*4)))
#define APC0_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(APC0_CSU_BASE+0x237*4)))
#define APC0_CSU_DMAADDRL7                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x238*4)))
#define APC0_CSU_DMAADDRH7                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x239*4)))
#define APC0_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x23A*4)))
#define APC0_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x23B*4)))
#define APC0_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x23C*4)))
#define APC0_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x23D*4)))
#define APC0_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x23E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(APC0_CSU_BASE+0x23F*4)))
#define APC0_CSU_DMAADDRL8                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x240*4)))
#define APC0_CSU_DMAADDRH8                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x241*4)))
#define APC0_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x242*4)))
#define APC0_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x243*4)))
#define APC0_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x244*4)))
#define APC0_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x245*4)))
#define APC0_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x246*4)))
#define APC0_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(APC0_CSU_BASE+0x247*4)))
#define APC0_CSU_DMAADDRL9                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x248*4)))
#define APC0_CSU_DMAADDRH9                        (*((volatile uint32_t *)(APC0_CSU_BASE+0x249*4)))
#define APC0_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x24A*4)))
#define APC0_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x24B*4)))
#define APC0_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x24C*4)))
#define APC0_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x24D*4)))
#define APC0_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x24E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(APC0_CSU_BASE+0x24F*4)))
#define APC0_CSU_DMAADDRL10                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x250*4)))
#define APC0_CSU_DMAADDRH10                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x251*4)))
#define APC0_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x252*4)))
#define APC0_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x253*4)))
#define APC0_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x254*4)))
#define APC0_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x255*4)))
#define APC0_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x256*4)))
#define APC0_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(APC0_CSU_BASE+0x257*4)))
#define APC0_CSU_DMAADDRL11                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x258*4)))
#define APC0_CSU_DMAADDRH11                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x259*4)))
#define APC0_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x25A*4)))
#define APC0_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x25B*4)))
#define APC0_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x25C*4)))
#define APC0_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x25D*4)))
#define APC0_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x25E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(APC0_CSU_BASE+0x25F*4)))
#define APC0_CSU_DMAADDRL12                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x260*4)))
#define APC0_CSU_DMAADDRH12                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x261*4)))
#define APC0_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x262*4)))
#define APC0_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x263*4)))
#define APC0_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x264*4)))
#define APC0_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x265*4)))
#define APC0_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x266*4)))
#define APC0_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(APC0_CSU_BASE+0x267*4)))
#define APC0_CSU_DMAADDRL13                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x268*4)))
#define APC0_CSU_DMAADDRH13                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x269*4)))
#define APC0_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x26A*4)))
#define APC0_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x26B*4)))
#define APC0_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x26C*4)))
#define APC0_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x26D*4)))
#define APC0_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x26E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(APC0_CSU_BASE+0x26F*4)))
#define APC0_CSU_DMAADDRL14                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x270*4)))
#define APC0_CSU_DMAADDRH14                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x271*4)))
#define APC0_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x272*4)))
#define APC0_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x273*4)))
#define APC0_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x274*4)))
#define APC0_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x275*4)))
#define APC0_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x276*4)))
#define APC0_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(APC0_CSU_BASE+0x277*4)))
#define APC0_CSU_DMAADDRL15                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x278*4)))
#define APC0_CSU_DMAADDRH15                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x279*4)))
#define APC0_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x27A*4)))
#define APC0_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x27B*4)))
#define APC0_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x27C*4)))
#define APC0_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x27D*4)))
#define APC0_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x27E*4)))
#define APC0_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(APC0_CSU_BASE+0x27F*4)))
#define APC0_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(APC0_CSU_BASE+0x300*4)))
#define APC0_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x301*4)))
#define APC0_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(APC0_CSU_BASE+0x302*4)))
#define APC0_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(APC0_CSU_BASE+0x303*4)))
#define APC0_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x304*4)))
#define APC0_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x305*4)))
#define APC0_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x306*4)))
#define APC0_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(APC0_CSU_BASE+0x307*4)))
#define APC0_CSU_SPUID                            (*((volatile uint32_t *)(APC0_CSU_BASE+0x30B*4)))
#define APC0_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(APC0_CSU_BASE+0x310*4)))
#define APC0_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(APC0_CSU_BASE+0x311*4)))
#define APC0_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(APC0_CSU_BASE+0x312*4)))
#define APC0_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(APC0_CSU_BASE+0x313*4)))
#define APC0_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(APC0_CSU_BASE+0x314*4)))
#define APC0_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(APC0_CSU_BASE+0x315*4)))
#define APC0_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(APC0_CSU_BASE+0x316*4)))
#define APC0_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(APC0_CSU_BASE+0x317*4)))
#define APC0_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x380*4)))
#define APC0_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C0*4)))
#define APC0_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C1*4)))
#define APC0_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C2*4)))
#define APC0_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C3*4)))
#define APC0_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C4*4)))
#define APC0_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C5*4)))
#define APC0_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C6*4)))
#define APC0_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C7*4)))
#define APC0_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C8*4)))
#define APC0_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(APC0_CSU_BASE+0x3C9*4)))
#define APC0_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CA*4)))
#define APC0_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CB*4)))
#define APC0_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CC*4)))
#define APC0_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CD*4)))
#define APC0_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CE*4)))
#define APC0_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3CF*4)))
#define APC0_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D0*4)))
#define APC0_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D1*4)))
#define APC0_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D2*4)))
#define APC0_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D3*4)))
#define APC0_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D4*4)))
#define APC0_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D5*4)))
#define APC0_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D6*4)))
#define APC0_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D7*4)))
#define APC0_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D8*4)))
#define APC0_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3D9*4)))
#define APC0_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DA*4)))
#define APC0_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DB*4)))
#define APC0_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DC*4)))
#define APC0_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DD*4)))
#define APC0_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DE*4)))
#define APC0_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(APC0_CSU_BASE+0x3DF*4)))
#define APC0_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E0*4)))
#define APC0_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E1*4)))
#define APC0_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E2*4)))
#define APC0_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E3*4)))
#define APC0_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E4*4)))
#define APC0_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E5*4)))
#define APC0_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E6*4)))
#define APC0_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E7*4)))
#define APC0_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E8*4)))
#define APC0_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(APC0_CSU_BASE+0x3E9*4)))
#define APC0_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3EA*4)))
#define APC0_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3EB*4)))
#define APC0_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3EC*4)))
#define APC0_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3ED*4)))
#define APC0_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3EE*4)))
#define APC0_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3EF*4)))
#define APC0_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F0*4)))
#define APC0_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F1*4)))
#define APC0_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F2*4)))
#define APC0_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F3*4)))
#define APC0_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F4*4)))
#define APC0_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F5*4)))
#define APC0_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F6*4)))
#define APC0_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F7*4)))
#define APC0_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F8*4)))
#define APC0_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3F9*4)))
#define APC0_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FA*4)))
#define APC0_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FB*4)))
#define APC0_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FC*4)))
#define APC0_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FD*4)))
#define APC0_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FE*4)))
#define APC0_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(APC0_CSU_BASE+0x3FF*4)))


#define APC1_CSU_STARTSPU0                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x000*4)))
#define APC1_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x000*4)))
#define APC1_CSU_STARTSPU1                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x001*4)))
#define APC1_CSU_EVENTMASK                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x002*4)))
#define APC1_CSU_INTMASK                          (*((volatile uint32_t *)(APC1_CSU_BASE+0x004*4)))
#define APC1_CSU_ELEVELMASK                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x005*4)))
#define APC1_CSU_TAGMASK0                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x006*4)))
#define APC1_CSU_TAGMASK1                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x007*4)))
#define APC1_CSU_TAGMASK2                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x008*4)))
#define APC1_CSU_TAGMASK3                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x009*4)))
#define APC1_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x00A*4)))
#define APC1_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(APC1_CSU_BASE+0x00B*4)))
#define APC1_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x00C*4)))
#define APC1_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x00D*4)))
#define APC1_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(APC1_CSU_BASE+0x010*4)))
#define APC1_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(APC1_CSU_BASE+0x010*4)))
#define APC1_CSU_FINDDMATAG                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x014*4)))
#define APC1_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x018*4)))
#define APC1_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x019*4)))
#define APC1_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01A*4)))
#define APC1_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01B*4)))
#define APC1_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01C*4)))
#define APC1_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01D*4)))
#define APC1_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01E*4)))
#define APC1_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x01F*4)))
#define APC1_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x020*4)))
#define APC1_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x021*4)))
#define APC1_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x022*4)))
#define APC1_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x023*4)))
#define APC1_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(APC1_CSU_BASE+0x024*4)))
#define APC1_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(APC1_CSU_BASE+0x025*4)))
#define APC1_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(APC1_CSU_BASE+0x026*4)))
#define APC1_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(APC1_CSU_BASE+0x027*4)))
#define APC1_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x028*4)))
#define APC1_CSU_CMDFIFO0                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x02C*4)))
#define APC1_CSU_CMDFIFO1                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x02D*4)))
#define APC1_CSU_CMDFIFO2                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x02E*4)))
#define APC1_CSU_CMDFIFO3                         (*((volatile uint32_t *)(APC1_CSU_BASE+0x02F*4)))
#define APC1_CSU_READYLISTNUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x030*4)))
#define APC1_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x034*4)))
#define APC1_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x035*4)))
#define APC1_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x036*4)))
#define APC1_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x037*4)))
#define APC1_CSU_DMASTATUS                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x038*4)))
#define APC1_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(APC1_CSU_BASE+0x039*4)))
#define APC1_CSU_QOUSTATUS                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x03A*4)))
#define APC1_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x03C*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(APC1_CSU_BASE+0x100*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(APC1_CSU_BASE+0x101*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(APC1_CSU_BASE+0x102*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(APC1_CSU_BASE+0x103*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(APC1_CSU_BASE+0x104*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(APC1_CSU_BASE+0x105*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(APC1_CSU_BASE+0x106*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(APC1_CSU_BASE+0x107*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(APC1_CSU_BASE+0x108*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(APC1_CSU_BASE+0x109*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10A*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10B*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10C*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10D*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10E*4)))
#define APC1_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(APC1_CSU_BASE+0x10F*4)))
#define APC1_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x120*4)))
#define APC1_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x121*4)))
#define APC1_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x122*4)))
#define APC1_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x124*4)))
#define APC1_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x125*4)))
#define APC1_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x126*4)))
#define APC1_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x127*4)))
#define APC1_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(APC1_CSU_BASE+0x130*4)))
#define APC1_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(APC1_CSU_BASE+0x131*4)))
#define APC1_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x180*4)))
#define APC1_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x181*4)))
#define APC1_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x182*4)))
#define APC1_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x183*4)))
#define APC1_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x184*4)))
#define APC1_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x185*4)))
#define APC1_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x186*4)))
#define APC1_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x187*4)))
#define APC1_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x188*4)))
#define APC1_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x189*4)))
#define APC1_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18A*4)))
#define APC1_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18B*4)))
#define APC1_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18C*4)))
#define APC1_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18D*4)))
#define APC1_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18E*4)))
#define APC1_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x18F*4)))
#define APC1_CSU_DMAADDRL0                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x200*4)))
#define APC1_CSU_DMAADDRH0                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x201*4)))
#define APC1_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x202*4)))
#define APC1_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x203*4)))
#define APC1_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x204*4)))
#define APC1_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x205*4)))
#define APC1_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x206*4)))
#define APC1_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(APC1_CSU_BASE+0x207*4)))
#define APC1_CSU_DMAADDRL1                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x208*4)))
#define APC1_CSU_DMAADDRH1                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x209*4)))
#define APC1_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x20A*4)))
#define APC1_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x20B*4)))
#define APC1_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x20C*4)))
#define APC1_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x20D*4)))
#define APC1_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x20E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(APC1_CSU_BASE+0x20F*4)))
#define APC1_CSU_DMAADDRL2                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x210*4)))
#define APC1_CSU_DMAADDRH2                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x211*4)))
#define APC1_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x212*4)))
#define APC1_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x213*4)))
#define APC1_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x214*4)))
#define APC1_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x215*4)))
#define APC1_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x216*4)))
#define APC1_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(APC1_CSU_BASE+0x217*4)))
#define APC1_CSU_DMAADDRL3                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x218*4)))
#define APC1_CSU_DMAADDRH3                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x219*4)))
#define APC1_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x21A*4)))
#define APC1_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x21B*4)))
#define APC1_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x21C*4)))
#define APC1_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x21D*4)))
#define APC1_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x21E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(APC1_CSU_BASE+0x21F*4)))
#define APC1_CSU_DMAADDRL4                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x220*4)))
#define APC1_CSU_DMAADDRH4                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x221*4)))
#define APC1_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x222*4)))
#define APC1_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x223*4)))
#define APC1_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x224*4)))
#define APC1_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x225*4)))
#define APC1_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x226*4)))
#define APC1_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(APC1_CSU_BASE+0x227*4)))
#define APC1_CSU_DMAADDRL5                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x228*4)))
#define APC1_CSU_DMAADDRH5                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x229*4)))
#define APC1_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x22A*4)))
#define APC1_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x22B*4)))
#define APC1_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x22C*4)))
#define APC1_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x22D*4)))
#define APC1_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x22E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(APC1_CSU_BASE+0x22F*4)))
#define APC1_CSU_DMAADDRL6                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x230*4)))
#define APC1_CSU_DMAADDRH6                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x231*4)))
#define APC1_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x232*4)))
#define APC1_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x233*4)))
#define APC1_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x234*4)))
#define APC1_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x235*4)))
#define APC1_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x236*4)))
#define APC1_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(APC1_CSU_BASE+0x237*4)))
#define APC1_CSU_DMAADDRL7                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x238*4)))
#define APC1_CSU_DMAADDRH7                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x239*4)))
#define APC1_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x23A*4)))
#define APC1_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x23B*4)))
#define APC1_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x23C*4)))
#define APC1_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x23D*4)))
#define APC1_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x23E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(APC1_CSU_BASE+0x23F*4)))
#define APC1_CSU_DMAADDRL8                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x240*4)))
#define APC1_CSU_DMAADDRH8                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x241*4)))
#define APC1_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x242*4)))
#define APC1_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x243*4)))
#define APC1_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x244*4)))
#define APC1_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x245*4)))
#define APC1_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x246*4)))
#define APC1_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(APC1_CSU_BASE+0x247*4)))
#define APC1_CSU_DMAADDRL9                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x248*4)))
#define APC1_CSU_DMAADDRH9                        (*((volatile uint32_t *)(APC1_CSU_BASE+0x249*4)))
#define APC1_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x24A*4)))
#define APC1_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x24B*4)))
#define APC1_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x24C*4)))
#define APC1_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x24D*4)))
#define APC1_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x24E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(APC1_CSU_BASE+0x24F*4)))
#define APC1_CSU_DMAADDRL10                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x250*4)))
#define APC1_CSU_DMAADDRH10                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x251*4)))
#define APC1_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x252*4)))
#define APC1_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x253*4)))
#define APC1_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x254*4)))
#define APC1_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x255*4)))
#define APC1_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x256*4)))
#define APC1_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(APC1_CSU_BASE+0x257*4)))
#define APC1_CSU_DMAADDRL11                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x258*4)))
#define APC1_CSU_DMAADDRH11                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x259*4)))
#define APC1_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x25A*4)))
#define APC1_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x25B*4)))
#define APC1_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x25C*4)))
#define APC1_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x25D*4)))
#define APC1_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x25E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(APC1_CSU_BASE+0x25F*4)))
#define APC1_CSU_DMAADDRL12                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x260*4)))
#define APC1_CSU_DMAADDRH12                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x261*4)))
#define APC1_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x262*4)))
#define APC1_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x263*4)))
#define APC1_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x264*4)))
#define APC1_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x265*4)))
#define APC1_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x266*4)))
#define APC1_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(APC1_CSU_BASE+0x267*4)))
#define APC1_CSU_DMAADDRL13                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x268*4)))
#define APC1_CSU_DMAADDRH13                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x269*4)))
#define APC1_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x26A*4)))
#define APC1_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x26B*4)))
#define APC1_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x26C*4)))
#define APC1_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x26D*4)))
#define APC1_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x26E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(APC1_CSU_BASE+0x26F*4)))
#define APC1_CSU_DMAADDRL14                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x270*4)))
#define APC1_CSU_DMAADDRH14                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x271*4)))
#define APC1_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x272*4)))
#define APC1_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x273*4)))
#define APC1_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x274*4)))
#define APC1_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x275*4)))
#define APC1_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x276*4)))
#define APC1_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(APC1_CSU_BASE+0x277*4)))
#define APC1_CSU_DMAADDRL15                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x278*4)))
#define APC1_CSU_DMAADDRH15                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x279*4)))
#define APC1_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x27A*4)))
#define APC1_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x27B*4)))
#define APC1_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x27C*4)))
#define APC1_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x27D*4)))
#define APC1_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x27E*4)))
#define APC1_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(APC1_CSU_BASE+0x27F*4)))
#define APC1_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(APC1_CSU_BASE+0x300*4)))
#define APC1_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x301*4)))
#define APC1_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(APC1_CSU_BASE+0x302*4)))
#define APC1_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(APC1_CSU_BASE+0x303*4)))
#define APC1_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x304*4)))
#define APC1_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x305*4)))
#define APC1_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x306*4)))
#define APC1_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(APC1_CSU_BASE+0x307*4)))
#define APC1_CSU_SPUID                            (*((volatile uint32_t *)(APC1_CSU_BASE+0x30B*4)))
#define APC1_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(APC1_CSU_BASE+0x310*4)))
#define APC1_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(APC1_CSU_BASE+0x311*4)))
#define APC1_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(APC1_CSU_BASE+0x312*4)))
#define APC1_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(APC1_CSU_BASE+0x313*4)))
#define APC1_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(APC1_CSU_BASE+0x314*4)))
#define APC1_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(APC1_CSU_BASE+0x315*4)))
#define APC1_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(APC1_CSU_BASE+0x316*4)))
#define APC1_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(APC1_CSU_BASE+0x317*4)))
#define APC1_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x380*4)))
#define APC1_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C0*4)))
#define APC1_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C1*4)))
#define APC1_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C2*4)))
#define APC1_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C3*4)))
#define APC1_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C4*4)))
#define APC1_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C5*4)))
#define APC1_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C6*4)))
#define APC1_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C7*4)))
#define APC1_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C8*4)))
#define APC1_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(APC1_CSU_BASE+0x3C9*4)))
#define APC1_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CA*4)))
#define APC1_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CB*4)))
#define APC1_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CC*4)))
#define APC1_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CD*4)))
#define APC1_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CE*4)))
#define APC1_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3CF*4)))
#define APC1_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D0*4)))
#define APC1_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D1*4)))
#define APC1_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D2*4)))
#define APC1_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D3*4)))
#define APC1_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D4*4)))
#define APC1_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D5*4)))
#define APC1_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D6*4)))
#define APC1_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D7*4)))
#define APC1_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D8*4)))
#define APC1_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3D9*4)))
#define APC1_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DA*4)))
#define APC1_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DB*4)))
#define APC1_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DC*4)))
#define APC1_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DD*4)))
#define APC1_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DE*4)))
#define APC1_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(APC1_CSU_BASE+0x3DF*4)))
#define APC1_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E0*4)))
#define APC1_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E1*4)))
#define APC1_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E2*4)))
#define APC1_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E3*4)))
#define APC1_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E4*4)))
#define APC1_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E5*4)))
#define APC1_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E6*4)))
#define APC1_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E7*4)))
#define APC1_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E8*4)))
#define APC1_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(APC1_CSU_BASE+0x3E9*4)))
#define APC1_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3EA*4)))
#define APC1_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3EB*4)))
#define APC1_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3EC*4)))
#define APC1_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3ED*4)))
#define APC1_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3EE*4)))
#define APC1_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3EF*4)))
#define APC1_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F0*4)))
#define APC1_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F1*4)))
#define APC1_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F2*4)))
#define APC1_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F3*4)))
#define APC1_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F4*4)))
#define APC1_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F5*4)))
#define APC1_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F6*4)))
#define APC1_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F7*4)))
#define APC1_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F8*4)))
#define APC1_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3F9*4)))
#define APC1_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FA*4)))
#define APC1_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FB*4)))
#define APC1_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FC*4)))
#define APC1_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FD*4)))
#define APC1_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FE*4)))
#define APC1_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(APC1_CSU_BASE+0x3FF*4)))


#define APC2_CSU_STARTSPU0                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x000*4)))
#define APC2_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x000*4)))
#define APC2_CSU_STARTSPU1                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x001*4)))
#define APC2_CSU_EVENTMASK                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x002*4)))
#define APC2_CSU_INTMASK                          (*((volatile uint32_t *)(APC2_CSU_BASE+0x004*4)))
#define APC2_CSU_ELEVELMASK                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x005*4)))
#define APC2_CSU_TAGMASK0                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x006*4)))
#define APC2_CSU_TAGMASK1                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x007*4)))
#define APC2_CSU_TAGMASK2                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x008*4)))
#define APC2_CSU_TAGMASK3                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x009*4)))
#define APC2_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x00A*4)))
#define APC2_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(APC2_CSU_BASE+0x00B*4)))
#define APC2_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x00C*4)))
#define APC2_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x00D*4)))
#define APC2_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(APC2_CSU_BASE+0x010*4)))
#define APC2_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(APC2_CSU_BASE+0x010*4)))
#define APC2_CSU_FINDDMATAG                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x014*4)))
#define APC2_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x018*4)))
#define APC2_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x019*4)))
#define APC2_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01A*4)))
#define APC2_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01B*4)))
#define APC2_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01C*4)))
#define APC2_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01D*4)))
#define APC2_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01E*4)))
#define APC2_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x01F*4)))
#define APC2_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x020*4)))
#define APC2_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x021*4)))
#define APC2_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x022*4)))
#define APC2_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x023*4)))
#define APC2_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(APC2_CSU_BASE+0x024*4)))
#define APC2_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(APC2_CSU_BASE+0x025*4)))
#define APC2_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(APC2_CSU_BASE+0x026*4)))
#define APC2_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(APC2_CSU_BASE+0x027*4)))
#define APC2_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x028*4)))
#define APC2_CSU_CMDFIFO0                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x02C*4)))
#define APC2_CSU_CMDFIFO1                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x02D*4)))
#define APC2_CSU_CMDFIFO2                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x02E*4)))
#define APC2_CSU_CMDFIFO3                         (*((volatile uint32_t *)(APC2_CSU_BASE+0x02F*4)))
#define APC2_CSU_READYLISTNUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x030*4)))
#define APC2_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x034*4)))
#define APC2_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x035*4)))
#define APC2_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x036*4)))
#define APC2_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x037*4)))
#define APC2_CSU_DMASTATUS                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x038*4)))
#define APC2_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(APC2_CSU_BASE+0x039*4)))
#define APC2_CSU_QOUSTATUS                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x03A*4)))
#define APC2_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x03C*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(APC2_CSU_BASE+0x100*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(APC2_CSU_BASE+0x101*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(APC2_CSU_BASE+0x102*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(APC2_CSU_BASE+0x103*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(APC2_CSU_BASE+0x104*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(APC2_CSU_BASE+0x105*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(APC2_CSU_BASE+0x106*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(APC2_CSU_BASE+0x107*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(APC2_CSU_BASE+0x108*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(APC2_CSU_BASE+0x109*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10A*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10B*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10C*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10D*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10E*4)))
#define APC2_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(APC2_CSU_BASE+0x10F*4)))
#define APC2_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x120*4)))
#define APC2_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x121*4)))
#define APC2_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x122*4)))
#define APC2_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x124*4)))
#define APC2_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x125*4)))
#define APC2_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x126*4)))
#define APC2_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x127*4)))
#define APC2_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(APC2_CSU_BASE+0x130*4)))
#define APC2_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(APC2_CSU_BASE+0x131*4)))
#define APC2_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x180*4)))
#define APC2_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x181*4)))
#define APC2_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x182*4)))
#define APC2_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x183*4)))
#define APC2_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x184*4)))
#define APC2_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x185*4)))
#define APC2_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x186*4)))
#define APC2_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x187*4)))
#define APC2_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x188*4)))
#define APC2_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x189*4)))
#define APC2_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18A*4)))
#define APC2_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18B*4)))
#define APC2_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18C*4)))
#define APC2_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18D*4)))
#define APC2_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18E*4)))
#define APC2_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x18F*4)))
#define APC2_CSU_DMAADDRL0                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x200*4)))
#define APC2_CSU_DMAADDRH0                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x201*4)))
#define APC2_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x202*4)))
#define APC2_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x203*4)))
#define APC2_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x204*4)))
#define APC2_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x205*4)))
#define APC2_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x206*4)))
#define APC2_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(APC2_CSU_BASE+0x207*4)))
#define APC2_CSU_DMAADDRL1                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x208*4)))
#define APC2_CSU_DMAADDRH1                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x209*4)))
#define APC2_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x20A*4)))
#define APC2_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x20B*4)))
#define APC2_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x20C*4)))
#define APC2_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x20D*4)))
#define APC2_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x20E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(APC2_CSU_BASE+0x20F*4)))
#define APC2_CSU_DMAADDRL2                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x210*4)))
#define APC2_CSU_DMAADDRH2                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x211*4)))
#define APC2_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x212*4)))
#define APC2_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x213*4)))
#define APC2_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x214*4)))
#define APC2_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x215*4)))
#define APC2_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x216*4)))
#define APC2_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(APC2_CSU_BASE+0x217*4)))
#define APC2_CSU_DMAADDRL3                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x218*4)))
#define APC2_CSU_DMAADDRH3                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x219*4)))
#define APC2_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x21A*4)))
#define APC2_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x21B*4)))
#define APC2_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x21C*4)))
#define APC2_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x21D*4)))
#define APC2_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x21E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(APC2_CSU_BASE+0x21F*4)))
#define APC2_CSU_DMAADDRL4                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x220*4)))
#define APC2_CSU_DMAADDRH4                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x221*4)))
#define APC2_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x222*4)))
#define APC2_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x223*4)))
#define APC2_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x224*4)))
#define APC2_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x225*4)))
#define APC2_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x226*4)))
#define APC2_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(APC2_CSU_BASE+0x227*4)))
#define APC2_CSU_DMAADDRL5                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x228*4)))
#define APC2_CSU_DMAADDRH5                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x229*4)))
#define APC2_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x22A*4)))
#define APC2_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x22B*4)))
#define APC2_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x22C*4)))
#define APC2_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x22D*4)))
#define APC2_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x22E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(APC2_CSU_BASE+0x22F*4)))
#define APC2_CSU_DMAADDRL6                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x230*4)))
#define APC2_CSU_DMAADDRH6                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x231*4)))
#define APC2_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x232*4)))
#define APC2_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x233*4)))
#define APC2_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x234*4)))
#define APC2_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x235*4)))
#define APC2_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x236*4)))
#define APC2_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(APC2_CSU_BASE+0x237*4)))
#define APC2_CSU_DMAADDRL7                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x238*4)))
#define APC2_CSU_DMAADDRH7                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x239*4)))
#define APC2_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x23A*4)))
#define APC2_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x23B*4)))
#define APC2_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x23C*4)))
#define APC2_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x23D*4)))
#define APC2_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x23E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(APC2_CSU_BASE+0x23F*4)))
#define APC2_CSU_DMAADDRL8                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x240*4)))
#define APC2_CSU_DMAADDRH8                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x241*4)))
#define APC2_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x242*4)))
#define APC2_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x243*4)))
#define APC2_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x244*4)))
#define APC2_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x245*4)))
#define APC2_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x246*4)))
#define APC2_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(APC2_CSU_BASE+0x247*4)))
#define APC2_CSU_DMAADDRL9                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x248*4)))
#define APC2_CSU_DMAADDRH9                        (*((volatile uint32_t *)(APC2_CSU_BASE+0x249*4)))
#define APC2_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x24A*4)))
#define APC2_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x24B*4)))
#define APC2_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x24C*4)))
#define APC2_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x24D*4)))
#define APC2_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x24E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(APC2_CSU_BASE+0x24F*4)))
#define APC2_CSU_DMAADDRL10                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x250*4)))
#define APC2_CSU_DMAADDRH10                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x251*4)))
#define APC2_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x252*4)))
#define APC2_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x253*4)))
#define APC2_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x254*4)))
#define APC2_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x255*4)))
#define APC2_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x256*4)))
#define APC2_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(APC2_CSU_BASE+0x257*4)))
#define APC2_CSU_DMAADDRL11                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x258*4)))
#define APC2_CSU_DMAADDRH11                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x259*4)))
#define APC2_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x25A*4)))
#define APC2_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x25B*4)))
#define APC2_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x25C*4)))
#define APC2_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x25D*4)))
#define APC2_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x25E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(APC2_CSU_BASE+0x25F*4)))
#define APC2_CSU_DMAADDRL12                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x260*4)))
#define APC2_CSU_DMAADDRH12                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x261*4)))
#define APC2_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x262*4)))
#define APC2_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x263*4)))
#define APC2_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x264*4)))
#define APC2_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x265*4)))
#define APC2_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x266*4)))
#define APC2_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(APC2_CSU_BASE+0x267*4)))
#define APC2_CSU_DMAADDRL13                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x268*4)))
#define APC2_CSU_DMAADDRH13                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x269*4)))
#define APC2_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x26A*4)))
#define APC2_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x26B*4)))
#define APC2_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x26C*4)))
#define APC2_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x26D*4)))
#define APC2_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x26E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(APC2_CSU_BASE+0x26F*4)))
#define APC2_CSU_DMAADDRL14                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x270*4)))
#define APC2_CSU_DMAADDRH14                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x271*4)))
#define APC2_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x272*4)))
#define APC2_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x273*4)))
#define APC2_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x274*4)))
#define APC2_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x275*4)))
#define APC2_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x276*4)))
#define APC2_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(APC2_CSU_BASE+0x277*4)))
#define APC2_CSU_DMAADDRL15                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x278*4)))
#define APC2_CSU_DMAADDRH15                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x279*4)))
#define APC2_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x27A*4)))
#define APC2_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x27B*4)))
#define APC2_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x27C*4)))
#define APC2_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x27D*4)))
#define APC2_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x27E*4)))
#define APC2_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(APC2_CSU_BASE+0x27F*4)))
#define APC2_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(APC2_CSU_BASE+0x300*4)))
#define APC2_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x301*4)))
#define APC2_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(APC2_CSU_BASE+0x302*4)))
#define APC2_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(APC2_CSU_BASE+0x303*4)))
#define APC2_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x304*4)))
#define APC2_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x305*4)))
#define APC2_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x306*4)))
#define APC2_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(APC2_CSU_BASE+0x307*4)))
#define APC2_CSU_SPUID                            (*((volatile uint32_t *)(APC2_CSU_BASE+0x30B*4)))
#define APC2_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(APC2_CSU_BASE+0x310*4)))
#define APC2_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(APC2_CSU_BASE+0x311*4)))
#define APC2_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(APC2_CSU_BASE+0x312*4)))
#define APC2_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(APC2_CSU_BASE+0x313*4)))
#define APC2_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(APC2_CSU_BASE+0x314*4)))
#define APC2_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(APC2_CSU_BASE+0x315*4)))
#define APC2_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(APC2_CSU_BASE+0x316*4)))
#define APC2_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(APC2_CSU_BASE+0x317*4)))
#define APC2_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x380*4)))
#define APC2_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C0*4)))
#define APC2_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C1*4)))
#define APC2_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C2*4)))
#define APC2_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C3*4)))
#define APC2_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C4*4)))
#define APC2_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C5*4)))
#define APC2_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C6*4)))
#define APC2_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C7*4)))
#define APC2_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C8*4)))
#define APC2_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(APC2_CSU_BASE+0x3C9*4)))
#define APC2_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CA*4)))
#define APC2_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CB*4)))
#define APC2_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CC*4)))
#define APC2_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CD*4)))
#define APC2_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CE*4)))
#define APC2_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3CF*4)))
#define APC2_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D0*4)))
#define APC2_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D1*4)))
#define APC2_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D2*4)))
#define APC2_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D3*4)))
#define APC2_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D4*4)))
#define APC2_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D5*4)))
#define APC2_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D6*4)))
#define APC2_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D7*4)))
#define APC2_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D8*4)))
#define APC2_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3D9*4)))
#define APC2_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DA*4)))
#define APC2_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DB*4)))
#define APC2_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DC*4)))
#define APC2_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DD*4)))
#define APC2_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DE*4)))
#define APC2_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(APC2_CSU_BASE+0x3DF*4)))
#define APC2_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E0*4)))
#define APC2_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E1*4)))
#define APC2_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E2*4)))
#define APC2_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E3*4)))
#define APC2_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E4*4)))
#define APC2_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E5*4)))
#define APC2_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E6*4)))
#define APC2_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E7*4)))
#define APC2_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E8*4)))
#define APC2_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(APC2_CSU_BASE+0x3E9*4)))
#define APC2_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3EA*4)))
#define APC2_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3EB*4)))
#define APC2_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3EC*4)))
#define APC2_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3ED*4)))
#define APC2_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3EE*4)))
#define APC2_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3EF*4)))
#define APC2_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F0*4)))
#define APC2_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F1*4)))
#define APC2_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F2*4)))
#define APC2_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F3*4)))
#define APC2_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F4*4)))
#define APC2_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F5*4)))
#define APC2_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F6*4)))
#define APC2_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F7*4)))
#define APC2_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F8*4)))
#define APC2_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3F9*4)))
#define APC2_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FA*4)))
#define APC2_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FB*4)))
#define APC2_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FC*4)))
#define APC2_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FD*4)))
#define APC2_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FE*4)))
#define APC2_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(APC2_CSU_BASE+0x3FF*4)))


#define APC3_CSU_STARTSPU0                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x000*4)))
#define APC3_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x000*4)))
#define APC3_CSU_STARTSPU1                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x001*4)))
#define APC3_CSU_EVENTMASK                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x002*4)))
#define APC3_CSU_INTMASK                          (*((volatile uint32_t *)(APC3_CSU_BASE+0x004*4)))
#define APC3_CSU_ELEVELMASK                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x005*4)))
#define APC3_CSU_TAGMASK0                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x006*4)))
#define APC3_CSU_TAGMASK1                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x007*4)))
#define APC3_CSU_TAGMASK2                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x008*4)))
#define APC3_CSU_TAGMASK3                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x009*4)))
#define APC3_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x00A*4)))
#define APC3_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(APC3_CSU_BASE+0x00B*4)))
#define APC3_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x00C*4)))
#define APC3_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x00D*4)))
#define APC3_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(APC3_CSU_BASE+0x010*4)))
#define APC3_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(APC3_CSU_BASE+0x010*4)))
#define APC3_CSU_FINDDMATAG                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x014*4)))
#define APC3_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x018*4)))
#define APC3_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x019*4)))
#define APC3_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01A*4)))
#define APC3_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01B*4)))
#define APC3_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01C*4)))
#define APC3_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01D*4)))
#define APC3_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01E*4)))
#define APC3_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x01F*4)))
#define APC3_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x020*4)))
#define APC3_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x021*4)))
#define APC3_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x022*4)))
#define APC3_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x023*4)))
#define APC3_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(APC3_CSU_BASE+0x024*4)))
#define APC3_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(APC3_CSU_BASE+0x025*4)))
#define APC3_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(APC3_CSU_BASE+0x026*4)))
#define APC3_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(APC3_CSU_BASE+0x027*4)))
#define APC3_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x028*4)))
#define APC3_CSU_CMDFIFO0                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x02C*4)))
#define APC3_CSU_CMDFIFO1                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x02D*4)))
#define APC3_CSU_CMDFIFO2                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x02E*4)))
#define APC3_CSU_CMDFIFO3                         (*((volatile uint32_t *)(APC3_CSU_BASE+0x02F*4)))
#define APC3_CSU_READYLISTNUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x030*4)))
#define APC3_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x034*4)))
#define APC3_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x035*4)))
#define APC3_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x036*4)))
#define APC3_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x037*4)))
#define APC3_CSU_DMASTATUS                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x038*4)))
#define APC3_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(APC3_CSU_BASE+0x039*4)))
#define APC3_CSU_QOUSTATUS                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x03A*4)))
#define APC3_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x03C*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(APC3_CSU_BASE+0x100*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(APC3_CSU_BASE+0x101*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(APC3_CSU_BASE+0x102*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(APC3_CSU_BASE+0x103*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(APC3_CSU_BASE+0x104*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(APC3_CSU_BASE+0x105*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(APC3_CSU_BASE+0x106*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(APC3_CSU_BASE+0x107*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(APC3_CSU_BASE+0x108*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(APC3_CSU_BASE+0x109*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10A*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10B*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10C*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10D*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10E*4)))
#define APC3_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(APC3_CSU_BASE+0x10F*4)))
#define APC3_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x120*4)))
#define APC3_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x121*4)))
#define APC3_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x122*4)))
#define APC3_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x124*4)))
#define APC3_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x125*4)))
#define APC3_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x126*4)))
#define APC3_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x127*4)))
#define APC3_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(APC3_CSU_BASE+0x130*4)))
#define APC3_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(APC3_CSU_BASE+0x131*4)))
#define APC3_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x180*4)))
#define APC3_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x181*4)))
#define APC3_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x182*4)))
#define APC3_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x183*4)))
#define APC3_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x184*4)))
#define APC3_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x185*4)))
#define APC3_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x186*4)))
#define APC3_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x187*4)))
#define APC3_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x188*4)))
#define APC3_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x189*4)))
#define APC3_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18A*4)))
#define APC3_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18B*4)))
#define APC3_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18C*4)))
#define APC3_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18D*4)))
#define APC3_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18E*4)))
#define APC3_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x18F*4)))
#define APC3_CSU_DMAADDRL0                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x200*4)))
#define APC3_CSU_DMAADDRH0                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x201*4)))
#define APC3_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x202*4)))
#define APC3_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x203*4)))
#define APC3_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x204*4)))
#define APC3_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x205*4)))
#define APC3_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x206*4)))
#define APC3_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(APC3_CSU_BASE+0x207*4)))
#define APC3_CSU_DMAADDRL1                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x208*4)))
#define APC3_CSU_DMAADDRH1                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x209*4)))
#define APC3_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x20A*4)))
#define APC3_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x20B*4)))
#define APC3_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x20C*4)))
#define APC3_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x20D*4)))
#define APC3_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x20E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(APC3_CSU_BASE+0x20F*4)))
#define APC3_CSU_DMAADDRL2                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x210*4)))
#define APC3_CSU_DMAADDRH2                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x211*4)))
#define APC3_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x212*4)))
#define APC3_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x213*4)))
#define APC3_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x214*4)))
#define APC3_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x215*4)))
#define APC3_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x216*4)))
#define APC3_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(APC3_CSU_BASE+0x217*4)))
#define APC3_CSU_DMAADDRL3                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x218*4)))
#define APC3_CSU_DMAADDRH3                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x219*4)))
#define APC3_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x21A*4)))
#define APC3_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x21B*4)))
#define APC3_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x21C*4)))
#define APC3_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x21D*4)))
#define APC3_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x21E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(APC3_CSU_BASE+0x21F*4)))
#define APC3_CSU_DMAADDRL4                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x220*4)))
#define APC3_CSU_DMAADDRH4                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x221*4)))
#define APC3_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x222*4)))
#define APC3_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x223*4)))
#define APC3_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x224*4)))
#define APC3_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x225*4)))
#define APC3_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x226*4)))
#define APC3_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(APC3_CSU_BASE+0x227*4)))
#define APC3_CSU_DMAADDRL5                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x228*4)))
#define APC3_CSU_DMAADDRH5                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x229*4)))
#define APC3_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x22A*4)))
#define APC3_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x22B*4)))
#define APC3_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x22C*4)))
#define APC3_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x22D*4)))
#define APC3_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x22E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(APC3_CSU_BASE+0x22F*4)))
#define APC3_CSU_DMAADDRL6                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x230*4)))
#define APC3_CSU_DMAADDRH6                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x231*4)))
#define APC3_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x232*4)))
#define APC3_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x233*4)))
#define APC3_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x234*4)))
#define APC3_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x235*4)))
#define APC3_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x236*4)))
#define APC3_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(APC3_CSU_BASE+0x237*4)))
#define APC3_CSU_DMAADDRL7                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x238*4)))
#define APC3_CSU_DMAADDRH7                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x239*4)))
#define APC3_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x23A*4)))
#define APC3_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x23B*4)))
#define APC3_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x23C*4)))
#define APC3_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x23D*4)))
#define APC3_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x23E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(APC3_CSU_BASE+0x23F*4)))
#define APC3_CSU_DMAADDRL8                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x240*4)))
#define APC3_CSU_DMAADDRH8                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x241*4)))
#define APC3_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x242*4)))
#define APC3_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x243*4)))
#define APC3_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x244*4)))
#define APC3_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x245*4)))
#define APC3_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x246*4)))
#define APC3_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(APC3_CSU_BASE+0x247*4)))
#define APC3_CSU_DMAADDRL9                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x248*4)))
#define APC3_CSU_DMAADDRH9                        (*((volatile uint32_t *)(APC3_CSU_BASE+0x249*4)))
#define APC3_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x24A*4)))
#define APC3_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x24B*4)))
#define APC3_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x24C*4)))
#define APC3_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x24D*4)))
#define APC3_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x24E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(APC3_CSU_BASE+0x24F*4)))
#define APC3_CSU_DMAADDRL10                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x250*4)))
#define APC3_CSU_DMAADDRH10                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x251*4)))
#define APC3_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x252*4)))
#define APC3_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x253*4)))
#define APC3_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x254*4)))
#define APC3_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x255*4)))
#define APC3_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x256*4)))
#define APC3_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(APC3_CSU_BASE+0x257*4)))
#define APC3_CSU_DMAADDRL11                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x258*4)))
#define APC3_CSU_DMAADDRH11                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x259*4)))
#define APC3_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x25A*4)))
#define APC3_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x25B*4)))
#define APC3_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x25C*4)))
#define APC3_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x25D*4)))
#define APC3_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x25E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(APC3_CSU_BASE+0x25F*4)))
#define APC3_CSU_DMAADDRL12                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x260*4)))
#define APC3_CSU_DMAADDRH12                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x261*4)))
#define APC3_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x262*4)))
#define APC3_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x263*4)))
#define APC3_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x264*4)))
#define APC3_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x265*4)))
#define APC3_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x266*4)))
#define APC3_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(APC3_CSU_BASE+0x267*4)))
#define APC3_CSU_DMAADDRL13                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x268*4)))
#define APC3_CSU_DMAADDRH13                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x269*4)))
#define APC3_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x26A*4)))
#define APC3_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x26B*4)))
#define APC3_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x26C*4)))
#define APC3_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x26D*4)))
#define APC3_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x26E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(APC3_CSU_BASE+0x26F*4)))
#define APC3_CSU_DMAADDRL14                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x270*4)))
#define APC3_CSU_DMAADDRH14                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x271*4)))
#define APC3_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x272*4)))
#define APC3_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x273*4)))
#define APC3_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x274*4)))
#define APC3_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x275*4)))
#define APC3_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x276*4)))
#define APC3_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(APC3_CSU_BASE+0x277*4)))
#define APC3_CSU_DMAADDRL15                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x278*4)))
#define APC3_CSU_DMAADDRH15                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x279*4)))
#define APC3_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x27A*4)))
#define APC3_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x27B*4)))
#define APC3_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x27C*4)))
#define APC3_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x27D*4)))
#define APC3_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x27E*4)))
#define APC3_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(APC3_CSU_BASE+0x27F*4)))
#define APC3_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(APC3_CSU_BASE+0x300*4)))
#define APC3_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x301*4)))
#define APC3_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(APC3_CSU_BASE+0x302*4)))
#define APC3_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(APC3_CSU_BASE+0x303*4)))
#define APC3_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x304*4)))
#define APC3_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x305*4)))
#define APC3_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x306*4)))
#define APC3_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(APC3_CSU_BASE+0x307*4)))
#define APC3_CSU_SPUID                            (*((volatile uint32_t *)(APC3_CSU_BASE+0x30B*4)))
#define APC3_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(APC3_CSU_BASE+0x310*4)))
#define APC3_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(APC3_CSU_BASE+0x311*4)))
#define APC3_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(APC3_CSU_BASE+0x312*4)))
#define APC3_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(APC3_CSU_BASE+0x313*4)))
#define APC3_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(APC3_CSU_BASE+0x314*4)))
#define APC3_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(APC3_CSU_BASE+0x315*4)))
#define APC3_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(APC3_CSU_BASE+0x316*4)))
#define APC3_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(APC3_CSU_BASE+0x317*4)))
#define APC3_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x380*4)))
#define APC3_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C0*4)))
#define APC3_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C1*4)))
#define APC3_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C2*4)))
#define APC3_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C3*4)))
#define APC3_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C4*4)))
#define APC3_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C5*4)))
#define APC3_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C6*4)))
#define APC3_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C7*4)))
#define APC3_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C8*4)))
#define APC3_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(APC3_CSU_BASE+0x3C9*4)))
#define APC3_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CA*4)))
#define APC3_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CB*4)))
#define APC3_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CC*4)))
#define APC3_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CD*4)))
#define APC3_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CE*4)))
#define APC3_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3CF*4)))
#define APC3_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D0*4)))
#define APC3_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D1*4)))
#define APC3_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D2*4)))
#define APC3_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D3*4)))
#define APC3_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D4*4)))
#define APC3_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D5*4)))
#define APC3_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D6*4)))
#define APC3_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D7*4)))
#define APC3_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D8*4)))
#define APC3_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3D9*4)))
#define APC3_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DA*4)))
#define APC3_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DB*4)))
#define APC3_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DC*4)))
#define APC3_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DD*4)))
#define APC3_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DE*4)))
#define APC3_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(APC3_CSU_BASE+0x3DF*4)))
#define APC3_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E0*4)))
#define APC3_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E1*4)))
#define APC3_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E2*4)))
#define APC3_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E3*4)))
#define APC3_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E4*4)))
#define APC3_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E5*4)))
#define APC3_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E6*4)))
#define APC3_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E7*4)))
#define APC3_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E8*4)))
#define APC3_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(APC3_CSU_BASE+0x3E9*4)))
#define APC3_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3EA*4)))
#define APC3_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3EB*4)))
#define APC3_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3EC*4)))
#define APC3_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3ED*4)))
#define APC3_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3EE*4)))
#define APC3_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3EF*4)))
#define APC3_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F0*4)))
#define APC3_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F1*4)))
#define APC3_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F2*4)))
#define APC3_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F3*4)))
#define APC3_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F4*4)))
#define APC3_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F5*4)))
#define APC3_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F6*4)))
#define APC3_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F7*4)))
#define APC3_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F8*4)))
#define APC3_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3F9*4)))
#define APC3_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FA*4)))
#define APC3_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FB*4)))
#define APC3_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FC*4)))
#define APC3_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FD*4)))
#define APC3_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FE*4)))
#define APC3_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(APC3_CSU_BASE+0x3FF*4)))


#define ECSRFM_CSU_STARTSPU0                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x000*4)))
#define ECSRFM_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x000*4)))
#define ECSRFM_CSU_STARTSPU1                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x001*4)))
#define ECSRFM_CSU_EVENTMASK                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x002*4)))
#define ECSRFM_CSU_INTMASK                          (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x004*4)))
#define ECSRFM_CSU_ELEVELMASK                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x005*4)))
#define ECSRFM_CSU_TAGMASK0                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x006*4)))
#define ECSRFM_CSU_TAGMASK1                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x007*4)))
#define ECSRFM_CSU_TAGMASK2                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x008*4)))
#define ECSRFM_CSU_TAGMASK3                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x009*4)))
#define ECSRFM_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x00A*4)))
#define ECSRFM_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x00B*4)))
#define ECSRFM_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x00C*4)))
#define ECSRFM_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x00D*4)))
#define ECSRFM_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x010*4)))
#define ECSRFM_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x010*4)))
#define ECSRFM_CSU_FINDDMATAG                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x014*4)))
#define ECSRFM_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x018*4)))
#define ECSRFM_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x019*4)))
#define ECSRFM_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01A*4)))
#define ECSRFM_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01B*4)))
#define ECSRFM_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01C*4)))
#define ECSRFM_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01D*4)))
#define ECSRFM_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01E*4)))
#define ECSRFM_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x01F*4)))
#define ECSRFM_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x020*4)))
#define ECSRFM_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x021*4)))
#define ECSRFM_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x022*4)))
#define ECSRFM_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x023*4)))
#define ECSRFM_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x024*4)))
#define ECSRFM_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x025*4)))
#define ECSRFM_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x026*4)))
#define ECSRFM_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x027*4)))
#define ECSRFM_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x028*4)))
#define ECSRFM_CSU_CMDFIFO0                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x02C*4)))
#define ECSRFM_CSU_CMDFIFO1                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x02D*4)))
#define ECSRFM_CSU_CMDFIFO2                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x02E*4)))
#define ECSRFM_CSU_CMDFIFO3                         (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x02F*4)))
#define ECSRFM_CSU_READYLISTNUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x030*4)))
#define ECSRFM_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x034*4)))
#define ECSRFM_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x035*4)))
#define ECSRFM_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x036*4)))
#define ECSRFM_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x037*4)))
#define ECSRFM_CSU_DMASTATUS                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x038*4)))
#define ECSRFM_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x039*4)))
#define ECSRFM_CSU_QOUSTATUS                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x03A*4)))
#define ECSRFM_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x03C*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x100*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x101*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x102*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x103*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x104*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x105*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x106*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x107*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x108*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x109*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10A*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10B*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10C*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10D*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10E*4)))
#define ECSRFM_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x10F*4)))
#define ECSRFM_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x120*4)))
#define ECSRFM_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x121*4)))
#define ECSRFM_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x122*4)))
#define ECSRFM_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x124*4)))
#define ECSRFM_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x125*4)))
#define ECSRFM_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x126*4)))
#define ECSRFM_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x127*4)))
#define ECSRFM_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x130*4)))
#define ECSRFM_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x131*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x180*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x181*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x182*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x183*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x184*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x185*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x186*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x187*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x188*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x189*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18A*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18B*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18C*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18D*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18E*4)))
#define ECSRFM_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x18F*4)))
#define ECSRFM_CSU_DMAADDRL0                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x200*4)))
#define ECSRFM_CSU_DMAADDRH0                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x201*4)))
#define ECSRFM_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x202*4)))
#define ECSRFM_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x203*4)))
#define ECSRFM_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x204*4)))
#define ECSRFM_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x205*4)))
#define ECSRFM_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x206*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x207*4)))
#define ECSRFM_CSU_DMAADDRL1                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x208*4)))
#define ECSRFM_CSU_DMAADDRH1                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x209*4)))
#define ECSRFM_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20A*4)))
#define ECSRFM_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20B*4)))
#define ECSRFM_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20C*4)))
#define ECSRFM_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x20F*4)))
#define ECSRFM_CSU_DMAADDRL2                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x210*4)))
#define ECSRFM_CSU_DMAADDRH2                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x211*4)))
#define ECSRFM_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x212*4)))
#define ECSRFM_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x213*4)))
#define ECSRFM_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x214*4)))
#define ECSRFM_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x215*4)))
#define ECSRFM_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x216*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x217*4)))
#define ECSRFM_CSU_DMAADDRL3                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x218*4)))
#define ECSRFM_CSU_DMAADDRH3                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x219*4)))
#define ECSRFM_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21A*4)))
#define ECSRFM_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21B*4)))
#define ECSRFM_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21C*4)))
#define ECSRFM_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x21F*4)))
#define ECSRFM_CSU_DMAADDRL4                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x220*4)))
#define ECSRFM_CSU_DMAADDRH4                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x221*4)))
#define ECSRFM_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x222*4)))
#define ECSRFM_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x223*4)))
#define ECSRFM_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x224*4)))
#define ECSRFM_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x225*4)))
#define ECSRFM_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x226*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x227*4)))
#define ECSRFM_CSU_DMAADDRL5                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x228*4)))
#define ECSRFM_CSU_DMAADDRH5                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x229*4)))
#define ECSRFM_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22A*4)))
#define ECSRFM_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22B*4)))
#define ECSRFM_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22C*4)))
#define ECSRFM_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x22F*4)))
#define ECSRFM_CSU_DMAADDRL6                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x230*4)))
#define ECSRFM_CSU_DMAADDRH6                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x231*4)))
#define ECSRFM_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x232*4)))
#define ECSRFM_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x233*4)))
#define ECSRFM_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x234*4)))
#define ECSRFM_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x235*4)))
#define ECSRFM_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x236*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x237*4)))
#define ECSRFM_CSU_DMAADDRL7                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x238*4)))
#define ECSRFM_CSU_DMAADDRH7                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x239*4)))
#define ECSRFM_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23A*4)))
#define ECSRFM_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23B*4)))
#define ECSRFM_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23C*4)))
#define ECSRFM_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x23F*4)))
#define ECSRFM_CSU_DMAADDRL8                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x240*4)))
#define ECSRFM_CSU_DMAADDRH8                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x241*4)))
#define ECSRFM_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x242*4)))
#define ECSRFM_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x243*4)))
#define ECSRFM_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x244*4)))
#define ECSRFM_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x245*4)))
#define ECSRFM_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x246*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x247*4)))
#define ECSRFM_CSU_DMAADDRL9                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x248*4)))
#define ECSRFM_CSU_DMAADDRH9                        (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x249*4)))
#define ECSRFM_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24A*4)))
#define ECSRFM_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24B*4)))
#define ECSRFM_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24C*4)))
#define ECSRFM_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x24F*4)))
#define ECSRFM_CSU_DMAADDRL10                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x250*4)))
#define ECSRFM_CSU_DMAADDRH10                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x251*4)))
#define ECSRFM_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x252*4)))
#define ECSRFM_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x253*4)))
#define ECSRFM_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x254*4)))
#define ECSRFM_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x255*4)))
#define ECSRFM_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x256*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x257*4)))
#define ECSRFM_CSU_DMAADDRL11                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x258*4)))
#define ECSRFM_CSU_DMAADDRH11                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x259*4)))
#define ECSRFM_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25A*4)))
#define ECSRFM_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25B*4)))
#define ECSRFM_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25C*4)))
#define ECSRFM_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x25F*4)))
#define ECSRFM_CSU_DMAADDRL12                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x260*4)))
#define ECSRFM_CSU_DMAADDRH12                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x261*4)))
#define ECSRFM_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x262*4)))
#define ECSRFM_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x263*4)))
#define ECSRFM_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x264*4)))
#define ECSRFM_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x265*4)))
#define ECSRFM_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x266*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x267*4)))
#define ECSRFM_CSU_DMAADDRL13                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x268*4)))
#define ECSRFM_CSU_DMAADDRH13                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x269*4)))
#define ECSRFM_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26A*4)))
#define ECSRFM_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26B*4)))
#define ECSRFM_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26C*4)))
#define ECSRFM_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x26F*4)))
#define ECSRFM_CSU_DMAADDRL14                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x270*4)))
#define ECSRFM_CSU_DMAADDRH14                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x271*4)))
#define ECSRFM_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x272*4)))
#define ECSRFM_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x273*4)))
#define ECSRFM_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x274*4)))
#define ECSRFM_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x275*4)))
#define ECSRFM_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x276*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x277*4)))
#define ECSRFM_CSU_DMAADDRL15                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x278*4)))
#define ECSRFM_CSU_DMAADDRH15                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x279*4)))
#define ECSRFM_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27A*4)))
#define ECSRFM_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27B*4)))
#define ECSRFM_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27C*4)))
#define ECSRFM_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27D*4)))
#define ECSRFM_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27E*4)))
#define ECSRFM_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x27F*4)))
#define ECSRFM_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x300*4)))
#define ECSRFM_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x301*4)))
#define ECSRFM_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x302*4)))
#define ECSRFM_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x303*4)))
#define ECSRFM_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x304*4)))
#define ECSRFM_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x305*4)))
#define ECSRFM_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x306*4)))
#define ECSRFM_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x307*4)))
#define ECSRFM_CSU_SPUID                            (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x30B*4)))
#define ECSRFM_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x310*4)))
#define ECSRFM_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x311*4)))
#define ECSRFM_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x312*4)))
#define ECSRFM_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x313*4)))
#define ECSRFM_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x314*4)))
#define ECSRFM_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x315*4)))
#define ECSRFM_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x316*4)))
#define ECSRFM_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x317*4)))
#define ECSRFM_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x380*4)))
#define ECSRFM_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C0*4)))
#define ECSRFM_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C1*4)))
#define ECSRFM_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C2*4)))
#define ECSRFM_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C3*4)))
#define ECSRFM_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C4*4)))
#define ECSRFM_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C5*4)))
#define ECSRFM_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C6*4)))
#define ECSRFM_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C7*4)))
#define ECSRFM_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C8*4)))
#define ECSRFM_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3C9*4)))
#define ECSRFM_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CA*4)))
#define ECSRFM_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CB*4)))
#define ECSRFM_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CC*4)))
#define ECSRFM_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CD*4)))
#define ECSRFM_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CE*4)))
#define ECSRFM_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3CF*4)))
#define ECSRFM_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D0*4)))
#define ECSRFM_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D1*4)))
#define ECSRFM_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D2*4)))
#define ECSRFM_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D3*4)))
#define ECSRFM_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D4*4)))
#define ECSRFM_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D5*4)))
#define ECSRFM_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D6*4)))
#define ECSRFM_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D7*4)))
#define ECSRFM_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D8*4)))
#define ECSRFM_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3D9*4)))
#define ECSRFM_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DA*4)))
#define ECSRFM_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DB*4)))
#define ECSRFM_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DC*4)))
#define ECSRFM_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DD*4)))
#define ECSRFM_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DE*4)))
#define ECSRFM_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3DF*4)))
#define ECSRFM_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E0*4)))
#define ECSRFM_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E1*4)))
#define ECSRFM_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E2*4)))
#define ECSRFM_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E3*4)))
#define ECSRFM_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E4*4)))
#define ECSRFM_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E5*4)))
#define ECSRFM_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E6*4)))
#define ECSRFM_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E7*4)))
#define ECSRFM_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E8*4)))
#define ECSRFM_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3E9*4)))
#define ECSRFM_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3EA*4)))
#define ECSRFM_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3EB*4)))
#define ECSRFM_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3EC*4)))
#define ECSRFM_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3ED*4)))
#define ECSRFM_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3EE*4)))
#define ECSRFM_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3EF*4)))
#define ECSRFM_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F0*4)))
#define ECSRFM_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F1*4)))
#define ECSRFM_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F2*4)))
#define ECSRFM_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F3*4)))
#define ECSRFM_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F4*4)))
#define ECSRFM_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F5*4)))
#define ECSRFM_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F6*4)))
#define ECSRFM_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F7*4)))
#define ECSRFM_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F8*4)))
#define ECSRFM_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3F9*4)))
#define ECSRFM_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FA*4)))
#define ECSRFM_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FB*4)))
#define ECSRFM_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FC*4)))
#define ECSRFM_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FD*4)))
#define ECSRFM_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FE*4)))
#define ECSRFM_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(ECSRFM_CSU_BASE+0x3FF*4)))


#define PETRFM_CSU_STARTSPU0                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x000*4)))
#define PETRFM_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x000*4)))
#define PETRFM_CSU_STARTSPU1                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x001*4)))
#define PETRFM_CSU_EVENTMASK                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x002*4)))
#define PETRFM_CSU_INTMASK                          (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x004*4)))
#define PETRFM_CSU_ELEVELMASK                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x005*4)))
#define PETRFM_CSU_TAGMASK0                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x006*4)))
#define PETRFM_CSU_TAGMASK1                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x007*4)))
#define PETRFM_CSU_TAGMASK2                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x008*4)))
#define PETRFM_CSU_TAGMASK3                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x009*4)))
#define PETRFM_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x00A*4)))
#define PETRFM_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x00B*4)))
#define PETRFM_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x00C*4)))
#define PETRFM_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x00D*4)))
#define PETRFM_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x010*4)))
#define PETRFM_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x010*4)))
#define PETRFM_CSU_FINDDMATAG                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x014*4)))
#define PETRFM_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x018*4)))
#define PETRFM_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x019*4)))
#define PETRFM_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x01C*4)))
#define PETRFM_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x01D*4)))
#define PETRFM_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x020*4)))
#define PETRFM_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x021*4)))
#define PETRFM_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x024*4)))
#define PETRFM_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x025*4)))
#define PETRFM_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x028*4)))
#define PETRFM_CSU_CMDFIFO0                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x02C*4)))
#define PETRFM_CSU_CMDFIFO1                         (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x02D*4)))
#define PETRFM_CSU_READYLISTNUM                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x030*4)))
#define PETRFM_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x034*4)))
#define PETRFM_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x035*4)))
#define PETRFM_CSU_DMASTATUS                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x038*4)))
#define PETRFM_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x039*4)))
#define PETRFM_CSU_QOUSTATUS                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x03A*4)))
#define PETRFM_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x03C*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG0              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x100*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG1              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x101*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG2              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x102*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG3              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x103*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG4              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x104*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG5              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x105*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG6              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x106*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG7              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x107*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG8              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x108*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG9              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x109*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG10             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10A*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG11             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10B*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG12             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10C*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG13             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10D*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG14             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10E*4)))
#define PETRFM_CSU_MAILBOX_PRIDATAREG15             (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x10F*4)))
#define PETRFM_CSU_MAILBOX_BASENUM                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x120*4)))
#define PETRFM_CSU_MAILBOX_BASECNT                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x121*4)))
#define PETRFM_CSU_MAILBOX_VALIDREG                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x122*4)))
#define PETRFM_CSU_MAILBOX_INTMASK0                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x124*4)))
#define PETRFM_CSU_MAILBOX_INTMASK1                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x125*4)))
#define PETRFM_CSU_MAILBOX_INTMASK2                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x126*4)))
#define PETRFM_CSU_MAILBOX_INTMASK3                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x127*4)))
#define PETRFM_CSU_MAILBOX_EVENTMASK0               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x130*4)))
#define PETRFM_CSU_MAILBOX_EVENTMASK1               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x131*4)))
#define PETRFM_CSU_MAILBOX_CNTREG0                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x180*4)))
#define PETRFM_CSU_MAILBOX_CNTREG1                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x181*4)))
#define PETRFM_CSU_MAILBOX_CNTREG2                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x182*4)))
#define PETRFM_CSU_MAILBOX_CNTREG3                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x183*4)))
#define PETRFM_CSU_MAILBOX_CNTREG4                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x184*4)))
#define PETRFM_CSU_MAILBOX_CNTREG5                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x185*4)))
#define PETRFM_CSU_MAILBOX_CNTREG6                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x186*4)))
#define PETRFM_CSU_MAILBOX_CNTREG7                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x187*4)))
#define PETRFM_CSU_MAILBOX_CNTREG8                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x188*4)))
#define PETRFM_CSU_MAILBOX_CNTREG9                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x189*4)))
#define PETRFM_CSU_MAILBOX_CNTREG10                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18A*4)))
#define PETRFM_CSU_MAILBOX_CNTREG11                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18B*4)))
#define PETRFM_CSU_MAILBOX_CNTREG12                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18C*4)))
#define PETRFM_CSU_MAILBOX_CNTREG13                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18D*4)))
#define PETRFM_CSU_MAILBOX_CNTREG14                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18E*4)))
#define PETRFM_CSU_MAILBOX_CNTREG15                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x18F*4)))
#define PETRFM_CSU_DMAADDRL0                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x200*4)))
#define PETRFM_CSU_DMAADDRH0                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x201*4)))
#define PETRFM_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x202*4)))
#define PETRFM_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x203*4)))
#define PETRFM_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x204*4)))
#define PETRFM_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x205*4)))
#define PETRFM_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x206*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x207*4)))
#define PETRFM_CSU_DMAADDRL1                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x208*4)))
#define PETRFM_CSU_DMAADDRH1                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x209*4)))
#define PETRFM_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20A*4)))
#define PETRFM_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20B*4)))
#define PETRFM_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20C*4)))
#define PETRFM_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20D*4)))
#define PETRFM_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x20F*4)))
#define PETRFM_CSU_DMAADDRL2                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x210*4)))
#define PETRFM_CSU_DMAADDRH2                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x211*4)))
#define PETRFM_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x212*4)))
#define PETRFM_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x213*4)))
#define PETRFM_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x214*4)))
#define PETRFM_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x215*4)))
#define PETRFM_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x216*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x217*4)))
#define PETRFM_CSU_DMAADDRL3                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x218*4)))
#define PETRFM_CSU_DMAADDRH3                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x219*4)))
#define PETRFM_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21A*4)))
#define PETRFM_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21B*4)))
#define PETRFM_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21C*4)))
#define PETRFM_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21D*4)))
#define PETRFM_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x21F*4)))
#define PETRFM_CSU_DMAADDRL4                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x220*4)))
#define PETRFM_CSU_DMAADDRH4                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x221*4)))
#define PETRFM_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x222*4)))
#define PETRFM_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x223*4)))
#define PETRFM_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x224*4)))
#define PETRFM_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x225*4)))
#define PETRFM_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x226*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x227*4)))
#define PETRFM_CSU_DMAADDRL5                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x228*4)))
#define PETRFM_CSU_DMAADDRH5                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x229*4)))
#define PETRFM_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22A*4)))
#define PETRFM_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22B*4)))
#define PETRFM_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22C*4)))
#define PETRFM_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22D*4)))
#define PETRFM_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x22F*4)))
#define PETRFM_CSU_DMAADDRL6                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x230*4)))
#define PETRFM_CSU_DMAADDRH6                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x231*4)))
#define PETRFM_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x232*4)))
#define PETRFM_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x233*4)))
#define PETRFM_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x234*4)))
#define PETRFM_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x235*4)))
#define PETRFM_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x236*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x237*4)))
#define PETRFM_CSU_DMAADDRL7                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x238*4)))
#define PETRFM_CSU_DMAADDRH7                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x239*4)))
#define PETRFM_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23A*4)))
#define PETRFM_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23B*4)))
#define PETRFM_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23C*4)))
#define PETRFM_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23D*4)))
#define PETRFM_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x23F*4)))
#define PETRFM_CSU_DMAADDRL8                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x240*4)))
#define PETRFM_CSU_DMAADDRH8                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x241*4)))
#define PETRFM_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x242*4)))
#define PETRFM_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x243*4)))
#define PETRFM_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x244*4)))
#define PETRFM_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x245*4)))
#define PETRFM_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x246*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x247*4)))
#define PETRFM_CSU_DMAADDRL9                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x248*4)))
#define PETRFM_CSU_DMAADDRH9                        (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x249*4)))
#define PETRFM_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24A*4)))
#define PETRFM_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24B*4)))
#define PETRFM_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24C*4)))
#define PETRFM_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24D*4)))
#define PETRFM_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x24F*4)))
#define PETRFM_CSU_DMAADDRL10                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x250*4)))
#define PETRFM_CSU_DMAADDRH10                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x251*4)))
#define PETRFM_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x252*4)))
#define PETRFM_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x253*4)))
#define PETRFM_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x254*4)))
#define PETRFM_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x255*4)))
#define PETRFM_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x256*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x257*4)))
#define PETRFM_CSU_DMAADDRL11                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x258*4)))
#define PETRFM_CSU_DMAADDRH11                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x259*4)))
#define PETRFM_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25A*4)))
#define PETRFM_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25B*4)))
#define PETRFM_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25C*4)))
#define PETRFM_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25D*4)))
#define PETRFM_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x25F*4)))
#define PETRFM_CSU_DMAADDRL12                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x260*4)))
#define PETRFM_CSU_DMAADDRH12                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x261*4)))
#define PETRFM_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x262*4)))
#define PETRFM_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x263*4)))
#define PETRFM_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x264*4)))
#define PETRFM_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x265*4)))
#define PETRFM_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x266*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x267*4)))
#define PETRFM_CSU_DMAADDRL13                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x268*4)))
#define PETRFM_CSU_DMAADDRH13                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x269*4)))
#define PETRFM_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26A*4)))
#define PETRFM_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26B*4)))
#define PETRFM_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26C*4)))
#define PETRFM_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26D*4)))
#define PETRFM_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x26F*4)))
#define PETRFM_CSU_DMAADDRL14                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x270*4)))
#define PETRFM_CSU_DMAADDRH14                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x271*4)))
#define PETRFM_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x272*4)))
#define PETRFM_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x273*4)))
#define PETRFM_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x274*4)))
#define PETRFM_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x275*4)))
#define PETRFM_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x276*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x277*4)))
#define PETRFM_CSU_DMAADDRL15                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x278*4)))
#define PETRFM_CSU_DMAADDRH15                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x279*4)))
#define PETRFM_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27A*4)))
#define PETRFM_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27B*4)))
#define PETRFM_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27C*4)))
#define PETRFM_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27D*4)))
#define PETRFM_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27E*4)))
#define PETRFM_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x27F*4)))
#define PETRFM_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x300*4)))
#define PETRFM_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x301*4)))
#define PETRFM_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x302*4)))
#define PETRFM_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x303*4)))
#define PETRFM_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x304*4)))
#define PETRFM_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x305*4)))
#define PETRFM_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x306*4)))
#define PETRFM_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x307*4)))
#define PETRFM_CSU_SPUID                            (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x30B*4)))
#define PETRFM_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x310*4)))
#define PETRFM_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x311*4)))
#define PETRFM_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x312*4)))
#define PETRFM_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x313*4)))
#define PETRFM_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x314*4)))
#define PETRFM_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x315*4)))
#define PETRFM_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x316*4)))
#define PETRFM_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x317*4)))
#define PETRFM_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x380*4)))
#define PETRFM_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C0*4)))
#define PETRFM_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C1*4)))
#define PETRFM_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C2*4)))
#define PETRFM_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C3*4)))
#define PETRFM_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C4*4)))
#define PETRFM_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C5*4)))
#define PETRFM_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C6*4)))
#define PETRFM_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C7*4)))
#define PETRFM_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C8*4)))
#define PETRFM_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3C9*4)))
#define PETRFM_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CA*4)))
#define PETRFM_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CB*4)))
#define PETRFM_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CC*4)))
#define PETRFM_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CD*4)))
#define PETRFM_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CE*4)))
#define PETRFM_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3CF*4)))
#define PETRFM_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D0*4)))
#define PETRFM_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D1*4)))
#define PETRFM_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D2*4)))
#define PETRFM_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D3*4)))
#define PETRFM_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D4*4)))
#define PETRFM_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D5*4)))
#define PETRFM_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D6*4)))
#define PETRFM_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D7*4)))
#define PETRFM_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D8*4)))
#define PETRFM_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3D9*4)))
#define PETRFM_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DA*4)))
#define PETRFM_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DB*4)))
#define PETRFM_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DC*4)))
#define PETRFM_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DD*4)))
#define PETRFM_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DE*4)))
#define PETRFM_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3DF*4)))
#define PETRFM_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E0*4)))
#define PETRFM_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E1*4)))
#define PETRFM_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E2*4)))
#define PETRFM_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E3*4)))
#define PETRFM_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E4*4)))
#define PETRFM_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E5*4)))
#define PETRFM_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E6*4)))
#define PETRFM_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E7*4)))
#define PETRFM_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E8*4)))
#define PETRFM_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3E9*4)))
#define PETRFM_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3EA*4)))
#define PETRFM_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3EB*4)))
#define PETRFM_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3EC*4)))
#define PETRFM_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3ED*4)))
#define PETRFM_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3EE*4)))
#define PETRFM_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3EF*4)))
#define PETRFM_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F0*4)))
#define PETRFM_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F1*4)))
#define PETRFM_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F2*4)))
#define PETRFM_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F3*4)))
#define PETRFM_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F4*4)))
#define PETRFM_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F5*4)))
#define PETRFM_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F6*4)))
#define PETRFM_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F7*4)))
#define PETRFM_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F8*4)))
#define PETRFM_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3F9*4)))
#define PETRFM_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FA*4)))
#define PETRFM_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FB*4)))
#define PETRFM_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FC*4)))
#define PETRFM_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FD*4)))
#define PETRFM_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FE*4)))
#define PETRFM_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(PETRFM_CSU_BASE+0x3FF*4)))


#define AP_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(AP_CSU_BASE+0x000*4)))
#define AP_CSU_EVENTMASK                        (*((volatile uint32_t *)(AP_CSU_BASE+0x002*4)))
#define AP_CSU_INTMASK                          (*((volatile uint32_t *)(AP_CSU_BASE+0x004*4)))
#define AP_CSU_ELEVELMASK                       (*((volatile uint32_t *)(AP_CSU_BASE+0x005*4)))
#define AP_CSU_TAGMASK0                         (*((volatile uint32_t *)(AP_CSU_BASE+0x006*4)))
#define AP_CSU_TAGMASK1                         (*((volatile uint32_t *)(AP_CSU_BASE+0x007*4)))
#define AP_CSU_TAGMASK2                         (*((volatile uint32_t *)(AP_CSU_BASE+0x008*4)))
#define AP_CSU_TAGMASK3                         (*((volatile uint32_t *)(AP_CSU_BASE+0x009*4)))
#define AP_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(AP_CSU_BASE+0x00A*4)))
#define AP_CSU_FETCHMODE_CACHEMODE              (*((volatile uint32_t *)(AP_CSU_BASE+0x00B*4)))
#define AP_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(AP_CSU_BASE+0x00C*4)))
#define AP_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(AP_CSU_BASE+0x00D*4)))
#define AP_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(AP_CSU_BASE+0x010*4)))
#define AP_CSU_CACHEINFO_EM_BS_SPURWCACHE_SMSEL_PDNUM (*((volatile uint32_t *)(AP_CSU_BASE+0x010*4)))
#define AP_CSU_FINDDMATAG                       (*((volatile uint32_t *)(AP_CSU_BASE+0x014*4)))
#define AP_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(AP_CSU_BASE+0x018*4)))
#define AP_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(AP_CSU_BASE+0x019*4)))
#define AP_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01A*4)))
#define AP_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01B*4)))
#define AP_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01C*4)))
#define AP_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01D*4)))
#define AP_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01E*4)))
#define AP_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x01F*4)))
#define AP_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(AP_CSU_BASE+0x020*4)))
#define AP_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(AP_CSU_BASE+0x021*4)))
#define AP_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(AP_CSU_BASE+0x024*4)))
#define AP_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(AP_CSU_BASE+0x025*4)))
#define AP_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(AP_CSU_BASE+0x028*4)))
#define AP_CSU_CMDFIFO0                         (*((volatile uint32_t *)(AP_CSU_BASE+0x02C*4)))
#define AP_CSU_CMDFIFO1                         (*((volatile uint32_t *)(AP_CSU_BASE+0x02D*4)))
#define AP_CSU_CMDFIFO2                         (*((volatile uint32_t *)(AP_CSU_BASE+0x02E*4)))
#define AP_CSU_CMDFIFO3                         (*((volatile uint32_t *)(AP_CSU_BASE+0x02F*4)))
#define AP_CSU_READYLISTNUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x030*4)))
#define AP_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(AP_CSU_BASE+0x034*4)))
#define AP_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(AP_CSU_BASE+0x035*4)))
#define AP_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(AP_CSU_BASE+0x036*4)))
#define AP_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(AP_CSU_BASE+0x037*4)))
#define AP_CSU_DMASTATUS                        (*((volatile uint32_t *)(AP_CSU_BASE+0x038*4)))
#define AP_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(AP_CSU_BASE+0x039*4)))
#define AP_CSU_QOUSTATUS                        (*((volatile uint32_t *)(AP_CSU_BASE+0x03A*4)))
#define AP_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(AP_CSU_BASE+0x03C*4)))
#define AP_CSU_DMAADDRL0                        (*((volatile uint32_t *)(AP_CSU_BASE+0x200*4)))
#define AP_CSU_DMAADDRH0                        (*((volatile uint32_t *)(AP_CSU_BASE+0x201*4)))
#define AP_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(AP_CSU_BASE+0x202*4)))
#define AP_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(AP_CSU_BASE+0x203*4)))
#define AP_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(AP_CSU_BASE+0x204*4)))
#define AP_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(AP_CSU_BASE+0x205*4)))
#define AP_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(AP_CSU_BASE+0x206*4)))
#define AP_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(AP_CSU_BASE+0x207*4)))
#define AP_CSU_DMAADDRL1                        (*((volatile uint32_t *)(AP_CSU_BASE+0x208*4)))
#define AP_CSU_DMAADDRH1                        (*((volatile uint32_t *)(AP_CSU_BASE+0x209*4)))
#define AP_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(AP_CSU_BASE+0x20A*4)))
#define AP_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(AP_CSU_BASE+0x20B*4)))
#define AP_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(AP_CSU_BASE+0x20C*4)))
#define AP_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(AP_CSU_BASE+0x20D*4)))
#define AP_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(AP_CSU_BASE+0x20E*4)))
#define AP_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(AP_CSU_BASE+0x20F*4)))
#define AP_CSU_DMAADDRL2                        (*((volatile uint32_t *)(AP_CSU_BASE+0x210*4)))
#define AP_CSU_DMAADDRH2                        (*((volatile uint32_t *)(AP_CSU_BASE+0x211*4)))
#define AP_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(AP_CSU_BASE+0x212*4)))
#define AP_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(AP_CSU_BASE+0x213*4)))
#define AP_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(AP_CSU_BASE+0x214*4)))
#define AP_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(AP_CSU_BASE+0x215*4)))
#define AP_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(AP_CSU_BASE+0x216*4)))
#define AP_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(AP_CSU_BASE+0x217*4)))
#define AP_CSU_DMAADDRL3                        (*((volatile uint32_t *)(AP_CSU_BASE+0x218*4)))
#define AP_CSU_DMAADDRH3                        (*((volatile uint32_t *)(AP_CSU_BASE+0x219*4)))
#define AP_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(AP_CSU_BASE+0x21A*4)))
#define AP_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(AP_CSU_BASE+0x21B*4)))
#define AP_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(AP_CSU_BASE+0x21C*4)))
#define AP_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(AP_CSU_BASE+0x21D*4)))
#define AP_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(AP_CSU_BASE+0x21E*4)))
#define AP_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(AP_CSU_BASE+0x21F*4)))
#define AP_CSU_DMAADDRL4                        (*((volatile uint32_t *)(AP_CSU_BASE+0x220*4)))
#define AP_CSU_DMAADDRH4                        (*((volatile uint32_t *)(AP_CSU_BASE+0x221*4)))
#define AP_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(AP_CSU_BASE+0x222*4)))
#define AP_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(AP_CSU_BASE+0x223*4)))
#define AP_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(AP_CSU_BASE+0x224*4)))
#define AP_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(AP_CSU_BASE+0x225*4)))
#define AP_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(AP_CSU_BASE+0x226*4)))
#define AP_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(AP_CSU_BASE+0x227*4)))
#define AP_CSU_DMAADDRL5                        (*((volatile uint32_t *)(AP_CSU_BASE+0x228*4)))
#define AP_CSU_DMAADDRH5                        (*((volatile uint32_t *)(AP_CSU_BASE+0x229*4)))
#define AP_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(AP_CSU_BASE+0x22A*4)))
#define AP_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(AP_CSU_BASE+0x22B*4)))
#define AP_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(AP_CSU_BASE+0x22C*4)))
#define AP_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(AP_CSU_BASE+0x22D*4)))
#define AP_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(AP_CSU_BASE+0x22E*4)))
#define AP_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(AP_CSU_BASE+0x22F*4)))
#define AP_CSU_DMAADDRL6                        (*((volatile uint32_t *)(AP_CSU_BASE+0x230*4)))
#define AP_CSU_DMAADDRH6                        (*((volatile uint32_t *)(AP_CSU_BASE+0x231*4)))
#define AP_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(AP_CSU_BASE+0x232*4)))
#define AP_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(AP_CSU_BASE+0x233*4)))
#define AP_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(AP_CSU_BASE+0x234*4)))
#define AP_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(AP_CSU_BASE+0x235*4)))
#define AP_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(AP_CSU_BASE+0x236*4)))
#define AP_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(AP_CSU_BASE+0x237*4)))
#define AP_CSU_DMAADDRL7                        (*((volatile uint32_t *)(AP_CSU_BASE+0x238*4)))
#define AP_CSU_DMAADDRH7                        (*((volatile uint32_t *)(AP_CSU_BASE+0x239*4)))
#define AP_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(AP_CSU_BASE+0x23A*4)))
#define AP_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(AP_CSU_BASE+0x23B*4)))
#define AP_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(AP_CSU_BASE+0x23C*4)))
#define AP_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(AP_CSU_BASE+0x23D*4)))
#define AP_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(AP_CSU_BASE+0x23E*4)))
#define AP_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(AP_CSU_BASE+0x23F*4)))
#define AP_CSU_DMAADDRL8                        (*((volatile uint32_t *)(AP_CSU_BASE+0x240*4)))
#define AP_CSU_DMAADDRH8                        (*((volatile uint32_t *)(AP_CSU_BASE+0x241*4)))
#define AP_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(AP_CSU_BASE+0x242*4)))
#define AP_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(AP_CSU_BASE+0x243*4)))
#define AP_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(AP_CSU_BASE+0x244*4)))
#define AP_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(AP_CSU_BASE+0x245*4)))
#define AP_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(AP_CSU_BASE+0x246*4)))
#define AP_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(AP_CSU_BASE+0x247*4)))
#define AP_CSU_DMAADDRL9                        (*((volatile uint32_t *)(AP_CSU_BASE+0x248*4)))
#define AP_CSU_DMAADDRH9                        (*((volatile uint32_t *)(AP_CSU_BASE+0x249*4)))
#define AP_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(AP_CSU_BASE+0x24A*4)))
#define AP_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(AP_CSU_BASE+0x24B*4)))
#define AP_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(AP_CSU_BASE+0x24C*4)))
#define AP_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(AP_CSU_BASE+0x24D*4)))
#define AP_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(AP_CSU_BASE+0x24E*4)))
#define AP_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(AP_CSU_BASE+0x24F*4)))
#define AP_CSU_DMAADDRL10                       (*((volatile uint32_t *)(AP_CSU_BASE+0x250*4)))
#define AP_CSU_DMAADDRH10                       (*((volatile uint32_t *)(AP_CSU_BASE+0x251*4)))
#define AP_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(AP_CSU_BASE+0x252*4)))
#define AP_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(AP_CSU_BASE+0x253*4)))
#define AP_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(AP_CSU_BASE+0x254*4)))
#define AP_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(AP_CSU_BASE+0x255*4)))
#define AP_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(AP_CSU_BASE+0x256*4)))
#define AP_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(AP_CSU_BASE+0x257*4)))
#define AP_CSU_DMAADDRL11                       (*((volatile uint32_t *)(AP_CSU_BASE+0x258*4)))
#define AP_CSU_DMAADDRH11                       (*((volatile uint32_t *)(AP_CSU_BASE+0x259*4)))
#define AP_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(AP_CSU_BASE+0x25A*4)))
#define AP_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(AP_CSU_BASE+0x25B*4)))
#define AP_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(AP_CSU_BASE+0x25C*4)))
#define AP_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(AP_CSU_BASE+0x25D*4)))
#define AP_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(AP_CSU_BASE+0x25E*4)))
#define AP_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(AP_CSU_BASE+0x25F*4)))
#define AP_CSU_DMAADDRL12                       (*((volatile uint32_t *)(AP_CSU_BASE+0x260*4)))
#define AP_CSU_DMAADDRH12                       (*((volatile uint32_t *)(AP_CSU_BASE+0x261*4)))
#define AP_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(AP_CSU_BASE+0x262*4)))
#define AP_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(AP_CSU_BASE+0x263*4)))
#define AP_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(AP_CSU_BASE+0x264*4)))
#define AP_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(AP_CSU_BASE+0x265*4)))
#define AP_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(AP_CSU_BASE+0x266*4)))
#define AP_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(AP_CSU_BASE+0x267*4)))
#define AP_CSU_DMAADDRL13                       (*((volatile uint32_t *)(AP_CSU_BASE+0x268*4)))
#define AP_CSU_DMAADDRH13                       (*((volatile uint32_t *)(AP_CSU_BASE+0x269*4)))
#define AP_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(AP_CSU_BASE+0x26A*4)))
#define AP_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(AP_CSU_BASE+0x26B*4)))
#define AP_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(AP_CSU_BASE+0x26C*4)))
#define AP_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(AP_CSU_BASE+0x26D*4)))
#define AP_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(AP_CSU_BASE+0x26E*4)))
#define AP_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(AP_CSU_BASE+0x26F*4)))
#define AP_CSU_DMAADDRL14                       (*((volatile uint32_t *)(AP_CSU_BASE+0x270*4)))
#define AP_CSU_DMAADDRH14                       (*((volatile uint32_t *)(AP_CSU_BASE+0x271*4)))
#define AP_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(AP_CSU_BASE+0x272*4)))
#define AP_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(AP_CSU_BASE+0x273*4)))
#define AP_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(AP_CSU_BASE+0x274*4)))
#define AP_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(AP_CSU_BASE+0x275*4)))
#define AP_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(AP_CSU_BASE+0x276*4)))
#define AP_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(AP_CSU_BASE+0x277*4)))
#define AP_CSU_DMAADDRL15                       (*((volatile uint32_t *)(AP_CSU_BASE+0x278*4)))
#define AP_CSU_DMAADDRH15                       (*((volatile uint32_t *)(AP_CSU_BASE+0x279*4)))
#define AP_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(AP_CSU_BASE+0x27A*4)))
#define AP_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(AP_CSU_BASE+0x27B*4)))
#define AP_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(AP_CSU_BASE+0x27C*4)))
#define AP_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(AP_CSU_BASE+0x27D*4)))
#define AP_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(AP_CSU_BASE+0x27E*4)))
#define AP_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(AP_CSU_BASE+0x27F*4)))
#define AP_CSU_QOUCMDNUM_QOUCMDPOS              (*((volatile uint32_t *)(AP_CSU_BASE+0x300*4)))
#define AP_CSU_QOUCMDADDR                       (*((volatile uint32_t *)(AP_CSU_BASE+0x301*4)))
#define AP_CSU_QOUCMDDATA                       (*((volatile uint32_t *)(AP_CSU_BASE+0x302*4)))
#define AP_CSU_QOUSTATUSPOPDATA                 (*((volatile uint32_t *)(AP_CSU_BASE+0x303*4)))
#define AP_CSU_QOUCMPDATA0                      (*((volatile uint32_t *)(AP_CSU_BASE+0x304*4)))
#define AP_CSU_QOUCMPDATA1                      (*((volatile uint32_t *)(AP_CSU_BASE+0x305*4)))
#define AP_CSU_QOUCMPDATA2                      (*((volatile uint32_t *)(AP_CSU_BASE+0x306*4)))
#define AP_CSU_QOUCMPDATA3                      (*((volatile uint32_t *)(AP_CSU_BASE+0x307*4)))
#define AP_CSU_PRICMDDATA_L32BIT0               (*((volatile uint32_t *)(AP_CSU_BASE+0x310*4)))
#define AP_CSU_PRICMDDATA_H14BIT0               (*((volatile uint32_t *)(AP_CSU_BASE+0x311*4)))
#define AP_CSU_PRICMDDATA_L32BIT1               (*((volatile uint32_t *)(AP_CSU_BASE+0x312*4)))
#define AP_CSU_PRICMDDATA_H14BIT1               (*((volatile uint32_t *)(AP_CSU_BASE+0x313*4)))
#define AP_CSU_PRICMDDATA_L32BIT2               (*((volatile uint32_t *)(AP_CSU_BASE+0x314*4)))
#define AP_CSU_PRICMDDATA_H14BIT2               (*((volatile uint32_t *)(AP_CSU_BASE+0x315*4)))
#define AP_CSU_PRICMDDATA_L32BIT3               (*((volatile uint32_t *)(AP_CSU_BASE+0x316*4)))
#define AP_CSU_PRICMDDATA_H14BIT3               (*((volatile uint32_t *)(AP_CSU_BASE+0x317*4)))
#define AP_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(AP_CSU_BASE+0x380*4)))
#define AP_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C0*4)))
#define AP_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C1*4)))
#define AP_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C2*4)))
#define AP_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C3*4)))
#define AP_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C4*4)))
#define AP_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C5*4)))
#define AP_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C6*4)))
#define AP_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C7*4)))
#define AP_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C8*4)))
#define AP_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(AP_CSU_BASE+0x3C9*4)))
#define AP_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CA*4)))
#define AP_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CB*4)))
#define AP_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CC*4)))
#define AP_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CD*4)))
#define AP_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CE*4)))
#define AP_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3CF*4)))
#define AP_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D0*4)))
#define AP_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D1*4)))
#define AP_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D2*4)))
#define AP_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D3*4)))
#define AP_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D4*4)))
#define AP_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D5*4)))
#define AP_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D6*4)))
#define AP_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D7*4)))
#define AP_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D8*4)))
#define AP_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3D9*4)))
#define AP_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DA*4)))
#define AP_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DB*4)))
#define AP_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DC*4)))
#define AP_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DD*4)))
#define AP_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DE*4)))
#define AP_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(AP_CSU_BASE+0x3DF*4)))
#define AP_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E0*4)))
#define AP_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E1*4)))
#define AP_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E2*4)))
#define AP_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E3*4)))
#define AP_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E4*4)))
#define AP_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E5*4)))
#define AP_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E6*4)))
#define AP_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E7*4)))
#define AP_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E8*4)))
#define AP_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(AP_CSU_BASE+0x3E9*4)))
#define AP_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3EA*4)))
#define AP_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3EB*4)))
#define AP_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3EC*4)))
#define AP_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3ED*4)))
#define AP_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3EE*4)))
#define AP_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3EF*4)))
#define AP_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F0*4)))
#define AP_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F1*4)))
#define AP_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F2*4)))
#define AP_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F3*4)))
#define AP_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F4*4)))
#define AP_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F5*4)))
#define AP_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F6*4)))
#define AP_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F7*4)))
#define AP_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F8*4)))
#define AP_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3F9*4)))
#define AP_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FA*4)))
#define AP_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FB*4)))
#define AP_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FC*4)))
#define AP_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FD*4)))
#define AP_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FE*4)))
#define AP_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(AP_CSU_BASE+0x3FF*4)))


#define RFC_CSU_ALLPENDEVENTMASK                  (*((volatile uint32_t *)(RFC_CSU_BASE+0x000*4)))
#define RFC_CSU_EVENTMASK                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x002*4)))
#define RFC_CSU_LATCHALFULL                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x003*4)))
#define RFC_CSU_INTMASK                           (*((volatile uint32_t *)(RFC_CSU_BASE+0x004*4)))
#define RFC_CSU_ELEVELMASK                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x005*4)))
#define RFC_CSU_TAGMASK0                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x006*4)))
#define RFC_CSU_TAGMASK1                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x007*4)))
#define RFC_CSU_TAGMASK2                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x008*4)))
#define RFC_CSU_TAGMASK3                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x009*4)))
#define RFC_CSU_ARMCMDRECV                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x00A*4)))
#define RFC_CSU_ALLPENDEVENT0                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x00C*4)))
#define RFC_CSU_ALLPENDEVENT1                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x00D*4)))
#define RFC_CSU_EM_BS_SMSEL_PREDATANUM            (*((volatile uint32_t *)(RFC_CSU_BASE+0x010*4)))
#define RFC_CSU_ALMOSTFULLSENDTHRED               (*((volatile uint32_t *)(RFC_CSU_BASE+0x011*4)))
#define RFC_CSU_RFCTXSET                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x012*4)))
#define RFC_CSU_RFCRXSET                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x013*4)))
#define RFC_CSU_FINDDMATAG                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x014*4)))
#define RFC_CSU_CMDFIFO0_CMD                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x018*4)))
#define RFC_CSU_CMDFIFO1_CMD                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x019*4)))
#define RFC_CSU_CMDFIFO0_NUM                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x01C*4)))
#define RFC_CSU_CMDFIFO1_NUM                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x01D*4)))
#define RFC_CSU_PRICMDVALID0                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x020*4)))
#define RFC_CSU_PRICMDVALID1                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x021*4)))
#define RFC_CSU_CMDECODATAL32BIT0                 (*((volatile uint32_t *)(RFC_CSU_BASE+0x024*4)))
#define RFC_CSU_CMDECODATAL32BIT1                 (*((volatile uint32_t *)(RFC_CSU_BASE+0x025*4)))
#define RFC_CSU_CMDHIGHDATA                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x028*4)))
#define RFC_CSU_CMDFIFO0                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x02C*4)))
#define RFC_CSU_CMDFIFO1                          (*((volatile uint32_t *)(RFC_CSU_BASE+0x02D*4)))
#define RFC_CSU_READYLISTNUM                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x030*4)))
#define RFC_CSU_CMDFIFO0_TAGNUM                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x034*4)))
#define RFC_CSU_CMDFIFO1_TAGNUM                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x035*4)))
#define RFC_CSU_DMASTATUS                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x038*4)))
#define RFC_CSU_CMDSTALL_LISTSTALL                (*((volatile uint32_t *)(RFC_CSU_BASE+0x039*4)))
#define RFC_CSU_QOUSTATUS                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x03A*4)))
#define RFC_CSU_EVENTINTCLEAR                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x03C*4)))
#define RFC_CSU_DMAADDRL0                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x200*4)))
#define RFC_CSU_DMAADDRH0                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x201*4)))
#define RFC_CSU_DMAYSTEPL0                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x202*4)))
#define RFC_CSU_DMAYSTEPH0                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x203*4)))
#define RFC_CSU_DMAZSTEPL0                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x204*4)))
#define RFC_CSU_DMAZSTEPH0                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x205*4)))
#define RFC_CSU_DMAYNUMXNUM0                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x206*4)))
#define RFC_CSU_DMASIZEGRANALLNUM0                (*((volatile uint32_t *)(RFC_CSU_BASE+0x207*4)))
#define RFC_CSU_DMAADDRL1                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x208*4)))
#define RFC_CSU_DMAADDRH1                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x209*4)))
#define RFC_CSU_DMAYSTEPL1                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x20A*4)))
#define RFC_CSU_DMAYSTEPH1                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x20B*4)))
#define RFC_CSU_DMAZSTEPL1                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x20C*4)))
#define RFC_CSU_DMAZSTEPH1                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x20D*4)))
#define RFC_CSU_DMAYNUMXNUM1                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x20E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM1                (*((volatile uint32_t *)(RFC_CSU_BASE+0x20F*4)))
#define RFC_CSU_DMAADDRL2                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x210*4)))
#define RFC_CSU_DMAADDRH2                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x211*4)))
#define RFC_CSU_DMAYSTEPL2                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x212*4)))
#define RFC_CSU_DMAYSTEPH2                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x213*4)))
#define RFC_CSU_DMAZSTEPL2                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x214*4)))
#define RFC_CSU_DMAZSTEPH2                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x215*4)))
#define RFC_CSU_DMAYNUMXNUM2                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x216*4)))
#define RFC_CSU_DMASIZEGRANALLNUM2                (*((volatile uint32_t *)(RFC_CSU_BASE+0x217*4)))
#define RFC_CSU_DMAADDRL3                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x218*4)))
#define RFC_CSU_DMAADDRH3                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x219*4)))
#define RFC_CSU_DMAYSTEPL3                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x21A*4)))
#define RFC_CSU_DMAYSTEPH3                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x21B*4)))
#define RFC_CSU_DMAZSTEPL3                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x21C*4)))
#define RFC_CSU_DMAZSTEPH3                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x21D*4)))
#define RFC_CSU_DMAYNUMXNUM3                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x21E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM3                (*((volatile uint32_t *)(RFC_CSU_BASE+0x21F*4)))
#define RFC_CSU_DMAADDRL4                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x220*4)))
#define RFC_CSU_DMAADDRH4                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x221*4)))
#define RFC_CSU_DMAYSTEPL4                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x222*4)))
#define RFC_CSU_DMAYSTEPH4                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x223*4)))
#define RFC_CSU_DMAZSTEPL4                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x224*4)))
#define RFC_CSU_DMAZSTEPH4                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x225*4)))
#define RFC_CSU_DMAYNUMXNUM4                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x226*4)))
#define RFC_CSU_DMASIZEGRANALLNUM4                (*((volatile uint32_t *)(RFC_CSU_BASE+0x227*4)))
#define RFC_CSU_DMAADDRL5                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x228*4)))
#define RFC_CSU_DMAADDRH5                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x229*4)))
#define RFC_CSU_DMAYSTEPL5                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x22A*4)))
#define RFC_CSU_DMAYSTEPH5                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x22B*4)))
#define RFC_CSU_DMAZSTEPL5                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x22C*4)))
#define RFC_CSU_DMAZSTEPH5                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x22D*4)))
#define RFC_CSU_DMAYNUMXNUM5                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x22E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM5                (*((volatile uint32_t *)(RFC_CSU_BASE+0x22F*4)))
#define RFC_CSU_DMAADDRL6                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x230*4)))
#define RFC_CSU_DMAADDRH6                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x231*4)))
#define RFC_CSU_DMAYSTEPL6                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x232*4)))
#define RFC_CSU_DMAYSTEPH6                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x233*4)))
#define RFC_CSU_DMAZSTEPL6                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x234*4)))
#define RFC_CSU_DMAZSTEPH6                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x235*4)))
#define RFC_CSU_DMAYNUMXNUM6                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x236*4)))
#define RFC_CSU_DMASIZEGRANALLNUM6                (*((volatile uint32_t *)(RFC_CSU_BASE+0x237*4)))
#define RFC_CSU_DMAADDRL7                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x238*4)))
#define RFC_CSU_DMAADDRH7                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x239*4)))
#define RFC_CSU_DMAYSTEPL7                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x23A*4)))
#define RFC_CSU_DMAYSTEPH7                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x23B*4)))
#define RFC_CSU_DMAZSTEPL7                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x23C*4)))
#define RFC_CSU_DMAZSTEPH7                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x23D*4)))
#define RFC_CSU_DMAYNUMXNUM7                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x23E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM7                (*((volatile uint32_t *)(RFC_CSU_BASE+0x23F*4)))
#define RFC_CSU_DMAADDRL8                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x240*4)))
#define RFC_CSU_DMAADDRH8                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x241*4)))
#define RFC_CSU_DMAYSTEPL8                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x242*4)))
#define RFC_CSU_DMAYSTEPH8                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x243*4)))
#define RFC_CSU_DMAZSTEPL8                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x244*4)))
#define RFC_CSU_DMAZSTEPH8                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x245*4)))
#define RFC_CSU_DMAYNUMXNUM8                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x246*4)))
#define RFC_CSU_DMASIZEGRANALLNUM8                (*((volatile uint32_t *)(RFC_CSU_BASE+0x247*4)))
#define RFC_CSU_DMAADDRL9                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x248*4)))
#define RFC_CSU_DMAADDRH9                         (*((volatile uint32_t *)(RFC_CSU_BASE+0x249*4)))
#define RFC_CSU_DMAYSTEPL9                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x24A*4)))
#define RFC_CSU_DMAYSTEPH9                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x24B*4)))
#define RFC_CSU_DMAZSTEPL9                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x24C*4)))
#define RFC_CSU_DMAZSTEPH9                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x24D*4)))
#define RFC_CSU_DMAYNUMXNUM9                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x24E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM9                (*((volatile uint32_t *)(RFC_CSU_BASE+0x24F*4)))
#define RFC_CSU_DMAADDRL10                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x250*4)))
#define RFC_CSU_DMAADDRH10                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x251*4)))
#define RFC_CSU_DMAYSTEPL10                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x252*4)))
#define RFC_CSU_DMAYSTEPH10                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x253*4)))
#define RFC_CSU_DMAZSTEPL10                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x254*4)))
#define RFC_CSU_DMAZSTEPH10                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x255*4)))
#define RFC_CSU_DMAYNUMXNUM10                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x256*4)))
#define RFC_CSU_DMASIZEGRANALLNUM10               (*((volatile uint32_t *)(RFC_CSU_BASE+0x257*4)))
#define RFC_CSU_DMAADDRL11                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x258*4)))
#define RFC_CSU_DMAADDRH11                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x259*4)))
#define RFC_CSU_DMAYSTEPL11                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x25A*4)))
#define RFC_CSU_DMAYSTEPH11                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x25B*4)))
#define RFC_CSU_DMAZSTEPL11                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x25C*4)))
#define RFC_CSU_DMAZSTEPH11                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x25D*4)))
#define RFC_CSU_DMAYNUMXNUM11                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x25E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM11               (*((volatile uint32_t *)(RFC_CSU_BASE+0x25F*4)))
#define RFC_CSU_DMAADDRL12                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x260*4)))
#define RFC_CSU_DMAADDRH12                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x261*4)))
#define RFC_CSU_DMAYSTEPL12                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x262*4)))
#define RFC_CSU_DMAYSTEPH12                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x263*4)))
#define RFC_CSU_DMAZSTEPL12                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x264*4)))
#define RFC_CSU_DMAZSTEPH12                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x265*4)))
#define RFC_CSU_DMAYNUMXNUM12                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x266*4)))
#define RFC_CSU_DMASIZEGRANALLNUM12               (*((volatile uint32_t *)(RFC_CSU_BASE+0x267*4)))
#define RFC_CSU_DMAADDRL13                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x268*4)))
#define RFC_CSU_DMAADDRH13                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x269*4)))
#define RFC_CSU_DMAYSTEPL13                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x26A*4)))
#define RFC_CSU_DMAYSTEPH13                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x26B*4)))
#define RFC_CSU_DMAZSTEPL13                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x26C*4)))
#define RFC_CSU_DMAZSTEPH13                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x26D*4)))
#define RFC_CSU_DMAYNUMXNUM13                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x26E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM13               (*((volatile uint32_t *)(RFC_CSU_BASE+0x26F*4)))
#define RFC_CSU_DMAADDRL14                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x270*4)))
#define RFC_CSU_DMAADDRH14                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x271*4)))
#define RFC_CSU_DMAYSTEPL14                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x272*4)))
#define RFC_CSU_DMAYSTEPH14                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x273*4)))
#define RFC_CSU_DMAZSTEPL14                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x274*4)))
#define RFC_CSU_DMAZSTEPH14                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x275*4)))
#define RFC_CSU_DMAYNUMXNUM14                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x276*4)))
#define RFC_CSU_DMASIZEGRANALLNUM14               (*((volatile uint32_t *)(RFC_CSU_BASE+0x277*4)))
#define RFC_CSU_DMAADDRL15                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x278*4)))
#define RFC_CSU_DMAADDRH15                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x279*4)))
#define RFC_CSU_DMAYSTEPL15                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x27A*4)))
#define RFC_CSU_DMAYSTEPH15                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x27B*4)))
#define RFC_CSU_DMAZSTEPL15                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x27C*4)))
#define RFC_CSU_DMAZSTEPH15                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x27D*4)))
#define RFC_CSU_DMAYNUMXNUM15                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x27E*4)))
#define RFC_CSU_DMASIZEGRANALLNUM15               (*((volatile uint32_t *)(RFC_CSU_BASE+0x27F*4)))
#define RFC_CSU_QOUCMDNUM_QOUCMDPOS               (*((volatile uint32_t *)(RFC_CSU_BASE+0x300*4)))
#define RFC_CSU_QOUCMDADDR                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x301*4)))
#define RFC_CSU_QOUCMDDATA                        (*((volatile uint32_t *)(RFC_CSU_BASE+0x302*4)))
#define RFC_CSU_QOUSTATUSPOPDATA                  (*((volatile uint32_t *)(RFC_CSU_BASE+0x303*4)))
#define RFC_CSU_QOUCMPDATA0                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x304*4)))
#define RFC_CSU_QOUCMPDATA1                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x305*4)))
#define RFC_CSU_QOUCMPDATA2                       (*((volatile uint32_t *)(RFC_CSU_BASE+0x306*4)))
#define RFC_CSU_PRICMDDATA_L32BIT0                (*((volatile uint32_t *)(RFC_CSU_BASE+0x310*4)))
#define RFC_CSU_PRICMDDATA_H14BIT0                (*((volatile uint32_t *)(RFC_CSU_BASE+0x311*4)))
#define RFC_CSU_PRICMDDATA_L32BIT1                (*((volatile uint32_t *)(RFC_CSU_BASE+0x312*4)))
#define RFC_CSU_PRICMDDATA_H14BIT1                (*((volatile uint32_t *)(RFC_CSU_BASE+0x313*4)))
#define RFC_CSU_PRICMDDATA_L32BIT2                (*((volatile uint32_t *)(RFC_CSU_BASE+0x314*4)))
#define RFC_CSU_PRICMDDATA_H14BIT2                (*((volatile uint32_t *)(RFC_CSU_BASE+0x315*4)))
#define RFC_CSU_SORTDATA_NUM                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x380*4)))
#define RFC_CSU_SORTDATA_DATA0                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C0*4)))
#define RFC_CSU_SORTDATA_DATA1                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C1*4)))
#define RFC_CSU_SORTDATA_DATA2                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C2*4)))
#define RFC_CSU_SORTDATA_DATA3                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C3*4)))
#define RFC_CSU_SORTDATA_DATA4                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C4*4)))
#define RFC_CSU_SORTDATA_DATA5                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C5*4)))
#define RFC_CSU_SORTDATA_DATA6                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C6*4)))
#define RFC_CSU_SORTDATA_DATA7                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C7*4)))
#define RFC_CSU_SORTDATA_DATA8                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C8*4)))
#define RFC_CSU_SORTDATA_DATA9                    (*((volatile uint32_t *)(RFC_CSU_BASE+0x3C9*4)))
#define RFC_CSU_SORTDATA_DATA10                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CA*4)))
#define RFC_CSU_SORTDATA_DATA11                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CB*4)))
#define RFC_CSU_SORTDATA_DATA12                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CC*4)))
#define RFC_CSU_SORTDATA_DATA13                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CD*4)))
#define RFC_CSU_SORTDATA_DATA14                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CE*4)))
#define RFC_CSU_SORTDATA_DATA15                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3CF*4)))
#define RFC_CSU_SORTDATA_DATA16                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D0*4)))
#define RFC_CSU_SORTDATA_DATA17                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D1*4)))
#define RFC_CSU_SORTDATA_DATA18                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D2*4)))
#define RFC_CSU_SORTDATA_DATA19                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D3*4)))
#define RFC_CSU_SORTDATA_DATA20                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D4*4)))
#define RFC_CSU_SORTDATA_DATA21                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D5*4)))
#define RFC_CSU_SORTDATA_DATA22                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D6*4)))
#define RFC_CSU_SORTDATA_DATA23                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D7*4)))
#define RFC_CSU_SORTDATA_DATA24                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D8*4)))
#define RFC_CSU_SORTDATA_DATA25                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3D9*4)))
#define RFC_CSU_SORTDATA_DATA26                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DA*4)))
#define RFC_CSU_SORTDATA_DATA27                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DB*4)))
#define RFC_CSU_SORTDATA_DATA28                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DC*4)))
#define RFC_CSU_SORTDATA_DATA29                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DD*4)))
#define RFC_CSU_SORTDATA_DATA30                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DE*4)))
#define RFC_CSU_SORTDATA_DATA31                   (*((volatile uint32_t *)(RFC_CSU_BASE+0x3DF*4)))
#define RFC_CSU_SORTDATA_ID0                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E0*4)))
#define RFC_CSU_SORTDATA_ID1                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E1*4)))
#define RFC_CSU_SORTDATA_ID2                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E2*4)))
#define RFC_CSU_SORTDATA_ID3                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E3*4)))
#define RFC_CSU_SORTDATA_ID4                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E4*4)))
#define RFC_CSU_SORTDATA_ID5                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E5*4)))
#define RFC_CSU_SORTDATA_ID6                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E6*4)))
#define RFC_CSU_SORTDATA_ID7                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E7*4)))
#define RFC_CSU_SORTDATA_ID8                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E8*4)))
#define RFC_CSU_SORTDATA_ID9                      (*((volatile uint32_t *)(RFC_CSU_BASE+0x3E9*4)))
#define RFC_CSU_SORTDATA_ID10                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3EA*4)))
#define RFC_CSU_SORTDATA_ID11                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3EB*4)))
#define RFC_CSU_SORTDATA_ID12                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3EC*4)))
#define RFC_CSU_SORTDATA_ID13                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3ED*4)))
#define RFC_CSU_SORTDATA_ID14                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3EE*4)))
#define RFC_CSU_SORTDATA_ID15                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3EF*4)))
#define RFC_CSU_SORTDATA_ID16                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F0*4)))
#define RFC_CSU_SORTDATA_ID17                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F1*4)))
#define RFC_CSU_SORTDATA_ID18                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F2*4)))
#define RFC_CSU_SORTDATA_ID19                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F3*4)))
#define RFC_CSU_SORTDATA_ID20                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F4*4)))
#define RFC_CSU_SORTDATA_ID21                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F5*4)))
#define RFC_CSU_SORTDATA_ID22                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F6*4)))
#define RFC_CSU_SORTDATA_ID23                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F7*4)))
#define RFC_CSU_SORTDATA_ID24                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F8*4)))
#define RFC_CSU_SORTDATA_ID25                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3F9*4)))
#define RFC_CSU_SORTDATA_ID26                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FA*4)))
#define RFC_CSU_SORTDATA_ID27                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FB*4)))
#define RFC_CSU_SORTDATA_ID28                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FC*4)))
#define RFC_CSU_SORTDATA_ID29                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FD*4)))
#define RFC_CSU_SORTDATA_ID30                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FE*4)))
#define RFC_CSU_SORTDATA_ID31                     (*((volatile uint32_t *)(RFC_CSU_BASE+0x3FF*4)))


#define JS_CSU_ALLPENDEVENTMASK                   (*((volatile uint32_t *)(JS_CSU_BASE+0x000*4)))
#define JS_CSU_EVENTMASK                          (*((volatile uint32_t *)(JS_CSU_BASE+0x002*4)))
#define JS_CSU_LATCHALFULL                        (*((volatile uint32_t *)(JS_CSU_BASE+0x003*4)))
#define JS_CSU_INTMASK                            (*((volatile uint32_t *)(JS_CSU_BASE+0x004*4)))
#define JS_CSU_ELEVELMASK                         (*((volatile uint32_t *)(JS_CSU_BASE+0x005*4)))
#define JS_CSU_TAGMASK0                           (*((volatile uint32_t *)(JS_CSU_BASE+0x006*4)))
#define JS_CSU_TAGMASK1                           (*((volatile uint32_t *)(JS_CSU_BASE+0x007*4)))
#define JS_CSU_TAGMASK2                           (*((volatile uint32_t *)(JS_CSU_BASE+0x008*4)))
#define JS_CSU_TAGMASK3                           (*((volatile uint32_t *)(JS_CSU_BASE+0x009*4)))
#define JS_CSU_ARMCMDRECV                         (*((volatile uint32_t *)(JS_CSU_BASE+0x00A*4)))
#define JS_CSU_ALLPENDEVENT0                      (*((volatile uint32_t *)(JS_CSU_BASE+0x00C*4)))
#define JS_CSU_ALLPENDEVENT1                      (*((volatile uint32_t *)(JS_CSU_BASE+0x00D*4)))
#define JS_CSU_EM_BS_SMSEL_PREDATANUM             (*((volatile uint32_t *)(JS_CSU_BASE+0x010*4)))
#define JS_CSU_ALMOSTFULLSENDTHRED                (*((volatile uint32_t *)(JS_CSU_BASE+0x011*4)))
#define JS_CSU_JESDTX0SET                          (*((volatile uint32_t *)(JS_CSU_BASE+0x012*4)))
#define JS_CSU_JESDRX0SET                         (*((volatile uint32_t *)(JS_CSU_BASE+0x013*4)))
#define JS_CSU_FINDDMATAG                         (*((volatile uint32_t *)(JS_CSU_BASE+0x014*4)))
#define JS_CSU_JESDTX1SET                         (*((volatile uint32_t *)(JS_CSU_BASE+0x016*4)))
#define JS_CSU_JESDRX1SET                         (*((volatile uint32_t *)(JS_CSU_BASE+0x017*4)))
#define JS_CSU_CMDFIFO0_CMD                       (*((volatile uint32_t *)(JS_CSU_BASE+0x018*4)))
#define JS_CSU_CMDFIFO1_CMD                       (*((volatile uint32_t *)(JS_CSU_BASE+0x019*4)))
#define JS_CSU_CMDFIFO2_CMD                       (*((volatile uint32_t *)(JS_CSU_BASE+0x01A*4)))
#define JS_CSU_CMDFIFO0_NUM                       (*((volatile uint32_t *)(JS_CSU_BASE+0x01C*4)))
#define JS_CSU_CMDFIFO1_NUM                       (*((volatile uint32_t *)(JS_CSU_BASE+0x01D*4)))
#define JS_CSU_CMDFIFO2_NUM                       (*((volatile uint32_t *)(JS_CSU_BASE+0x01E*4)))
#define JS_CSU_PRICMDVALID0                       (*((volatile uint32_t *)(JS_CSU_BASE+0x020*4)))
#define JS_CSU_PRICMDVALID1                       (*((volatile uint32_t *)(JS_CSU_BASE+0x021*4)))
#define JS_CSU_PRICMDVALID2                       (*((volatile uint32_t *)(JS_CSU_BASE+0x022*4)))
#define JS_CSU_CMDECODATAL32BIT0                  (*((volatile uint32_t *)(JS_CSU_BASE+0x024*4)))
#define JS_CSU_CMDECODATAL32BIT1                  (*((volatile uint32_t *)(JS_CSU_BASE+0x025*4)))
#define JS_CSU_CMDECODATAL32BIT2                  (*((volatile uint32_t *)(JS_CSU_BASE+0x026*4)))
#define JS_CSU_CMDHIGHDATA                        (*((volatile uint32_t *)(JS_CSU_BASE+0x028*4)))
#define JS_CSU_CMDFIFO0                           (*((volatile uint32_t *)(JS_CSU_BASE+0x02C*4)))
#define JS_CSU_CMDFIFO1                           (*((volatile uint32_t *)(JS_CSU_BASE+0x02D*4)))
#define JS_CSU_CMDFIFO2                           (*((volatile uint32_t *)(JS_CSU_BASE+0x02E*4)))
#define JS_CSU_READYLISTNUM                       (*((volatile uint32_t *)(JS_CSU_BASE+0x030*4)))
#define JS_CSU_CMDFIFO0_TAGNUM                    (*((volatile uint32_t *)(JS_CSU_BASE+0x034*4)))
#define JS_CSU_CMDFIFO1_TAGNUM                    (*((volatile uint32_t *)(JS_CSU_BASE+0x035*4)))
#define JS_CSU_CMDFIFO2_TAGNUM                    (*((volatile uint32_t *)(JS_CSU_BASE+0x036*4)))
#define JS_CSU_DMASTATUS                          (*((volatile uint32_t *)(JS_CSU_BASE+0x038*4)))
#define JS_CSU_CMDSTALL_LISTSTALL                 (*((volatile uint32_t *)(JS_CSU_BASE+0x039*4)))
#define JS_CSU_QOUSTATUS                          (*((volatile uint32_t *)(JS_CSU_BASE+0x03A*4)))
#define JS_CSU_EVENTINTCLEAR                      (*((volatile uint32_t *)(JS_CSU_BASE+0x03C*4)))
#define JS_CSU_DMAADDRL0                          (*((volatile uint32_t *)(JS_CSU_BASE+0x200*4)))
#define JS_CSU_DMAADDRH0                          (*((volatile uint32_t *)(JS_CSU_BASE+0x201*4)))
#define JS_CSU_DMAYSTEPL0                         (*((volatile uint32_t *)(JS_CSU_BASE+0x202*4)))
#define JS_CSU_DMAYSTEPH0                         (*((volatile uint32_t *)(JS_CSU_BASE+0x203*4)))
#define JS_CSU_DMAZSTEPL0                         (*((volatile uint32_t *)(JS_CSU_BASE+0x204*4)))
#define JS_CSU_DMAZSTEPH0                         (*((volatile uint32_t *)(JS_CSU_BASE+0x205*4)))
#define JS_CSU_DMAYNUMXNUM0                       (*((volatile uint32_t *)(JS_CSU_BASE+0x206*4)))
#define JS_CSU_DMASIZEGRANALLNUM0                 (*((volatile uint32_t *)(JS_CSU_BASE+0x207*4)))
#define JS_CSU_DMAADDRL1                          (*((volatile uint32_t *)(JS_CSU_BASE+0x208*4)))
#define JS_CSU_DMAADDRH1                          (*((volatile uint32_t *)(JS_CSU_BASE+0x209*4)))
#define JS_CSU_DMAYSTEPL1                         (*((volatile uint32_t *)(JS_CSU_BASE+0x20A*4)))
#define JS_CSU_DMAYSTEPH1                         (*((volatile uint32_t *)(JS_CSU_BASE+0x20B*4)))
#define JS_CSU_DMAZSTEPL1                         (*((volatile uint32_t *)(JS_CSU_BASE+0x20C*4)))
#define JS_CSU_DMAZSTEPH1                         (*((volatile uint32_t *)(JS_CSU_BASE+0x20D*4)))
#define JS_CSU_DMAYNUMXNUM1                       (*((volatile uint32_t *)(JS_CSU_BASE+0x20E*4)))
#define JS_CSU_DMASIZEGRANALLNUM1                 (*((volatile uint32_t *)(JS_CSU_BASE+0x20F*4)))
#define JS_CSU_DMAADDRL2                          (*((volatile uint32_t *)(JS_CSU_BASE+0x210*4)))
#define JS_CSU_DMAADDRH2                          (*((volatile uint32_t *)(JS_CSU_BASE+0x211*4)))
#define JS_CSU_DMAYSTEPL2                         (*((volatile uint32_t *)(JS_CSU_BASE+0x212*4)))
#define JS_CSU_DMAYSTEPH2                         (*((volatile uint32_t *)(JS_CSU_BASE+0x213*4)))
#define JS_CSU_DMAZSTEPL2                         (*((volatile uint32_t *)(JS_CSU_BASE+0x214*4)))
#define JS_CSU_DMAZSTEPH2                         (*((volatile uint32_t *)(JS_CSU_BASE+0x215*4)))
#define JS_CSU_DMAYNUMXNUM2                       (*((volatile uint32_t *)(JS_CSU_BASE+0x216*4)))
#define JS_CSU_DMASIZEGRANALLNUM2                 (*((volatile uint32_t *)(JS_CSU_BASE+0x217*4)))
#define JS_CSU_DMAADDRL3                          (*((volatile uint32_t *)(JS_CSU_BASE+0x218*4)))
#define JS_CSU_DMAADDRH3                          (*((volatile uint32_t *)(JS_CSU_BASE+0x219*4)))
#define JS_CSU_DMAYSTEPL3                         (*((volatile uint32_t *)(JS_CSU_BASE+0x21A*4)))
#define JS_CSU_DMAYSTEPH3                         (*((volatile uint32_t *)(JS_CSU_BASE+0x21B*4)))
#define JS_CSU_DMAZSTEPL3                         (*((volatile uint32_t *)(JS_CSU_BASE+0x21C*4)))
#define JS_CSU_DMAZSTEPH3                         (*((volatile uint32_t *)(JS_CSU_BASE+0x21D*4)))
#define JS_CSU_DMAYNUMXNUM3                       (*((volatile uint32_t *)(JS_CSU_BASE+0x21E*4)))
#define JS_CSU_DMASIZEGRANALLNUM3                 (*((volatile uint32_t *)(JS_CSU_BASE+0x21F*4)))
#define JS_CSU_DMAADDRL4                          (*((volatile uint32_t *)(JS_CSU_BASE+0x220*4)))
#define JS_CSU_DMAADDRH4                          (*((volatile uint32_t *)(JS_CSU_BASE+0x221*4)))
#define JS_CSU_DMAYSTEPL4                         (*((volatile uint32_t *)(JS_CSU_BASE+0x222*4)))
#define JS_CSU_DMAYSTEPH4                         (*((volatile uint32_t *)(JS_CSU_BASE+0x223*4)))
#define JS_CSU_DMAZSTEPL4                         (*((volatile uint32_t *)(JS_CSU_BASE+0x224*4)))
#define JS_CSU_DMAZSTEPH4                         (*((volatile uint32_t *)(JS_CSU_BASE+0x225*4)))
#define JS_CSU_DMAYNUMXNUM4                       (*((volatile uint32_t *)(JS_CSU_BASE+0x226*4)))
#define JS_CSU_DMASIZEGRANALLNUM4                 (*((volatile uint32_t *)(JS_CSU_BASE+0x227*4)))
#define JS_CSU_DMAADDRL5                          (*((volatile uint32_t *)(JS_CSU_BASE+0x228*4)))
#define JS_CSU_DMAADDRH5                          (*((volatile uint32_t *)(JS_CSU_BASE+0x229*4)))
#define JS_CSU_DMAYSTEPL5                         (*((volatile uint32_t *)(JS_CSU_BASE+0x22A*4)))
#define JS_CSU_DMAYSTEPH5                         (*((volatile uint32_t *)(JS_CSU_BASE+0x22B*4)))
#define JS_CSU_DMAZSTEPL5                         (*((volatile uint32_t *)(JS_CSU_BASE+0x22C*4)))
#define JS_CSU_DMAZSTEPH5                         (*((volatile uint32_t *)(JS_CSU_BASE+0x22D*4)))
#define JS_CSU_DMAYNUMXNUM5                       (*((volatile uint32_t *)(JS_CSU_BASE+0x22E*4)))
#define JS_CSU_DMASIZEGRANALLNUM5                 (*((volatile uint32_t *)(JS_CSU_BASE+0x22F*4)))
#define JS_CSU_DMAADDRL6                          (*((volatile uint32_t *)(JS_CSU_BASE+0x230*4)))
#define JS_CSU_DMAADDRH6                          (*((volatile uint32_t *)(JS_CSU_BASE+0x231*4)))
#define JS_CSU_DMAYSTEPL6                         (*((volatile uint32_t *)(JS_CSU_BASE+0x232*4)))
#define JS_CSU_DMAYSTEPH6                         (*((volatile uint32_t *)(JS_CSU_BASE+0x233*4)))
#define JS_CSU_DMAZSTEPL6                         (*((volatile uint32_t *)(JS_CSU_BASE+0x234*4)))
#define JS_CSU_DMAZSTEPH6                         (*((volatile uint32_t *)(JS_CSU_BASE+0x235*4)))
#define JS_CSU_DMAYNUMXNUM6                       (*((volatile uint32_t *)(JS_CSU_BASE+0x236*4)))
#define JS_CSU_DMASIZEGRANALLNUM6                 (*((volatile uint32_t *)(JS_CSU_BASE+0x237*4)))
#define JS_CSU_DMAADDRL7                          (*((volatile uint32_t *)(JS_CSU_BASE+0x238*4)))
#define JS_CSU_DMAADDRH7                          (*((volatile uint32_t *)(JS_CSU_BASE+0x239*4)))
#define JS_CSU_DMAYSTEPL7                         (*((volatile uint32_t *)(JS_CSU_BASE+0x23A*4)))
#define JS_CSU_DMAYSTEPH7                         (*((volatile uint32_t *)(JS_CSU_BASE+0x23B*4)))
#define JS_CSU_DMAZSTEPL7                         (*((volatile uint32_t *)(JS_CSU_BASE+0x23C*4)))
#define JS_CSU_DMAZSTEPH7                         (*((volatile uint32_t *)(JS_CSU_BASE+0x23D*4)))
#define JS_CSU_DMAYNUMXNUM7                       (*((volatile uint32_t *)(JS_CSU_BASE+0x23E*4)))
#define JS_CSU_DMASIZEGRANALLNUM7                 (*((volatile uint32_t *)(JS_CSU_BASE+0x23F*4)))
#define JS_CSU_DMAADDRL8                          (*((volatile uint32_t *)(JS_CSU_BASE+0x240*4)))
#define JS_CSU_DMAADDRH8                          (*((volatile uint32_t *)(JS_CSU_BASE+0x241*4)))
#define JS_CSU_DMAYSTEPL8                         (*((volatile uint32_t *)(JS_CSU_BASE+0x242*4)))
#define JS_CSU_DMAYSTEPH8                         (*((volatile uint32_t *)(JS_CSU_BASE+0x243*4)))
#define JS_CSU_DMAZSTEPL8                         (*((volatile uint32_t *)(JS_CSU_BASE+0x244*4)))
#define JS_CSU_DMAZSTEPH8                         (*((volatile uint32_t *)(JS_CSU_BASE+0x245*4)))
#define JS_CSU_DMAYNUMXNUM8                       (*((volatile uint32_t *)(JS_CSU_BASE+0x246*4)))
#define JS_CSU_DMASIZEGRANALLNUM8                 (*((volatile uint32_t *)(JS_CSU_BASE+0x247*4)))
#define JS_CSU_DMAADDRL9                          (*((volatile uint32_t *)(JS_CSU_BASE+0x248*4)))
#define JS_CSU_DMAADDRH9                          (*((volatile uint32_t *)(JS_CSU_BASE+0x249*4)))
#define JS_CSU_DMAYSTEPL9                         (*((volatile uint32_t *)(JS_CSU_BASE+0x24A*4)))
#define JS_CSU_DMAYSTEPH9                         (*((volatile uint32_t *)(JS_CSU_BASE+0x24B*4)))
#define JS_CSU_DMAZSTEPL9                         (*((volatile uint32_t *)(JS_CSU_BASE+0x24C*4)))
#define JS_CSU_DMAZSTEPH9                         (*((volatile uint32_t *)(JS_CSU_BASE+0x24D*4)))
#define JS_CSU_DMAYNUMXNUM9                       (*((volatile uint32_t *)(JS_CSU_BASE+0x24E*4)))
#define JS_CSU_DMASIZEGRANALLNUM9                 (*((volatile uint32_t *)(JS_CSU_BASE+0x24F*4)))
#define JS_CSU_DMAADDRL10                         (*((volatile uint32_t *)(JS_CSU_BASE+0x250*4)))
#define JS_CSU_DMAADDRH10                         (*((volatile uint32_t *)(JS_CSU_BASE+0x251*4)))
#define JS_CSU_DMAYSTEPL10                        (*((volatile uint32_t *)(JS_CSU_BASE+0x252*4)))
#define JS_CSU_DMAYSTEPH10                        (*((volatile uint32_t *)(JS_CSU_BASE+0x253*4)))
#define JS_CSU_DMAZSTEPL10                        (*((volatile uint32_t *)(JS_CSU_BASE+0x254*4)))
#define JS_CSU_DMAZSTEPH10                        (*((volatile uint32_t *)(JS_CSU_BASE+0x255*4)))
#define JS_CSU_DMAYNUMXNUM10                      (*((volatile uint32_t *)(JS_CSU_BASE+0x256*4)))
#define JS_CSU_DMASIZEGRANALLNUM10                (*((volatile uint32_t *)(JS_CSU_BASE+0x257*4)))
#define JS_CSU_DMAADDRL11                         (*((volatile uint32_t *)(JS_CSU_BASE+0x258*4)))
#define JS_CSU_DMAADDRH11                         (*((volatile uint32_t *)(JS_CSU_BASE+0x259*4)))
#define JS_CSU_DMAYSTEPL11                        (*((volatile uint32_t *)(JS_CSU_BASE+0x25A*4)))
#define JS_CSU_DMAYSTEPH11                        (*((volatile uint32_t *)(JS_CSU_BASE+0x25B*4)))
#define JS_CSU_DMAZSTEPL11                        (*((volatile uint32_t *)(JS_CSU_BASE+0x25C*4)))
#define JS_CSU_DMAZSTEPH11                        (*((volatile uint32_t *)(JS_CSU_BASE+0x25D*4)))
#define JS_CSU_DMAYNUMXNUM11                      (*((volatile uint32_t *)(JS_CSU_BASE+0x25E*4)))
#define JS_CSU_DMASIZEGRANALLNUM11                (*((volatile uint32_t *)(JS_CSU_BASE+0x25F*4)))
#define JS_CSU_DMAADDRL12                         (*((volatile uint32_t *)(JS_CSU_BASE+0x260*4)))
#define JS_CSU_DMAADDRH12                         (*((volatile uint32_t *)(JS_CSU_BASE+0x261*4)))
#define JS_CSU_DMAYSTEPL12                        (*((volatile uint32_t *)(JS_CSU_BASE+0x262*4)))
#define JS_CSU_DMAYSTEPH12                        (*((volatile uint32_t *)(JS_CSU_BASE+0x263*4)))
#define JS_CSU_DMAZSTEPL12                        (*((volatile uint32_t *)(JS_CSU_BASE+0x264*4)))
#define JS_CSU_DMAZSTEPH12                        (*((volatile uint32_t *)(JS_CSU_BASE+0x265*4)))
#define JS_CSU_DMAYNUMXNUM12                      (*((volatile uint32_t *)(JS_CSU_BASE+0x266*4)))
#define JS_CSU_DMASIZEGRANALLNUM12                (*((volatile uint32_t *)(JS_CSU_BASE+0x267*4)))
#define JS_CSU_DMAADDRL13                         (*((volatile uint32_t *)(JS_CSU_BASE+0x268*4)))
#define JS_CSU_DMAADDRH13                         (*((volatile uint32_t *)(JS_CSU_BASE+0x269*4)))
#define JS_CSU_DMAYSTEPL13                        (*((volatile uint32_t *)(JS_CSU_BASE+0x26A*4)))
#define JS_CSU_DMAYSTEPH13                        (*((volatile uint32_t *)(JS_CSU_BASE+0x26B*4)))
#define JS_CSU_DMAZSTEPL13                        (*((volatile uint32_t *)(JS_CSU_BASE+0x26C*4)))
#define JS_CSU_DMAZSTEPH13                        (*((volatile uint32_t *)(JS_CSU_BASE+0x26D*4)))
#define JS_CSU_DMAYNUMXNUM13                      (*((volatile uint32_t *)(JS_CSU_BASE+0x26E*4)))
#define JS_CSU_DMASIZEGRANALLNUM13                (*((volatile uint32_t *)(JS_CSU_BASE+0x26F*4)))
#define JS_CSU_DMAADDRL14                         (*((volatile uint32_t *)(JS_CSU_BASE+0x270*4)))
#define JS_CSU_DMAADDRH14                         (*((volatile uint32_t *)(JS_CSU_BASE+0x271*4)))
#define JS_CSU_DMAYSTEPL14                        (*((volatile uint32_t *)(JS_CSU_BASE+0x272*4)))
#define JS_CSU_DMAYSTEPH14                        (*((volatile uint32_t *)(JS_CSU_BASE+0x273*4)))
#define JS_CSU_DMAZSTEPL14                        (*((volatile uint32_t *)(JS_CSU_BASE+0x274*4)))
#define JS_CSU_DMAZSTEPH14                        (*((volatile uint32_t *)(JS_CSU_BASE+0x275*4)))
#define JS_CSU_DMAYNUMXNUM14                      (*((volatile uint32_t *)(JS_CSU_BASE+0x276*4)))
#define JS_CSU_DMASIZEGRANALLNUM14                (*((volatile uint32_t *)(JS_CSU_BASE+0x277*4)))
#define JS_CSU_DMAADDRL15                         (*((volatile uint32_t *)(JS_CSU_BASE+0x278*4)))
#define JS_CSU_DMAADDRH15                         (*((volatile uint32_t *)(JS_CSU_BASE+0x279*4)))
#define JS_CSU_DMAYSTEPL15                        (*((volatile uint32_t *)(JS_CSU_BASE+0x27A*4)))
#define JS_CSU_DMAYSTEPH15                        (*((volatile uint32_t *)(JS_CSU_BASE+0x27B*4)))
#define JS_CSU_DMAZSTEPL15                        (*((volatile uint32_t *)(JS_CSU_BASE+0x27C*4)))
#define JS_CSU_DMAZSTEPH15                        (*((volatile uint32_t *)(JS_CSU_BASE+0x27D*4)))
#define JS_CSU_DMAYNUMXNUM15                      (*((volatile uint32_t *)(JS_CSU_BASE+0x27E*4)))
#define JS_CSU_DMASIZEGRANALLNUM15                (*((volatile uint32_t *)(JS_CSU_BASE+0x27F*4)))
#define JS_CSU_QOUCMDNUM_QOUCMDPOS                (*((volatile uint32_t *)(JS_CSU_BASE+0x300*4)))
#define JS_CSU_QOUCMDADDR                         (*((volatile uint32_t *)(JS_CSU_BASE+0x301*4)))
#define JS_CSU_QOUCMDDATA                         (*((volatile uint32_t *)(JS_CSU_BASE+0x302*4)))
#define JS_CSU_QOUSTATUSPOPDATA                   (*((volatile uint32_t *)(JS_CSU_BASE+0x303*4)))
#define JS_CSU_QOUCMPDATA0                        (*((volatile uint32_t *)(JS_CSU_BASE+0x304*4)))
#define JS_CSU_QOUCMPDATA1                        (*((volatile uint32_t *)(JS_CSU_BASE+0x305*4)))
#define JS_CSU_QOUCMPDATA2                        (*((volatile uint32_t *)(JS_CSU_BASE+0x306*4)))
#define JS_CSU_PRICMDDATA_L32BIT0                 (*((volatile uint32_t *)(JS_CSU_BASE+0x310*4)))
#define JS_CSU_PRICMDDATA_H14BIT0                 (*((volatile uint32_t *)(JS_CSU_BASE+0x311*4)))
#define JS_CSU_PRICMDDATA_L32BIT1                 (*((volatile uint32_t *)(JS_CSU_BASE+0x312*4)))
#define JS_CSU_PRICMDDATA_H14BIT1                 (*((volatile uint32_t *)(JS_CSU_BASE+0x313*4)))
#define JS_CSU_PRICMDDATA_L32BIT2                 (*((volatile uint32_t *)(JS_CSU_BASE+0x314*4)))
#define JS_CSU_PRICMDDATA_H14BIT2                 (*((volatile uint32_t *)(JS_CSU_BASE+0x315*4)))
#define JS_CSU_SORTDATA_NUM                       (*((volatile uint32_t *)(JS_CSU_BASE+0x380*4)))
#define JS_CSU_SORTDATA_DATA0                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C0*4)))
#define JS_CSU_SORTDATA_DATA1                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C1*4)))
#define JS_CSU_SORTDATA_DATA2                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C2*4)))
#define JS_CSU_SORTDATA_DATA3                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C3*4)))
#define JS_CSU_SORTDATA_DATA4                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C4*4)))
#define JS_CSU_SORTDATA_DATA5                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C5*4)))
#define JS_CSU_SORTDATA_DATA6                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C6*4)))
#define JS_CSU_SORTDATA_DATA7                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C7*4)))
#define JS_CSU_SORTDATA_DATA8                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C8*4)))
#define JS_CSU_SORTDATA_DATA9                     (*((volatile uint32_t *)(JS_CSU_BASE+0x3C9*4)))
#define JS_CSU_SORTDATA_DATA10                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CA*4)))
#define JS_CSU_SORTDATA_DATA11                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CB*4)))
#define JS_CSU_SORTDATA_DATA12                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CC*4)))
#define JS_CSU_SORTDATA_DATA13                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CD*4)))
#define JS_CSU_SORTDATA_DATA14                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CE*4)))
#define JS_CSU_SORTDATA_DATA15                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3CF*4)))
#define JS_CSU_SORTDATA_DATA16                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D0*4)))
#define JS_CSU_SORTDATA_DATA17                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D1*4)))
#define JS_CSU_SORTDATA_DATA18                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D2*4)))
#define JS_CSU_SORTDATA_DATA19                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D3*4)))
#define JS_CSU_SORTDATA_DATA20                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D4*4)))
#define JS_CSU_SORTDATA_DATA21                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D5*4)))
#define JS_CSU_SORTDATA_DATA22                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D6*4)))
#define JS_CSU_SORTDATA_DATA23                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D7*4)))
#define JS_CSU_SORTDATA_DATA24                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D8*4)))
#define JS_CSU_SORTDATA_DATA25                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3D9*4)))
#define JS_CSU_SORTDATA_DATA26                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DA*4)))
#define JS_CSU_SORTDATA_DATA27                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DB*4)))
#define JS_CSU_SORTDATA_DATA28                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DC*4)))
#define JS_CSU_SORTDATA_DATA29                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DD*4)))
#define JS_CSU_SORTDATA_DATA30                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DE*4)))
#define JS_CSU_SORTDATA_DATA31                    (*((volatile uint32_t *)(JS_CSU_BASE+0x3DF*4)))
#define JS_CSU_SORTDATA_ID0                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E0*4)))
#define JS_CSU_SORTDATA_ID1                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E1*4)))
#define JS_CSU_SORTDATA_ID2                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E2*4)))
#define JS_CSU_SORTDATA_ID3                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E3*4)))
#define JS_CSU_SORTDATA_ID4                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E4*4)))
#define JS_CSU_SORTDATA_ID5                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E5*4)))
#define JS_CSU_SORTDATA_ID6                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E6*4)))
#define JS_CSU_SORTDATA_ID7                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E7*4)))
#define JS_CSU_SORTDATA_ID8                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E8*4)))
#define JS_CSU_SORTDATA_ID9                       (*((volatile uint32_t *)(JS_CSU_BASE+0x3E9*4)))
#define JS_CSU_SORTDATA_ID10                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3EA*4)))
#define JS_CSU_SORTDATA_ID11                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3EB*4)))
#define JS_CSU_SORTDATA_ID12                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3EC*4)))
#define JS_CSU_SORTDATA_ID13                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3ED*4)))
#define JS_CSU_SORTDATA_ID14                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3EE*4)))
#define JS_CSU_SORTDATA_ID15                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3EF*4)))
#define JS_CSU_SORTDATA_ID16                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F0*4)))
#define JS_CSU_SORTDATA_ID17                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F1*4)))
#define JS_CSU_SORTDATA_ID18                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F2*4)))
#define JS_CSU_SORTDATA_ID19                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F3*4)))
#define JS_CSU_SORTDATA_ID20                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F4*4)))
#define JS_CSU_SORTDATA_ID21                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F5*4)))
#define JS_CSU_SORTDATA_ID22                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F6*4)))
#define JS_CSU_SORTDATA_ID23                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F7*4)))
#define JS_CSU_SORTDATA_ID24                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F8*4)))
#define JS_CSU_SORTDATA_ID25                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3F9*4)))
#define JS_CSU_SORTDATA_ID26                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FA*4)))
#define JS_CSU_SORTDATA_ID27                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FB*4)))
#define JS_CSU_SORTDATA_ID28                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FC*4)))
#define JS_CSU_SORTDATA_ID29                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FD*4)))
#define JS_CSU_SORTDATA_ID30                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FE*4)))
#define JS_CSU_SORTDATA_ID31                      (*((volatile uint32_t *)(JS_CSU_BASE+0x3FF*4)))


#define JECS_CSU_ALLPENDEVENTMASK                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x000*4)))
#define JECS_CSU_EVENTMASK                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x002*4)))
#define JECS_CSU_LATCHALFULL                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x003*4)))
#define JECS_CSU_INTMASK                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x004*4)))
#define JECS_CSU_ELEVELMASK                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x005*4)))
#define JECS_CSU_TAGMASK0                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x006*4)))
#define JECS_CSU_TAGMASK1                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x007*4)))
#define JECS_CSU_TAGMASK2                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x008*4)))
#define JECS_CSU_TAGMASK3                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x009*4)))
#define JECS_CSU_ARMCMDRECV                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x00A*4)))
#define JECS_CSU_ALLPENDEVENT0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x00C*4)))
#define JECS_CSU_ALLPENDEVENT1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x00D*4)))
#define JECS_CSU_AXCSTAMPL32BIT                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x00E*4)))
#define JECS_CSU_CTRLSTAMPL32BIT                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x00F*4)))
#define JECS_CSU_EM_BS_SMSEL_PREDATANUM           (*((volatile uint32_t *)(JECS_CSU_BASE+0x010*4)))
#define JECS_CSU_ALMOSTFULLSENDTHRED              (*((volatile uint32_t *)(JECS_CSU_BASE+0x011*4)))
#define JECS_CSU_FINDDMATAG                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x014*4)))
#define JECS_CSU_AXCSTAMPH32BIT                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x016*4)))
#define JECS_CSU_CTRLSTAMPH32BIT                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x017*4)))
#define JECS_CSU_CMDFIFO0_CMD                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x018*4)))
#define JECS_CSU_CMDFIFO1_CMD                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x019*4)))
#define JECS_CSU_CMDFIFO2_CMD                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01A*4)))
#define JECS_CSU_CMDFIFO3_CMD                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01B*4)))
#define JECS_CSU_CMDFIFO0_NUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01C*4)))
#define JECS_CSU_CMDFIFO1_NUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01D*4)))
#define JECS_CSU_CMDFIFO2_NUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01E*4)))
#define JECS_CSU_CMDFIFO3_NUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x01F*4)))
#define JECS_CSU_PRICMDVALID0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x020*4)))
#define JECS_CSU_PRICMDVALID1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x021*4)))
#define JECS_CSU_PRICMDVALID2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x022*4)))
#define JECS_CSU_PRICMDVALID3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x023*4)))
#define JECS_CSU_CMDECODATAL32BIT0                (*((volatile uint32_t *)(JECS_CSU_BASE+0x024*4)))
#define JECS_CSU_CMDECODATAL32BIT1                (*((volatile uint32_t *)(JECS_CSU_BASE+0x025*4)))
#define JECS_CSU_CMDECODATAL32BIT2                (*((volatile uint32_t *)(JECS_CSU_BASE+0x026*4)))
#define JECS_CSU_CMDECODATAL32BIT3                (*((volatile uint32_t *)(JECS_CSU_BASE+0x027*4)))
#define JECS_CSU_CMDHIGHDATA                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x028*4)))
#define JECS_CSU_CMDFIFO0                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x02C*4)))
#define JECS_CSU_CMDFIFO1                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x02D*4)))
#define JECS_CSU_CMDFIFO2                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x02E*4)))
#define JECS_CSU_CMDFIFO3                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x02F*4)))
#define JECS_CSU_READYLISTNUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x030*4)))
#define JECS_CSU_CMDFIFO0_TAGNUM                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x034*4)))
#define JECS_CSU_CMDFIFO1_TAGNUM                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x035*4)))
#define JECS_CSU_CMDFIFO2_TAGNUM                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x036*4)))
#define JECS_CSU_CMDFIFO3_TAGNUM                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x037*4)))
#define JECS_CSU_DMASTATUS                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x038*4)))
#define JECS_CSU_CMDSTALL_LISTSTALL               (*((volatile uint32_t *)(JECS_CSU_BASE+0x039*4)))
#define JECS_CSU_QOUSTATUS                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x03A*4)))
#define JECS_CSU_EVENTINTCLEAR                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x03C*4)))
#define JECS_CSU_XSTEPL0                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x140*4)))
#define JECS_CSU_XSTEPH0                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x141*4)))
#define JECS_CSU_XSTEPL1                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x142*4)))
#define JECS_CSU_XSTEPH1                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x143*4)))
#define JECS_CSU_XSTEPL2                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x144*4)))
#define JECS_CSU_XSTEPH2                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x145*4)))
#define JECS_CSU_XSTEPL3                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x146*4)))
#define JECS_CSU_XSTEPH3                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x147*4)))
#define JECS_CSU_XSTEPL4                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x148*4)))
#define JECS_CSU_XSTEPH4                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x149*4)))
#define JECS_CSU_XSTEPL5                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x150*4)))
#define JECS_CSU_XSTEPH5                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x151*4)))
#define JECS_CSU_XSTEPL6                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x152*4)))
#define JECS_CSU_XSTEPH6                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x153*4)))
#define JECS_CSU_XSTEPL7                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x154*4)))
#define JECS_CSU_XSTEPH7                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x155*4)))
#define JECS_CSU_XSTEPL8                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x156*4)))
#define JECS_CSU_XSTEPH8                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x157*4)))
#define JECS_CSU_XSTEPL9                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x158*4)))
#define JECS_CSU_XSTEPH9                          (*((volatile uint32_t *)(JECS_CSU_BASE+0x159*4)))
#define JECS_CSU_XSTEPL10                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x160*4)))
#define JECS_CSU_XSTEPH10                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x161*4)))
#define JECS_CSU_XSTEPL11                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x162*4)))
#define JECS_CSU_XSTEPH11                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x163*4)))
#define JECS_CSU_XSTEPL12                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x164*4)))
#define JECS_CSU_XSTEPH12                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x165*4)))
#define JECS_CSU_XSTEPL13                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x166*4)))
#define JECS_CSU_XSTEPH13                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x167*4)))
#define JECS_CSU_XSTEPL14                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x168*4)))
#define JECS_CSU_XSTEPH14                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x169*4)))
#define JECS_CSU_XSTEPL15                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x170*4)))
#define JECS_CSU_XSTEPH15                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x171*4)))
#define JECS_CSU_XSTEPL16                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x172*4)))
#define JECS_CSU_XSTEPH16                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x173*4)))
#define JECS_CSU_XSTEPL17                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x174*4)))
#define JECS_CSU_XSTEPH17                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x175*4)))
#define JECS_CSU_XSTEPL18                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x176*4)))
#define JECS_CSU_XSTEPH18                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x177*4)))
#define JECS_CSU_XSTEPL19                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x178*4)))
#define JECS_CSU_XSTEPH19                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x179*4)))
#define JECS_CSU_XSTEPL20                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x180*4)))
#define JECS_CSU_XSTEPH20                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x181*4)))
#define JECS_CSU_XSTEPL21                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x182*4)))
#define JECS_CSU_XSTEPH21                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x183*4)))
#define JECS_CSU_XSTEPL22                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x184*4)))
#define JECS_CSU_XSTEPH22                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x185*4)))
#define JECS_CSU_XSTEPL23                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x186*4)))
#define JECS_CSU_XSTEPH23                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x187*4)))
#define JECS_CSU_XSTEPL24                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x188*4)))
#define JECS_CSU_XSTEPH24                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x189*4)))
#define JECS_CSU_XSTEPL25                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x190*4)))
#define JECS_CSU_XSTEPH25                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x191*4)))
#define JECS_CSU_XSTEPL26                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x192*4)))
#define JECS_CSU_XSTEPH26                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x193*4)))
#define JECS_CSU_XSTEPL27                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x194*4)))
#define JECS_CSU_XSTEPH27                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x195*4)))
#define JECS_CSU_XSTEPL28                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x196*4)))
#define JECS_CSU_XSTEPH28                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x197*4)))
#define JECS_CSU_XSTEPL29                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x198*4)))
#define JECS_CSU_XSTEPH29                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x199*4)))
#define JECS_CSU_XSTEPL30                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x1A0*4)))
#define JECS_CSU_XSTEPH30                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x1A1*4)))
#define JECS_CSU_XSTEPL31                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x1A2*4)))
#define JECS_CSU_XSTEPH31                         (*((volatile uint32_t *)(JECS_CSU_BASE+0x1A3*4)))
#define JECS_CSU_DMAADDRL0                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x200*4)))
#define JECS_CSU_DMAADDRH0                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x201*4)))
#define JECS_CSU_DMAYSTEPL0                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x202*4)))
#define JECS_CSU_DMAYSTEPH0                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x203*4)))
#define JECS_CSU_DMAZSTEPL0                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x204*4)))
#define JECS_CSU_DMAZSTEPH0                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x205*4)))
#define JECS_CSU_DMAYNUMXNUM0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x206*4)))
#define JECS_CSU_DMASIZEGRANALLNUM0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x207*4)))
#define JECS_CSU_DMAADDRL1                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x208*4)))
#define JECS_CSU_DMAADDRH1                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x209*4)))
#define JECS_CSU_DMAYSTEPL1                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x20A*4)))
#define JECS_CSU_DMAYSTEPH1                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x20B*4)))
#define JECS_CSU_DMAZSTEPL1                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x20C*4)))
#define JECS_CSU_DMAZSTEPH1                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x20D*4)))
#define JECS_CSU_DMAYNUMXNUM1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x20E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x20F*4)))
#define JECS_CSU_DMAADDRL2                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x210*4)))
#define JECS_CSU_DMAADDRH2                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x211*4)))
#define JECS_CSU_DMAYSTEPL2                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x212*4)))
#define JECS_CSU_DMAYSTEPH2                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x213*4)))
#define JECS_CSU_DMAZSTEPL2                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x214*4)))
#define JECS_CSU_DMAZSTEPH2                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x215*4)))
#define JECS_CSU_DMAYNUMXNUM2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x216*4)))
#define JECS_CSU_DMASIZEGRANALLNUM2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x217*4)))
#define JECS_CSU_DMAADDRL3                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x218*4)))
#define JECS_CSU_DMAADDRH3                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x219*4)))
#define JECS_CSU_DMAYSTEPL3                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x21A*4)))
#define JECS_CSU_DMAYSTEPH3                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x21B*4)))
#define JECS_CSU_DMAZSTEPL3                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x21C*4)))
#define JECS_CSU_DMAZSTEPH3                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x21D*4)))
#define JECS_CSU_DMAYNUMXNUM3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x21E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x21F*4)))
#define JECS_CSU_DMAADDRL4                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x220*4)))
#define JECS_CSU_DMAADDRH4                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x221*4)))
#define JECS_CSU_DMAYSTEPL4                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x222*4)))
#define JECS_CSU_DMAYSTEPH4                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x223*4)))
#define JECS_CSU_DMAZSTEPL4                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x224*4)))
#define JECS_CSU_DMAZSTEPH4                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x225*4)))
#define JECS_CSU_DMAYNUMXNUM4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x226*4)))
#define JECS_CSU_DMASIZEGRANALLNUM4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x227*4)))
#define JECS_CSU_DMAADDRL5                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x228*4)))
#define JECS_CSU_DMAADDRH5                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x229*4)))
#define JECS_CSU_DMAYSTEPL5                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x22A*4)))
#define JECS_CSU_DMAYSTEPH5                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x22B*4)))
#define JECS_CSU_DMAZSTEPL5                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x22C*4)))
#define JECS_CSU_DMAZSTEPH5                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x22D*4)))
#define JECS_CSU_DMAYNUMXNUM5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x22E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x22F*4)))
#define JECS_CSU_DMAADDRL6                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x230*4)))
#define JECS_CSU_DMAADDRH6                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x231*4)))
#define JECS_CSU_DMAYSTEPL6                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x232*4)))
#define JECS_CSU_DMAYSTEPH6                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x233*4)))
#define JECS_CSU_DMAZSTEPL6                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x234*4)))
#define JECS_CSU_DMAZSTEPH6                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x235*4)))
#define JECS_CSU_DMAYNUMXNUM6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x236*4)))
#define JECS_CSU_DMASIZEGRANALLNUM6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x237*4)))
#define JECS_CSU_DMAADDRL7                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x238*4)))
#define JECS_CSU_DMAADDRH7                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x239*4)))
#define JECS_CSU_DMAYSTEPL7                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x23A*4)))
#define JECS_CSU_DMAYSTEPH7                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x23B*4)))
#define JECS_CSU_DMAZSTEPL7                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x23C*4)))
#define JECS_CSU_DMAZSTEPH7                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x23D*4)))
#define JECS_CSU_DMAYNUMXNUM7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x23E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x23F*4)))
#define JECS_CSU_DMAADDRL8                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x240*4)))
#define JECS_CSU_DMAADDRH8                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x241*4)))
#define JECS_CSU_DMAYSTEPL8                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x242*4)))
#define JECS_CSU_DMAYSTEPH8                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x243*4)))
#define JECS_CSU_DMAZSTEPL8                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x244*4)))
#define JECS_CSU_DMAZSTEPH8                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x245*4)))
#define JECS_CSU_DMAYNUMXNUM8                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x246*4)))
#define JECS_CSU_DMASIZEGRANALLNUM8               (*((volatile uint32_t *)(JECS_CSU_BASE+0x247*4)))
#define JECS_CSU_DMAADDRL9                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x248*4)))
#define JECS_CSU_DMAADDRH9                        (*((volatile uint32_t *)(JECS_CSU_BASE+0x249*4)))
#define JECS_CSU_DMAYSTEPL9                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x24A*4)))
#define JECS_CSU_DMAYSTEPH9                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x24B*4)))
#define JECS_CSU_DMAZSTEPL9                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x24C*4)))
#define JECS_CSU_DMAZSTEPH9                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x24D*4)))
#define JECS_CSU_DMAYNUMXNUM9                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x24E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM9               (*((volatile uint32_t *)(JECS_CSU_BASE+0x24F*4)))
#define JECS_CSU_DMAADDRL10                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x250*4)))
#define JECS_CSU_DMAADDRH10                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x251*4)))
#define JECS_CSU_DMAYSTEPL10                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x252*4)))
#define JECS_CSU_DMAYSTEPH10                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x253*4)))
#define JECS_CSU_DMAZSTEPL10                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x254*4)))
#define JECS_CSU_DMAZSTEPH10                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x255*4)))
#define JECS_CSU_DMAYNUMXNUM10                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x256*4)))
#define JECS_CSU_DMASIZEGRANALLNUM10              (*((volatile uint32_t *)(JECS_CSU_BASE+0x257*4)))
#define JECS_CSU_DMAADDRL11                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x258*4)))
#define JECS_CSU_DMAADDRH11                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x259*4)))
#define JECS_CSU_DMAYSTEPL11                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x25A*4)))
#define JECS_CSU_DMAYSTEPH11                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x25B*4)))
#define JECS_CSU_DMAZSTEPL11                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x25C*4)))
#define JECS_CSU_DMAZSTEPH11                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x25D*4)))
#define JECS_CSU_DMAYNUMXNUM11                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x25E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM11              (*((volatile uint32_t *)(JECS_CSU_BASE+0x25F*4)))
#define JECS_CSU_DMAADDRL12                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x260*4)))
#define JECS_CSU_DMAADDRH12                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x261*4)))
#define JECS_CSU_DMAYSTEPL12                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x262*4)))
#define JECS_CSU_DMAYSTEPH12                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x263*4)))
#define JECS_CSU_DMAZSTEPL12                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x264*4)))
#define JECS_CSU_DMAZSTEPH12                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x265*4)))
#define JECS_CSU_DMAYNUMXNUM12                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x266*4)))
#define JECS_CSU_DMASIZEGRANALLNUM12              (*((volatile uint32_t *)(JECS_CSU_BASE+0x267*4)))
#define JECS_CSU_DMAADDRL13                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x268*4)))
#define JECS_CSU_DMAADDRH13                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x269*4)))
#define JECS_CSU_DMAYSTEPL13                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x26A*4)))
#define JECS_CSU_DMAYSTEPH13                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x26B*4)))
#define JECS_CSU_DMAZSTEPL13                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x26C*4)))
#define JECS_CSU_DMAZSTEPH13                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x26D*4)))
#define JECS_CSU_DMAYNUMXNUM13                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x26E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM13              (*((volatile uint32_t *)(JECS_CSU_BASE+0x26F*4)))
#define JECS_CSU_DMAADDRL14                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x270*4)))
#define JECS_CSU_DMAADDRH14                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x271*4)))
#define JECS_CSU_DMAYSTEPL14                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x272*4)))
#define JECS_CSU_DMAYSTEPH14                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x273*4)))
#define JECS_CSU_DMAZSTEPL14                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x274*4)))
#define JECS_CSU_DMAZSTEPH14                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x275*4)))
#define JECS_CSU_DMAYNUMXNUM14                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x276*4)))
#define JECS_CSU_DMASIZEGRANALLNUM14              (*((volatile uint32_t *)(JECS_CSU_BASE+0x277*4)))
#define JECS_CSU_DMAADDRL15                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x278*4)))
#define JECS_CSU_DMAADDRH15                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x279*4)))
#define JECS_CSU_DMAYSTEPL15                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x27A*4)))
#define JECS_CSU_DMAYSTEPH15                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x27B*4)))
#define JECS_CSU_DMAZSTEPL15                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x27C*4)))
#define JECS_CSU_DMAZSTEPH15                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x27D*4)))
#define JECS_CSU_DMAYNUMXNUM15                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x27E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM15              (*((volatile uint32_t *)(JECS_CSU_BASE+0x27F*4)))
#define JECS_CSU_DMAADDRL16                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x280*4)))
#define JECS_CSU_DMAADDRH16                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x281*4)))
#define JECS_CSU_DMAYSTEPL16                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x282*4)))
#define JECS_CSU_DMAYSTEPH16                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x283*4)))
#define JECS_CSU_DMAZSTEPL16                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x284*4)))
#define JECS_CSU_DMAZSTEPH16                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x285*4)))
#define JECS_CSU_DMAYNUMXNUM16                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x286*4)))
#define JECS_CSU_DMASIZEGRANALLNUM16              (*((volatile uint32_t *)(JECS_CSU_BASE+0x287*4)))
#define JECS_CSU_DMAADDRL17                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x288*4)))
#define JECS_CSU_DMAADDRH17                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x289*4)))
#define JECS_CSU_DMAYSTEPL17                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x28A*4)))
#define JECS_CSU_DMAYSTEPH17                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x28B*4)))
#define JECS_CSU_DMAZSTEPL17                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x28C*4)))
#define JECS_CSU_DMAZSTEPH17                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x28D*4)))
#define JECS_CSU_DMAYNUMXNUM17                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x28E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM17              (*((volatile uint32_t *)(JECS_CSU_BASE+0x28F*4)))
#define JECS_CSU_DMAADDRL18                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x290*4)))
#define JECS_CSU_DMAADDRH18                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x291*4)))
#define JECS_CSU_DMAYSTEPL18                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x292*4)))
#define JECS_CSU_DMAYSTEPH18                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x293*4)))
#define JECS_CSU_DMAZSTEPL18                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x294*4)))
#define JECS_CSU_DMAZSTEPH18                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x295*4)))
#define JECS_CSU_DMAYNUMXNUM18                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x296*4)))
#define JECS_CSU_DMASIZEGRANALLNUM18              (*((volatile uint32_t *)(JECS_CSU_BASE+0x297*4)))
#define JECS_CSU_DMAADDRL19                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x298*4)))
#define JECS_CSU_DMAADDRH19                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x299*4)))
#define JECS_CSU_DMAYSTEPL19                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x29A*4)))
#define JECS_CSU_DMAYSTEPH19                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x29B*4)))
#define JECS_CSU_DMAZSTEPL19                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x29C*4)))
#define JECS_CSU_DMAZSTEPH19                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x29D*4)))
#define JECS_CSU_DMAYNUMXNUM19                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x29E*4)))
#define JECS_CSU_DMASIZEGRANALLNUM19              (*((volatile uint32_t *)(JECS_CSU_BASE+0x29F*4)))
#define JECS_CSU_DMAADDRL20                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A0*4)))
#define JECS_CSU_DMAADDRH20                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A1*4)))
#define JECS_CSU_DMAYSTEPL20                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A2*4)))
#define JECS_CSU_DMAYSTEPH20                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A3*4)))
#define JECS_CSU_DMAZSTEPL20                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A4*4)))
#define JECS_CSU_DMAZSTEPH20                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A5*4)))
#define JECS_CSU_DMAYNUMXNUM20                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM20              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A7*4)))
#define JECS_CSU_DMAADDRL21                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A8*4)))
#define JECS_CSU_DMAADDRH21                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2A9*4)))
#define JECS_CSU_DMAYSTEPL21                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AA*4)))
#define JECS_CSU_DMAYSTEPH21                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AB*4)))
#define JECS_CSU_DMAZSTEPL21                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AC*4)))
#define JECS_CSU_DMAZSTEPH21                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AD*4)))
#define JECS_CSU_DMAYNUMXNUM21                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM21              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2AF*4)))
#define JECS_CSU_DMAADDRL22                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B0*4)))
#define JECS_CSU_DMAADDRH22                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B1*4)))
#define JECS_CSU_DMAYSTEPL22                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B2*4)))
#define JECS_CSU_DMAYSTEPH22                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B3*4)))
#define JECS_CSU_DMAZSTEPL22                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B4*4)))
#define JECS_CSU_DMAZSTEPH22                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B5*4)))
#define JECS_CSU_DMAYNUMXNUM22                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM22              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B7*4)))
#define JECS_CSU_DMAADDRL23                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B8*4)))
#define JECS_CSU_DMAADDRH23                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2B9*4)))
#define JECS_CSU_DMAYSTEPL23                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BA*4)))
#define JECS_CSU_DMAYSTEPH23                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BB*4)))
#define JECS_CSU_DMAZSTEPL23                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BC*4)))
#define JECS_CSU_DMAZSTEPH23                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BD*4)))
#define JECS_CSU_DMAYNUMXNUM23                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM23              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2BF*4)))
#define JECS_CSU_DMAADDRL24                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C0*4)))
#define JECS_CSU_DMAADDRH24                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C1*4)))
#define JECS_CSU_DMAYSTEPL24                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C2*4)))
#define JECS_CSU_DMAYSTEPH24                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C3*4)))
#define JECS_CSU_DMAZSTEPL24                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C4*4)))
#define JECS_CSU_DMAZSTEPH24                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C5*4)))
#define JECS_CSU_DMAYNUMXNUM24                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM24              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C7*4)))
#define JECS_CSU_DMAADDRL25                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C8*4)))
#define JECS_CSU_DMAADDRH25                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2C9*4)))
#define JECS_CSU_DMAYSTEPL25                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CA*4)))
#define JECS_CSU_DMAYSTEPH25                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CB*4)))
#define JECS_CSU_DMAZSTEPL25                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CC*4)))
#define JECS_CSU_DMAZSTEPH25                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CD*4)))
#define JECS_CSU_DMAYNUMXNUM25                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM25              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2CF*4)))
#define JECS_CSU_DMAADDRL26                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D0*4)))
#define JECS_CSU_DMAADDRH26                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D1*4)))
#define JECS_CSU_DMAYSTEPL26                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D2*4)))
#define JECS_CSU_DMAYSTEPH26                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D3*4)))
#define JECS_CSU_DMAZSTEPL26                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D4*4)))
#define JECS_CSU_DMAZSTEPH26                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D5*4)))
#define JECS_CSU_DMAYNUMXNUM26                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM26              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D7*4)))
#define JECS_CSU_DMAADDRL27                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D8*4)))
#define JECS_CSU_DMAADDRH27                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2D9*4)))
#define JECS_CSU_DMAYSTEPL27                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DA*4)))
#define JECS_CSU_DMAYSTEPH27                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DB*4)))
#define JECS_CSU_DMAZSTEPL27                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DC*4)))
#define JECS_CSU_DMAZSTEPH27                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DD*4)))
#define JECS_CSU_DMAYNUMXNUM27                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM27              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2DF*4)))
#define JECS_CSU_DMAADDRL28                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E0*4)))
#define JECS_CSU_DMAADDRH28                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E1*4)))
#define JECS_CSU_DMAYSTEPL28                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E2*4)))
#define JECS_CSU_DMAYSTEPH28                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E3*4)))
#define JECS_CSU_DMAZSTEPL28                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E4*4)))
#define JECS_CSU_DMAZSTEPH28                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E5*4)))
#define JECS_CSU_DMAYNUMXNUM28                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM28              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E7*4)))
#define JECS_CSU_DMAADDRL29                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E8*4)))
#define JECS_CSU_DMAADDRH29                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2E9*4)))
#define JECS_CSU_DMAYSTEPL29                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2EA*4)))
#define JECS_CSU_DMAYSTEPH29                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2EB*4)))
#define JECS_CSU_DMAZSTEPL29                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2EC*4)))
#define JECS_CSU_DMAZSTEPH29                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2ED*4)))
#define JECS_CSU_DMAYNUMXNUM29                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2EE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM29              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2EF*4)))
#define JECS_CSU_DMAADDRL30                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F0*4)))
#define JECS_CSU_DMAADDRH30                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F1*4)))
#define JECS_CSU_DMAYSTEPL30                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F2*4)))
#define JECS_CSU_DMAYSTEPH30                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F3*4)))
#define JECS_CSU_DMAZSTEPL30                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F4*4)))
#define JECS_CSU_DMAZSTEPH30                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F5*4)))
#define JECS_CSU_DMAYNUMXNUM30                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F6*4)))
#define JECS_CSU_DMASIZEGRANALLNUM30              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F7*4)))
#define JECS_CSU_DMAADDRL31                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F8*4)))
#define JECS_CSU_DMAADDRH31                       (*((volatile uint32_t *)(JECS_CSU_BASE+0x2F9*4)))
#define JECS_CSU_DMAYSTEPL31                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FA*4)))
#define JECS_CSU_DMAYSTEPH31                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FB*4)))
#define JECS_CSU_DMAZSTEPL31                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FC*4)))
#define JECS_CSU_DMAZSTEPH31                      (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FD*4)))
#define JECS_CSU_DMAYNUMXNUM31                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FE*4)))
#define JECS_CSU_DMASIZEGRANALLNUM31              (*((volatile uint32_t *)(JECS_CSU_BASE+0x2FF*4)))
#define JECS_CSU_SORTDATA_NUM                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x380*4)))
#define JECS_CSU_SORTDATA_DATA0                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C0*4)))
#define JECS_CSU_SORTDATA_DATA1                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C1*4)))
#define JECS_CSU_SORTDATA_DATA2                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C2*4)))
#define JECS_CSU_SORTDATA_DATA3                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C3*4)))
#define JECS_CSU_SORTDATA_DATA4                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C4*4)))
#define JECS_CSU_SORTDATA_DATA5                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C5*4)))
#define JECS_CSU_SORTDATA_DATA6                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C6*4)))
#define JECS_CSU_SORTDATA_DATA7                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C7*4)))
#define JECS_CSU_SORTDATA_DATA8                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C8*4)))
#define JECS_CSU_SORTDATA_DATA9                   (*((volatile uint32_t *)(JECS_CSU_BASE+0x3C9*4)))
#define JECS_CSU_SORTDATA_DATA10                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CA*4)))
#define JECS_CSU_SORTDATA_DATA11                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CB*4)))
#define JECS_CSU_SORTDATA_DATA12                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CC*4)))
#define JECS_CSU_SORTDATA_DATA13                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CD*4)))
#define JECS_CSU_SORTDATA_DATA14                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CE*4)))
#define JECS_CSU_SORTDATA_DATA15                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3CF*4)))
#define JECS_CSU_SORTDATA_DATA16                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D0*4)))
#define JECS_CSU_SORTDATA_DATA17                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D1*4)))
#define JECS_CSU_SORTDATA_DATA18                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D2*4)))
#define JECS_CSU_SORTDATA_DATA19                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D3*4)))
#define JECS_CSU_SORTDATA_DATA20                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D4*4)))
#define JECS_CSU_SORTDATA_DATA21                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D5*4)))
#define JECS_CSU_SORTDATA_DATA22                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D6*4)))
#define JECS_CSU_SORTDATA_DATA23                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D7*4)))
#define JECS_CSU_SORTDATA_DATA24                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D8*4)))
#define JECS_CSU_SORTDATA_DATA25                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3D9*4)))
#define JECS_CSU_SORTDATA_DATA26                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DA*4)))
#define JECS_CSU_SORTDATA_DATA27                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DB*4)))
#define JECS_CSU_SORTDATA_DATA28                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DC*4)))
#define JECS_CSU_SORTDATA_DATA29                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DD*4)))
#define JECS_CSU_SORTDATA_DATA30                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DE*4)))
#define JECS_CSU_SORTDATA_DATA31                  (*((volatile uint32_t *)(JECS_CSU_BASE+0x3DF*4)))
#define JECS_CSU_SORTDATA_ID0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E0*4)))
#define JECS_CSU_SORTDATA_ID1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E1*4)))
#define JECS_CSU_SORTDATA_ID2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E2*4)))
#define JECS_CSU_SORTDATA_ID3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E3*4)))
#define JECS_CSU_SORTDATA_ID4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E4*4)))
#define JECS_CSU_SORTDATA_ID5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E5*4)))
#define JECS_CSU_SORTDATA_ID6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E6*4)))
#define JECS_CSU_SORTDATA_ID7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E7*4)))
#define JECS_CSU_SORTDATA_ID8                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E8*4)))
#define JECS_CSU_SORTDATA_ID9                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x3E9*4)))
#define JECS_CSU_SORTDATA_ID10                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3EA*4)))
#define JECS_CSU_SORTDATA_ID11                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3EB*4)))
#define JECS_CSU_SORTDATA_ID12                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3EC*4)))
#define JECS_CSU_SORTDATA_ID13                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3ED*4)))
#define JECS_CSU_SORTDATA_ID14                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3EE*4)))
#define JECS_CSU_SORTDATA_ID15                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3EF*4)))
#define JECS_CSU_SORTDATA_ID16                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F0*4)))
#define JECS_CSU_SORTDATA_ID17                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F1*4)))
#define JECS_CSU_SORTDATA_ID18                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F2*4)))
#define JECS_CSU_SORTDATA_ID19                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F3*4)))
#define JECS_CSU_SORTDATA_ID20                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F4*4)))
#define JECS_CSU_SORTDATA_ID21                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F5*4)))
#define JECS_CSU_SORTDATA_ID22                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F6*4)))
#define JECS_CSU_SORTDATA_ID23                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F7*4)))
#define JECS_CSU_SORTDATA_ID24                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F8*4)))
#define JECS_CSU_SORTDATA_ID25                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3F9*4)))
#define JECS_CSU_SORTDATA_ID26                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FA*4)))
#define JECS_CSU_SORTDATA_ID27                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FB*4)))
#define JECS_CSU_SORTDATA_ID28                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FC*4)))
#define JECS_CSU_SORTDATA_ID29                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FD*4)))
#define JECS_CSU_SORTDATA_ID30                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FE*4)))
#define JECS_CSU_SORTDATA_ID31                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x3FF*4)))
#define JECS_CSU_CPRITX0RFPSET                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x47E*4)))
#define JECS_CSU_CPRITX0PORTINFO0                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x400*4)))
#define JECS_CSU_CPRITX0PORTINFO1                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x401*4)))
#define JECS_CSU_CPRITX0PORTINFO2                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x402*4)))
#define JECS_CSU_CPRITX0PORTINFO3                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x403*4)))
#define JECS_CSU_CPRITX0PORTINFO4                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x404*4)))
#define JECS_CSU_CPRITX0PORTINFO5                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x405*4)))
#define JECS_CSU_CPRITX0PORTINFO6                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x406*4)))
#define JECS_CSU_CPRITX0PORTINFO7                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x407*4)))
#define JECS_CSU_CPRITX0PORTINFO8                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x408*4)))
#define JECS_CSU_CPRITX0PORTINFO9                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x409*4)))
#define JECS_CSU_CPRITX0PORTINFO10                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40A*4)))
#define JECS_CSU_CPRITX0PORTINFO11                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40B*4)))
#define JECS_CSU_CPRITX0PORTINFO12                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40C*4)))
#define JECS_CSU_CPRITX0PORTINFO13                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40D*4)))
#define JECS_CSU_CPRITX0PORTINFO14                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40E*4)))
#define JECS_CSU_CPRITX0PORTINFO15                (*((volatile uint32_t *)(JECS_CSU_BASE+0x40F*4)))
#define JECS_CSU_CPRITX0PORTINFO16                (*((volatile uint32_t *)(JECS_CSU_BASE+0x410*4)))
#define JECS_CSU_CPRITX0PORTINFO17                (*((volatile uint32_t *)(JECS_CSU_BASE+0x411*4)))
#define JECS_CSU_CPRITX0PORTINFO18                (*((volatile uint32_t *)(JECS_CSU_BASE+0x412*4)))
#define JECS_CSU_CPRITX0PORTINFO19                (*((volatile uint32_t *)(JECS_CSU_BASE+0x413*4)))
#define JECS_CSU_CPRITX0PORTINFO20                (*((volatile uint32_t *)(JECS_CSU_BASE+0x414*4)))
#define JECS_CSU_CPRITX0PORTINFO21                (*((volatile uint32_t *)(JECS_CSU_BASE+0x415*4)))
#define JECS_CSU_CPRITX0PORTINFO22                (*((volatile uint32_t *)(JECS_CSU_BASE+0x416*4)))
#define JECS_CSU_CPRITX0PORTINFO23                (*((volatile uint32_t *)(JECS_CSU_BASE+0x417*4)))
#define JECS_CSU_CPRITX0PORTINFO24                (*((volatile uint32_t *)(JECS_CSU_BASE+0x418*4)))
#define JECS_CSU_CPRITX0PORTINFO25                (*((volatile uint32_t *)(JECS_CSU_BASE+0x419*4)))
#define JECS_CSU_CPRITX0PORTINFO26                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41A*4)))
#define JECS_CSU_CPRITX0PORTINFO27                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41B*4)))
#define JECS_CSU_CPRITX0PORTINFO28                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41C*4)))
#define JECS_CSU_CPRITX0PORTINFO29                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41D*4)))
#define JECS_CSU_CPRITX0PORTINFO30                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41E*4)))
#define JECS_CSU_CPRITX0PORTINFO31                (*((volatile uint32_t *)(JECS_CSU_BASE+0x41F*4)))
#define JECS_CSU_CPRITX0PORTINFO32                (*((volatile uint32_t *)(JECS_CSU_BASE+0x420*4)))
#define JECS_CSU_CPRITX0PORTINFO33                (*((volatile uint32_t *)(JECS_CSU_BASE+0x421*4)))
#define JECS_CSU_CPRITX0PORTINFO34                (*((volatile uint32_t *)(JECS_CSU_BASE+0x422*4)))
#define JECS_CSU_CPRITX0PORTINFO35                (*((volatile uint32_t *)(JECS_CSU_BASE+0x423*4)))
#define JECS_CSU_CPRITX0PORTINFO36                (*((volatile uint32_t *)(JECS_CSU_BASE+0x424*4)))
#define JECS_CSU_CPRITX0PORTINFO37                (*((volatile uint32_t *)(JECS_CSU_BASE+0x425*4)))
#define JECS_CSU_CPRITX0PORTINFO38                (*((volatile uint32_t *)(JECS_CSU_BASE+0x426*4)))
#define JECS_CSU_CPRITX0PORTINFO39                (*((volatile uint32_t *)(JECS_CSU_BASE+0x427*4)))
#define JECS_CSU_CPRITX0PORTINFO40                (*((volatile uint32_t *)(JECS_CSU_BASE+0x428*4)))
#define JECS_CSU_CPRITX0PORTINFO41                (*((volatile uint32_t *)(JECS_CSU_BASE+0x429*4)))
#define JECS_CSU_CPRITX0PORTINFO42                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42A*4)))
#define JECS_CSU_CPRITX0PORTINFO43                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42B*4)))
#define JECS_CSU_CPRITX0PORTINFO44                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42C*4)))
#define JECS_CSU_CPRITX0PORTINFO45                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42D*4)))
#define JECS_CSU_CPRITX0PORTINFO46                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42E*4)))
#define JECS_CSU_CPRITX0PORTINFO47                (*((volatile uint32_t *)(JECS_CSU_BASE+0x42F*4)))
#define JECS_CSU_CPRITX0PORTINFO48                (*((volatile uint32_t *)(JECS_CSU_BASE+0x430*4)))
#define JECS_CSU_CPRITX0PORTINFO49                (*((volatile uint32_t *)(JECS_CSU_BASE+0x431*4)))
#define JECS_CSU_CPRITX0PORTINFO50                (*((volatile uint32_t *)(JECS_CSU_BASE+0x432*4)))
#define JECS_CSU_CPRITX0PORTINFO51                (*((volatile uint32_t *)(JECS_CSU_BASE+0x433*4)))
#define JECS_CSU_CPRITX0PORTINFO52                (*((volatile uint32_t *)(JECS_CSU_BASE+0x434*4)))
#define JECS_CSU_CPRITX0PORTINFO53                (*((volatile uint32_t *)(JECS_CSU_BASE+0x435*4)))
#define JECS_CSU_CPRITX0PORTINFO54                (*((volatile uint32_t *)(JECS_CSU_BASE+0x436*4)))
#define JECS_CSU_CPRITX0PORTINFO55                (*((volatile uint32_t *)(JECS_CSU_BASE+0x437*4)))
#define JECS_CSU_CPRITX0PORTINFO56                (*((volatile uint32_t *)(JECS_CSU_BASE+0x438*4)))
#define JECS_CSU_CPRITX0PORTINFO57                (*((volatile uint32_t *)(JECS_CSU_BASE+0x439*4)))
#define JECS_CSU_CPRITX0PORTINFO58                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43A*4)))
#define JECS_CSU_CPRITX0PORTINFO59                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43B*4)))
#define JECS_CSU_CPRITX0PORTINFO60                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43C*4)))
#define JECS_CSU_CPRITX0PORTINFO61                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43D*4)))
#define JECS_CSU_CPRITX0PORTINFO62                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43E*4)))
#define JECS_CSU_CPRITX0PORTINFO63                (*((volatile uint32_t *)(JECS_CSU_BASE+0x43F*4)))
#define JECS_CSU_CPRITX0LATCHINFOL0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x450*4)))
#define JECS_CSU_CPRITX0LATCHINFOL1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x451*4)))
#define JECS_CSU_CPRITX0LATCHINFOL2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x452*4)))
#define JECS_CSU_CPRITX0LATCHINFOL3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x453*4)))
#define JECS_CSU_CPRITX0LATCHINFOL4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x454*4)))
#define JECS_CSU_CPRITX0LATCHINFOL5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x455*4)))
#define JECS_CSU_CPRITX0LATCHINFOL6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x456*4)))
#define JECS_CSU_CPRITX0LATCHINFOL7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x457*4)))
#define JECS_CSU_CPRITX0LATCHINFOM0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x440*4)))
#define JECS_CSU_CPRITX0LATCHINFOM1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x441*4)))
#define JECS_CSU_CPRITX0LATCHINFOM2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x442*4)))
#define JECS_CSU_CPRITX0LATCHINFOM3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x443*4)))
#define JECS_CSU_CPRITX0LATCHINFOM4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x444*4)))
#define JECS_CSU_CPRITX0LATCHINFOM5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x445*4)))
#define JECS_CSU_CPRITX0LATCHINFOM6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x446*4)))
#define JECS_CSU_CPRITX0LATCHINFOM7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x447*4)))
#define JECS_CSU_CPRITX0LATCHINFOH0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x448*4)))
#define JECS_CSU_CPRITX0LATCHINFOH1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x449*4)))
#define JECS_CSU_CPRITX0LATCHINFOH2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44A*4)))
#define JECS_CSU_CPRITX0LATCHINFOH3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44B*4)))
#define JECS_CSU_CPRITX0LATCHINFOH4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44C*4)))
#define JECS_CSU_CPRITX0LATCHINFOH5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44D*4)))
#define JECS_CSU_CPRITX0LATCHINFOH6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44E*4)))
#define JECS_CSU_CPRITX0LATCHINFOH7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x44F*4)))
#define JECS_CSU_CPRITX0FLUSH                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x47D*4)))
#define JECS_CSU_CPRITX0ONWORK                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x47F*4)))
#define JECS_CSU_CPRIRX0RFPSET                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x4FE*4)))
#define JECS_CSU_CPRIRX0PORTINFO0                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x480*4)))
#define JECS_CSU_CPRIRX0PORTINFO1                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x481*4)))
#define JECS_CSU_CPRIRX0PORTINFO2                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x482*4)))
#define JECS_CSU_CPRIRX0PORTINFO3                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x483*4)))
#define JECS_CSU_CPRIRX0PORTINFO4                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x484*4)))
#define JECS_CSU_CPRIRX0PORTINFO5                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x485*4)))
#define JECS_CSU_CPRIRX0PORTINFO6                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x486*4)))
#define JECS_CSU_CPRIRX0PORTINFO7                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x487*4)))
#define JECS_CSU_CPRIRX0PORTINFO8                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x488*4)))
#define JECS_CSU_CPRIRX0PORTINFO9                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x489*4)))
#define JECS_CSU_CPRIRX0PORTINFO10                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48A*4)))
#define JECS_CSU_CPRIRX0PORTINFO11                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48B*4)))
#define JECS_CSU_CPRIRX0PORTINFO12                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48C*4)))
#define JECS_CSU_CPRIRX0PORTINFO13                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48D*4)))
#define JECS_CSU_CPRIRX0PORTINFO14                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48E*4)))
#define JECS_CSU_CPRIRX0PORTINFO15                (*((volatile uint32_t *)(JECS_CSU_BASE+0x48F*4)))
#define JECS_CSU_CPRIRX0PORTINFO16                (*((volatile uint32_t *)(JECS_CSU_BASE+0x490*4)))
#define JECS_CSU_CPRIRX0PORTINFO17                (*((volatile uint32_t *)(JECS_CSU_BASE+0x491*4)))
#define JECS_CSU_CPRIRX0PORTINFO18                (*((volatile uint32_t *)(JECS_CSU_BASE+0x492*4)))
#define JECS_CSU_CPRIRX0PORTINFO19                (*((volatile uint32_t *)(JECS_CSU_BASE+0x493*4)))
#define JECS_CSU_CPRIRX0PORTINFO20                (*((volatile uint32_t *)(JECS_CSU_BASE+0x494*4)))
#define JECS_CSU_CPRIRX0PORTINFO21                (*((volatile uint32_t *)(JECS_CSU_BASE+0x495*4)))
#define JECS_CSU_CPRIRX0PORTINFO22                (*((volatile uint32_t *)(JECS_CSU_BASE+0x496*4)))
#define JECS_CSU_CPRIRX0PORTINFO23                (*((volatile uint32_t *)(JECS_CSU_BASE+0x497*4)))
#define JECS_CSU_CPRIRX0PORTINFO24                (*((volatile uint32_t *)(JECS_CSU_BASE+0x498*4)))
#define JECS_CSU_CPRIRX0PORTINFO25                (*((volatile uint32_t *)(JECS_CSU_BASE+0x499*4)))
#define JECS_CSU_CPRIRX0PORTINFO26                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49A*4)))
#define JECS_CSU_CPRIRX0PORTINFO27                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49B*4)))
#define JECS_CSU_CPRIRX0PORTINFO28                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49C*4)))
#define JECS_CSU_CPRIRX0PORTINFO29                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49D*4)))
#define JECS_CSU_CPRIRX0PORTINFO30                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49E*4)))
#define JECS_CSU_CPRIRX0PORTINFO31                (*((volatile uint32_t *)(JECS_CSU_BASE+0x49F*4)))
#define JECS_CSU_CPRIRX0PORTINFO32                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A0*4)))
#define JECS_CSU_CPRIRX0PORTINFO33                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A1*4)))
#define JECS_CSU_CPRIRX0PORTINFO34                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A2*4)))
#define JECS_CSU_CPRIRX0PORTINFO35                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A3*4)))
#define JECS_CSU_CPRIRX0PORTINFO36                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A4*4)))
#define JECS_CSU_CPRIRX0PORTINFO37                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A5*4)))
#define JECS_CSU_CPRIRX0PORTINFO38                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A6*4)))
#define JECS_CSU_CPRIRX0PORTINFO39                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A7*4)))
#define JECS_CSU_CPRIRX0PORTINFO40                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A8*4)))
#define JECS_CSU_CPRIRX0PORTINFO41                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4A9*4)))
#define JECS_CSU_CPRIRX0PORTINFO42                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AA*4)))
#define JECS_CSU_CPRIRX0PORTINFO43                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AB*4)))
#define JECS_CSU_CPRIRX0PORTINFO44                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AC*4)))
#define JECS_CSU_CPRIRX0PORTINFO45                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AD*4)))
#define JECS_CSU_CPRIRX0PORTINFO46                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AE*4)))
#define JECS_CSU_CPRIRX0PORTINFO47                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4AF*4)))
#define JECS_CSU_CPRIRX0PORTINFO48                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B0*4)))
#define JECS_CSU_CPRIRX0PORTINFO49                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B1*4)))
#define JECS_CSU_CPRIRX0PORTINFO50                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B2*4)))
#define JECS_CSU_CPRIRX0PORTINFO51                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B3*4)))
#define JECS_CSU_CPRIRX0PORTINFO52                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B4*4)))
#define JECS_CSU_CPRIRX0PORTINFO53                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B5*4)))
#define JECS_CSU_CPRIRX0PORTINFO54                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B6*4)))
#define JECS_CSU_CPRIRX0PORTINFO55                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B7*4)))
#define JECS_CSU_CPRIRX0PORTINFO56                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B8*4)))
#define JECS_CSU_CPRIRX0PORTINFO57                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4B9*4)))
#define JECS_CSU_CPRIRX0PORTINFO58                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BA*4)))
#define JECS_CSU_CPRIRX0PORTINFO59                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BB*4)))
#define JECS_CSU_CPRIRX0PORTINFO60                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BC*4)))
#define JECS_CSU_CPRIRX0PORTINFO61                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BD*4)))
#define JECS_CSU_CPRIRX0PORTINFO62                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BE*4)))
#define JECS_CSU_CPRIRX0PORTINFO63                (*((volatile uint32_t *)(JECS_CSU_BASE+0x4BF*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D0*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D1*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D2*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D3*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D4*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D5*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D6*4)))
#define JECS_CSU_CPRIRX0LATCHINFOL7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4D7*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH0               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C0*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH1               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C1*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH2               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C2*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH3               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C3*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH4               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C4*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH5               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C5*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH6               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C6*4)))
#define JECS_CSU_CPRIRX0LATCHINFOH7               (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C7*4)))
#define JECS_CSU_CPRIRX0CYCLENUM0                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C8*4)))
#define JECS_CSU_CPRIRX0CYCLENUM1                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4C9*4)))
#define JECS_CSU_CPRIRX0CYCLENUM2                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CA*4)))
#define JECS_CSU_CPRIRX0CYCLENUM3                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CB*4)))
#define JECS_CSU_CPRIRX0CYCLENUM4                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CC*4)))
#define JECS_CSU_CPRIRX0CYCLENUM5                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CD*4)))
#define JECS_CSU_CPRIRX0CYCLENUM6                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CE*4)))
#define JECS_CSU_CPRIRX0CYCLENUM7                 (*((volatile uint32_t *)(JECS_CSU_BASE+0x4CF*4)))
#define JECS_CSU_CPRIRX0FLUSH                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x4FD*4)))
#define JECS_CSU_CPRIRX0ONWORK                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x4FF*4)))
#define JECS_CSU_CPRITX1FLUSH                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x57D*4)))
#define JECS_CSU_CPRITX1ONWORK                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x57F*4)))
#define JECS_CSU_CPRIRX1FLUSH                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x5FD*4)))
#define JECS_CSU_CPRIRX1ONWORK                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x5FF*4)))
#define JECS_CSU_ECPRIPARA0_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x600*4)))
#define JECS_CSU_ECPRIPARA0_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x601*4)))
#define JECS_CSU_ECPRIPARA0_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x602*4)))
#define JECS_CSU_ECPRIPARA0_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x603*4)))
#define JECS_CSU_ECPRIPARA0_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x604*4)))
#define JECS_CSU_ECPRIPARA0_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x605*4)))
#define JECS_CSU_ECPRIPARA0_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x606*4)))
#define JECS_CSU_ECPRIPARA0_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x607*4)))
#define JECS_CSU_ECPRIPARA1_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x608*4)))
#define JECS_CSU_ECPRIPARA1_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x609*4)))
#define JECS_CSU_ECPRIPARA1_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60A*4)))
#define JECS_CSU_ECPRIPARA1_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60B*4)))
#define JECS_CSU_ECPRIPARA1_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60C*4)))
#define JECS_CSU_ECPRIPARA1_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60D*4)))
#define JECS_CSU_ECPRIPARA1_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60E*4)))
#define JECS_CSU_ECPRIPARA1_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x60F*4)))
#define JECS_CSU_ECPRIPARA2_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x610*4)))
#define JECS_CSU_ECPRIPARA2_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x611*4)))
#define JECS_CSU_ECPRIPARA2_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x612*4)))
#define JECS_CSU_ECPRIPARA2_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x613*4)))
#define JECS_CSU_ECPRIPARA2_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x614*4)))
#define JECS_CSU_ECPRIPARA2_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x615*4)))
#define JECS_CSU_ECPRIPARA2_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x616*4)))
#define JECS_CSU_ECPRIPARA2_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x617*4)))
#define JECS_CSU_ECPRIPARA3_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x618*4)))
#define JECS_CSU_ECPRIPARA3_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x619*4)))
#define JECS_CSU_ECPRIPARA3_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61A*4)))
#define JECS_CSU_ECPRIPARA3_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61B*4)))
#define JECS_CSU_ECPRIPARA3_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61C*4)))
#define JECS_CSU_ECPRIPARA3_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61D*4)))
#define JECS_CSU_ECPRIPARA3_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61E*4)))
#define JECS_CSU_ECPRIPARA3_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x61F*4)))
#define JECS_CSU_ECPRIPARA4_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x620*4)))
#define JECS_CSU_ECPRIPARA4_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x621*4)))
#define JECS_CSU_ECPRIPARA4_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x622*4)))
#define JECS_CSU_ECPRIPARA4_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x623*4)))
#define JECS_CSU_ECPRIPARA4_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x624*4)))
#define JECS_CSU_ECPRIPARA4_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x625*4)))
#define JECS_CSU_ECPRIPARA4_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x626*4)))
#define JECS_CSU_ECPRIPARA4_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x627*4)))
#define JECS_CSU_ECPRIPARA5_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x628*4)))
#define JECS_CSU_ECPRIPARA5_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x629*4)))
#define JECS_CSU_ECPRIPARA5_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62A*4)))
#define JECS_CSU_ECPRIPARA5_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62B*4)))
#define JECS_CSU_ECPRIPARA5_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62C*4)))
#define JECS_CSU_ECPRIPARA5_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62D*4)))
#define JECS_CSU_ECPRIPARA5_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62E*4)))
#define JECS_CSU_ECPRIPARA5_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x62F*4)))
#define JECS_CSU_ECPRIPARA6_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x630*4)))
#define JECS_CSU_ECPRIPARA6_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x631*4)))
#define JECS_CSU_ECPRIPARA6_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x632*4)))
#define JECS_CSU_ECPRIPARA6_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x633*4)))
#define JECS_CSU_ECPRIPARA6_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x634*4)))
#define JECS_CSU_ECPRIPARA6_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x635*4)))
#define JECS_CSU_ECPRIPARA6_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x636*4)))
#define JECS_CSU_ECPRIPARA6_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x637*4)))
#define JECS_CSU_ECPRIPARA7_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x638*4)))
#define JECS_CSU_ECPRIPARA7_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x639*4)))
#define JECS_CSU_ECPRIPARA7_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63A*4)))
#define JECS_CSU_ECPRIPARA7_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63B*4)))
#define JECS_CSU_ECPRIPARA7_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63C*4)))
#define JECS_CSU_ECPRIPARA7_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63D*4)))
#define JECS_CSU_ECPRIPARA7_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63E*4)))
#define JECS_CSU_ECPRIPARA7_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x63F*4)))
#define JECS_CSU_ECPRIPARA8_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x640*4)))
#define JECS_CSU_ECPRIPARA8_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x641*4)))
#define JECS_CSU_ECPRIPARA8_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x642*4)))
#define JECS_CSU_ECPRIPARA8_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x643*4)))
#define JECS_CSU_ECPRIPARA8_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x644*4)))
#define JECS_CSU_ECPRIPARA8_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x645*4)))
#define JECS_CSU_ECPRIPARA8_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x646*4)))
#define JECS_CSU_ECPRIPARA8_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x647*4)))
#define JECS_CSU_ECPRIPARA9_0                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x648*4)))
#define JECS_CSU_ECPRIPARA9_1                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x649*4)))
#define JECS_CSU_ECPRIPARA9_2                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64A*4)))
#define JECS_CSU_ECPRIPARA9_3                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64B*4)))
#define JECS_CSU_ECPRIPARA9_4                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64C*4)))
#define JECS_CSU_ECPRIPARA9_5                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64D*4)))
#define JECS_CSU_ECPRIPARA9_6                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64E*4)))
#define JECS_CSU_ECPRIPARA9_7                     (*((volatile uint32_t *)(JECS_CSU_BASE+0x64F*4)))
#define JECS_CSU_ECPRIPARA10_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x650*4)))
#define JECS_CSU_ECPRIPARA10_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x651*4)))
#define JECS_CSU_ECPRIPARA10_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x652*4)))
#define JECS_CSU_ECPRIPARA10_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x653*4)))
#define JECS_CSU_ECPRIPARA10_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x654*4)))
#define JECS_CSU_ECPRIPARA10_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x655*4)))
#define JECS_CSU_ECPRIPARA10_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x656*4)))
#define JECS_CSU_ECPRIPARA10_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x657*4)))
#define JECS_CSU_ECPRIPARA11_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x658*4)))
#define JECS_CSU_ECPRIPARA11_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x659*4)))
#define JECS_CSU_ECPRIPARA11_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65A*4)))
#define JECS_CSU_ECPRIPARA11_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65B*4)))
#define JECS_CSU_ECPRIPARA11_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65C*4)))
#define JECS_CSU_ECPRIPARA11_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65D*4)))
#define JECS_CSU_ECPRIPARA11_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65E*4)))
#define JECS_CSU_ECPRIPARA11_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x65F*4)))
#define JECS_CSU_ECPRIPARA12_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x660*4)))
#define JECS_CSU_ECPRIPARA12_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x661*4)))
#define JECS_CSU_ECPRIPARA12_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x662*4)))
#define JECS_CSU_ECPRIPARA12_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x663*4)))
#define JECS_CSU_ECPRIPARA12_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x664*4)))
#define JECS_CSU_ECPRIPARA12_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x665*4)))
#define JECS_CSU_ECPRIPARA12_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x666*4)))
#define JECS_CSU_ECPRIPARA12_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x667*4)))
#define JECS_CSU_ECPRIPARA13_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x668*4)))
#define JECS_CSU_ECPRIPARA13_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x669*4)))
#define JECS_CSU_ECPRIPARA13_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66A*4)))
#define JECS_CSU_ECPRIPARA13_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66B*4)))
#define JECS_CSU_ECPRIPARA13_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66C*4)))
#define JECS_CSU_ECPRIPARA13_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66D*4)))
#define JECS_CSU_ECPRIPARA13_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66E*4)))
#define JECS_CSU_ECPRIPARA13_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x66F*4)))
#define JECS_CSU_ECPRIPARA14_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x670*4)))
#define JECS_CSU_ECPRIPARA14_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x671*4)))
#define JECS_CSU_ECPRIPARA14_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x672*4)))
#define JECS_CSU_ECPRIPARA14_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x673*4)))
#define JECS_CSU_ECPRIPARA14_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x674*4)))
#define JECS_CSU_ECPRIPARA14_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x675*4)))
#define JECS_CSU_ECPRIPARA14_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x676*4)))
#define JECS_CSU_ECPRIPARA14_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x677*4)))
#define JECS_CSU_ECPRIPARA15_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x678*4)))
#define JECS_CSU_ECPRIPARA15_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x679*4)))
#define JECS_CSU_ECPRIPARA15_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67A*4)))
#define JECS_CSU_ECPRIPARA15_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67B*4)))
#define JECS_CSU_ECPRIPARA15_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67C*4)))
#define JECS_CSU_ECPRIPARA15_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67D*4)))
#define JECS_CSU_ECPRIPARA15_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67E*4)))
#define JECS_CSU_ECPRIPARA15_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x67F*4)))
#define JECS_CSU_ECPRIPARA16_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x680*4)))
#define JECS_CSU_ECPRIPARA16_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x681*4)))
#define JECS_CSU_ECPRIPARA16_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x682*4)))
#define JECS_CSU_ECPRIPARA16_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x683*4)))
#define JECS_CSU_ECPRIPARA16_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x684*4)))
#define JECS_CSU_ECPRIPARA16_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x685*4)))
#define JECS_CSU_ECPRIPARA16_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x686*4)))
#define JECS_CSU_ECPRIPARA16_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x687*4)))
#define JECS_CSU_ECPRIPARA17_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x688*4)))
#define JECS_CSU_ECPRIPARA17_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x689*4)))
#define JECS_CSU_ECPRIPARA17_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68A*4)))
#define JECS_CSU_ECPRIPARA17_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68B*4)))
#define JECS_CSU_ECPRIPARA17_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68C*4)))
#define JECS_CSU_ECPRIPARA17_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68D*4)))
#define JECS_CSU_ECPRIPARA17_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68E*4)))
#define JECS_CSU_ECPRIPARA17_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x68F*4)))
#define JECS_CSU_ECPRIPARA18_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x690*4)))
#define JECS_CSU_ECPRIPARA18_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x691*4)))
#define JECS_CSU_ECPRIPARA18_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x692*4)))
#define JECS_CSU_ECPRIPARA18_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x693*4)))
#define JECS_CSU_ECPRIPARA18_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x694*4)))
#define JECS_CSU_ECPRIPARA18_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x695*4)))
#define JECS_CSU_ECPRIPARA18_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x696*4)))
#define JECS_CSU_ECPRIPARA18_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x697*4)))
#define JECS_CSU_ECPRIPARA19_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x698*4)))
#define JECS_CSU_ECPRIPARA19_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x699*4)))
#define JECS_CSU_ECPRIPARA19_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69A*4)))
#define JECS_CSU_ECPRIPARA19_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69B*4)))
#define JECS_CSU_ECPRIPARA19_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69C*4)))
#define JECS_CSU_ECPRIPARA19_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69D*4)))
#define JECS_CSU_ECPRIPARA19_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69E*4)))
#define JECS_CSU_ECPRIPARA19_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x69F*4)))
#define JECS_CSU_ECPRIPARA20_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A0*4)))
#define JECS_CSU_ECPRIPARA20_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A1*4)))
#define JECS_CSU_ECPRIPARA20_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A2*4)))
#define JECS_CSU_ECPRIPARA20_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A3*4)))
#define JECS_CSU_ECPRIPARA20_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A4*4)))
#define JECS_CSU_ECPRIPARA20_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A5*4)))
#define JECS_CSU_ECPRIPARA20_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A6*4)))
#define JECS_CSU_ECPRIPARA20_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A7*4)))
#define JECS_CSU_ECPRIPARA21_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A8*4)))
#define JECS_CSU_ECPRIPARA21_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6A9*4)))
#define JECS_CSU_ECPRIPARA21_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AA*4)))
#define JECS_CSU_ECPRIPARA21_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AB*4)))
#define JECS_CSU_ECPRIPARA21_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AC*4)))
#define JECS_CSU_ECPRIPARA21_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AD*4)))
#define JECS_CSU_ECPRIPARA21_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AE*4)))
#define JECS_CSU_ECPRIPARA21_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6AF*4)))
#define JECS_CSU_ECPRIPARA22_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B0*4)))
#define JECS_CSU_ECPRIPARA22_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B1*4)))
#define JECS_CSU_ECPRIPARA22_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B2*4)))
#define JECS_CSU_ECPRIPARA22_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B3*4)))
#define JECS_CSU_ECPRIPARA22_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B4*4)))
#define JECS_CSU_ECPRIPARA22_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B5*4)))
#define JECS_CSU_ECPRIPARA22_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B6*4)))
#define JECS_CSU_ECPRIPARA22_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B7*4)))
#define JECS_CSU_ECPRIPARA23_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B8*4)))
#define JECS_CSU_ECPRIPARA23_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6B9*4)))
#define JECS_CSU_ECPRIPARA23_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BA*4)))
#define JECS_CSU_ECPRIPARA23_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BB*4)))
#define JECS_CSU_ECPRIPARA23_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BC*4)))
#define JECS_CSU_ECPRIPARA23_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BD*4)))
#define JECS_CSU_ECPRIPARA23_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BE*4)))
#define JECS_CSU_ECPRIPARA23_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6BF*4)))
#define JECS_CSU_ECPRIPARA24_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C0*4)))
#define JECS_CSU_ECPRIPARA24_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C1*4)))
#define JECS_CSU_ECPRIPARA24_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C2*4)))
#define JECS_CSU_ECPRIPARA24_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C3*4)))
#define JECS_CSU_ECPRIPARA24_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C4*4)))
#define JECS_CSU_ECPRIPARA24_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C5*4)))
#define JECS_CSU_ECPRIPARA24_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C6*4)))
#define JECS_CSU_ECPRIPARA24_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C7*4)))
#define JECS_CSU_ECPRIPARA25_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C8*4)))
#define JECS_CSU_ECPRIPARA25_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6C9*4)))
#define JECS_CSU_ECPRIPARA25_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CA*4)))
#define JECS_CSU_ECPRIPARA25_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CB*4)))
#define JECS_CSU_ECPRIPARA25_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CC*4)))
#define JECS_CSU_ECPRIPARA25_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CD*4)))
#define JECS_CSU_ECPRIPARA25_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CE*4)))
#define JECS_CSU_ECPRIPARA25_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6CF*4)))
#define JECS_CSU_ECPRIPARA26_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D0*4)))
#define JECS_CSU_ECPRIPARA26_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D1*4)))
#define JECS_CSU_ECPRIPARA26_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D2*4)))
#define JECS_CSU_ECPRIPARA26_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D3*4)))
#define JECS_CSU_ECPRIPARA26_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D4*4)))
#define JECS_CSU_ECPRIPARA26_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D5*4)))
#define JECS_CSU_ECPRIPARA26_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D6*4)))
#define JECS_CSU_ECPRIPARA26_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D7*4)))
#define JECS_CSU_ECPRIPARA27_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D8*4)))
#define JECS_CSU_ECPRIPARA27_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6D9*4)))
#define JECS_CSU_ECPRIPARA27_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DA*4)))
#define JECS_CSU_ECPRIPARA27_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DB*4)))
#define JECS_CSU_ECPRIPARA27_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DC*4)))
#define JECS_CSU_ECPRIPARA27_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DD*4)))
#define JECS_CSU_ECPRIPARA27_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DE*4)))
#define JECS_CSU_ECPRIPARA27_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6DF*4)))
#define JECS_CSU_ECPRIPARA28_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E0*4)))
#define JECS_CSU_ECPRIPARA28_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E1*4)))
#define JECS_CSU_ECPRIPARA28_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E2*4)))
#define JECS_CSU_ECPRIPARA28_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E3*4)))
#define JECS_CSU_ECPRIPARA28_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E4*4)))
#define JECS_CSU_ECPRIPARA28_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E5*4)))
#define JECS_CSU_ECPRIPARA28_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E6*4)))
#define JECS_CSU_ECPRIPARA28_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E7*4)))
#define JECS_CSU_ECPRIPARA29_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E8*4)))
#define JECS_CSU_ECPRIPARA29_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6E9*4)))
#define JECS_CSU_ECPRIPARA29_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6EA*4)))
#define JECS_CSU_ECPRIPARA29_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6EB*4)))
#define JECS_CSU_ECPRIPARA29_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6EC*4)))
#define JECS_CSU_ECPRIPARA29_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6ED*4)))
#define JECS_CSU_ECPRIPARA29_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6EE*4)))
#define JECS_CSU_ECPRIPARA29_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6EF*4)))
#define JECS_CSU_ECPRIPARA30_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F0*4)))
#define JECS_CSU_ECPRIPARA30_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F1*4)))
#define JECS_CSU_ECPRIPARA30_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F2*4)))
#define JECS_CSU_ECPRIPARA30_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F3*4)))
#define JECS_CSU_ECPRIPARA30_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F4*4)))
#define JECS_CSU_ECPRIPARA30_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F5*4)))
#define JECS_CSU_ECPRIPARA30_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F6*4)))
#define JECS_CSU_ECPRIPARA30_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F7*4)))
#define JECS_CSU_ECPRIPARA31_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F8*4)))
#define JECS_CSU_ECPRIPARA31_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6F9*4)))
#define JECS_CSU_ECPRIPARA31_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FA*4)))
#define JECS_CSU_ECPRIPARA31_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FB*4)))
#define JECS_CSU_ECPRIPARA31_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FC*4)))
#define JECS_CSU_ECPRIPARA31_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FD*4)))
#define JECS_CSU_ECPRIPARA31_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FE*4)))
#define JECS_CSU_ECPRIPARA31_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x6FF*4)))
#define JECS_CSU_ECPRIPARA32_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x700*4)))
#define JECS_CSU_ECPRIPARA32_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x701*4)))
#define JECS_CSU_ECPRIPARA32_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x702*4)))
#define JECS_CSU_ECPRIPARA32_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x703*4)))
#define JECS_CSU_ECPRIPARA32_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x704*4)))
#define JECS_CSU_ECPRIPARA32_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x705*4)))
#define JECS_CSU_ECPRIPARA32_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x706*4)))
#define JECS_CSU_ECPRIPARA32_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x707*4)))
#define JECS_CSU_ECPRIPARA33_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x708*4)))
#define JECS_CSU_ECPRIPARA33_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x709*4)))
#define JECS_CSU_ECPRIPARA33_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70A*4)))
#define JECS_CSU_ECPRIPARA33_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70B*4)))
#define JECS_CSU_ECPRIPARA33_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70C*4)))
#define JECS_CSU_ECPRIPARA33_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70D*4)))
#define JECS_CSU_ECPRIPARA33_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70E*4)))
#define JECS_CSU_ECPRIPARA33_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x70F*4)))
#define JECS_CSU_ECPRIPARA34_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x710*4)))
#define JECS_CSU_ECPRIPARA34_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x711*4)))
#define JECS_CSU_ECPRIPARA34_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x712*4)))
#define JECS_CSU_ECPRIPARA34_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x713*4)))
#define JECS_CSU_ECPRIPARA34_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x714*4)))
#define JECS_CSU_ECPRIPARA34_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x715*4)))
#define JECS_CSU_ECPRIPARA34_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x716*4)))
#define JECS_CSU_ECPRIPARA34_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x717*4)))
#define JECS_CSU_ECPRIPARA35_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x718*4)))
#define JECS_CSU_ECPRIPARA35_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x719*4)))
#define JECS_CSU_ECPRIPARA35_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71A*4)))
#define JECS_CSU_ECPRIPARA35_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71B*4)))
#define JECS_CSU_ECPRIPARA35_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71C*4)))
#define JECS_CSU_ECPRIPARA35_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71D*4)))
#define JECS_CSU_ECPRIPARA35_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71E*4)))
#define JECS_CSU_ECPRIPARA35_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x71F*4)))
#define JECS_CSU_ECPRIPARA36_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x720*4)))
#define JECS_CSU_ECPRIPARA36_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x721*4)))
#define JECS_CSU_ECPRIPARA36_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x722*4)))
#define JECS_CSU_ECPRIPARA36_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x723*4)))
#define JECS_CSU_ECPRIPARA36_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x724*4)))
#define JECS_CSU_ECPRIPARA36_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x725*4)))
#define JECS_CSU_ECPRIPARA36_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x726*4)))
#define JECS_CSU_ECPRIPARA36_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x727*4)))
#define JECS_CSU_ECPRIPARA37_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x728*4)))
#define JECS_CSU_ECPRIPARA37_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x729*4)))
#define JECS_CSU_ECPRIPARA37_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72A*4)))
#define JECS_CSU_ECPRIPARA37_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72B*4)))
#define JECS_CSU_ECPRIPARA37_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72C*4)))
#define JECS_CSU_ECPRIPARA37_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72D*4)))
#define JECS_CSU_ECPRIPARA37_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72E*4)))
#define JECS_CSU_ECPRIPARA37_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x72F*4)))
#define JECS_CSU_ECPRIPARA38_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x730*4)))
#define JECS_CSU_ECPRIPARA38_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x731*4)))
#define JECS_CSU_ECPRIPARA38_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x732*4)))
#define JECS_CSU_ECPRIPARA38_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x733*4)))
#define JECS_CSU_ECPRIPARA38_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x734*4)))
#define JECS_CSU_ECPRIPARA38_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x735*4)))
#define JECS_CSU_ECPRIPARA38_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x736*4)))
#define JECS_CSU_ECPRIPARA38_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x737*4)))
#define JECS_CSU_ECPRIPARA39_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x738*4)))
#define JECS_CSU_ECPRIPARA39_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x739*4)))
#define JECS_CSU_ECPRIPARA39_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73A*4)))
#define JECS_CSU_ECPRIPARA39_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73B*4)))
#define JECS_CSU_ECPRIPARA39_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73C*4)))
#define JECS_CSU_ECPRIPARA39_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73D*4)))
#define JECS_CSU_ECPRIPARA39_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73E*4)))
#define JECS_CSU_ECPRIPARA39_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x73F*4)))
#define JECS_CSU_ECPRIPARA40_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x740*4)))
#define JECS_CSU_ECPRIPARA40_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x741*4)))
#define JECS_CSU_ECPRIPARA40_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x742*4)))
#define JECS_CSU_ECPRIPARA40_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x743*4)))
#define JECS_CSU_ECPRIPARA40_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x744*4)))
#define JECS_CSU_ECPRIPARA40_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x745*4)))
#define JECS_CSU_ECPRIPARA40_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x746*4)))
#define JECS_CSU_ECPRIPARA40_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x747*4)))
#define JECS_CSU_ECPRIPARA41_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x748*4)))
#define JECS_CSU_ECPRIPARA41_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x749*4)))
#define JECS_CSU_ECPRIPARA41_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74A*4)))
#define JECS_CSU_ECPRIPARA41_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74B*4)))
#define JECS_CSU_ECPRIPARA41_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74C*4)))
#define JECS_CSU_ECPRIPARA41_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74D*4)))
#define JECS_CSU_ECPRIPARA41_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74E*4)))
#define JECS_CSU_ECPRIPARA41_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x74F*4)))
#define JECS_CSU_ECPRIPARA42_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x750*4)))
#define JECS_CSU_ECPRIPARA42_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x751*4)))
#define JECS_CSU_ECPRIPARA42_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x752*4)))
#define JECS_CSU_ECPRIPARA42_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x753*4)))
#define JECS_CSU_ECPRIPARA42_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x754*4)))
#define JECS_CSU_ECPRIPARA42_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x755*4)))
#define JECS_CSU_ECPRIPARA42_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x756*4)))
#define JECS_CSU_ECPRIPARA42_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x757*4)))
#define JECS_CSU_ECPRIPARA43_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x758*4)))
#define JECS_CSU_ECPRIPARA43_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x759*4)))
#define JECS_CSU_ECPRIPARA43_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75A*4)))
#define JECS_CSU_ECPRIPARA43_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75B*4)))
#define JECS_CSU_ECPRIPARA43_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75C*4)))
#define JECS_CSU_ECPRIPARA43_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75D*4)))
#define JECS_CSU_ECPRIPARA43_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75E*4)))
#define JECS_CSU_ECPRIPARA43_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x75F*4)))
#define JECS_CSU_ECPRIPARA44_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x760*4)))
#define JECS_CSU_ECPRIPARA44_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x761*4)))
#define JECS_CSU_ECPRIPARA44_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x762*4)))
#define JECS_CSU_ECPRIPARA44_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x763*4)))
#define JECS_CSU_ECPRIPARA44_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x764*4)))
#define JECS_CSU_ECPRIPARA44_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x765*4)))
#define JECS_CSU_ECPRIPARA44_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x766*4)))
#define JECS_CSU_ECPRIPARA44_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x767*4)))
#define JECS_CSU_ECPRIPARA45_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x768*4)))
#define JECS_CSU_ECPRIPARA45_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x769*4)))
#define JECS_CSU_ECPRIPARA45_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76A*4)))
#define JECS_CSU_ECPRIPARA45_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76B*4)))
#define JECS_CSU_ECPRIPARA45_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76C*4)))
#define JECS_CSU_ECPRIPARA45_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76D*4)))
#define JECS_CSU_ECPRIPARA45_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76E*4)))
#define JECS_CSU_ECPRIPARA45_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x76F*4)))
#define JECS_CSU_ECPRIPARA46_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x770*4)))
#define JECS_CSU_ECPRIPARA46_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x771*4)))
#define JECS_CSU_ECPRIPARA46_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x772*4)))
#define JECS_CSU_ECPRIPARA46_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x773*4)))
#define JECS_CSU_ECPRIPARA46_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x774*4)))
#define JECS_CSU_ECPRIPARA46_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x775*4)))
#define JECS_CSU_ECPRIPARA46_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x776*4)))
#define JECS_CSU_ECPRIPARA46_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x777*4)))
#define JECS_CSU_ECPRIPARA47_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x778*4)))
#define JECS_CSU_ECPRIPARA47_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x779*4)))
#define JECS_CSU_ECPRIPARA47_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77A*4)))
#define JECS_CSU_ECPRIPARA47_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77B*4)))
#define JECS_CSU_ECPRIPARA47_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77C*4)))
#define JECS_CSU_ECPRIPARA47_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77D*4)))
#define JECS_CSU_ECPRIPARA47_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77E*4)))
#define JECS_CSU_ECPRIPARA47_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x77F*4)))
#define JECS_CSU_ECPRIPARA48_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x780*4)))
#define JECS_CSU_ECPRIPARA48_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x781*4)))
#define JECS_CSU_ECPRIPARA48_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x782*4)))
#define JECS_CSU_ECPRIPARA48_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x783*4)))
#define JECS_CSU_ECPRIPARA48_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x784*4)))
#define JECS_CSU_ECPRIPARA48_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x785*4)))
#define JECS_CSU_ECPRIPARA48_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x786*4)))
#define JECS_CSU_ECPRIPARA48_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x787*4)))
#define JECS_CSU_ECPRIPARA49_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x788*4)))
#define JECS_CSU_ECPRIPARA49_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x789*4)))
#define JECS_CSU_ECPRIPARA49_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78A*4)))
#define JECS_CSU_ECPRIPARA49_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78B*4)))
#define JECS_CSU_ECPRIPARA49_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78C*4)))
#define JECS_CSU_ECPRIPARA49_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78D*4)))
#define JECS_CSU_ECPRIPARA49_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78E*4)))
#define JECS_CSU_ECPRIPARA49_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x78F*4)))
#define JECS_CSU_ECPRIPARA50_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x790*4)))
#define JECS_CSU_ECPRIPARA50_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x791*4)))
#define JECS_CSU_ECPRIPARA50_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x792*4)))
#define JECS_CSU_ECPRIPARA50_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x793*4)))
#define JECS_CSU_ECPRIPARA50_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x794*4)))
#define JECS_CSU_ECPRIPARA50_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x795*4)))
#define JECS_CSU_ECPRIPARA50_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x796*4)))
#define JECS_CSU_ECPRIPARA50_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x797*4)))
#define JECS_CSU_ECPRIPARA51_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x798*4)))
#define JECS_CSU_ECPRIPARA51_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x799*4)))
#define JECS_CSU_ECPRIPARA51_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79A*4)))
#define JECS_CSU_ECPRIPARA51_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79B*4)))
#define JECS_CSU_ECPRIPARA51_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79C*4)))
#define JECS_CSU_ECPRIPARA51_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79D*4)))
#define JECS_CSU_ECPRIPARA51_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79E*4)))
#define JECS_CSU_ECPRIPARA51_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x79F*4)))
#define JECS_CSU_ECPRIPARA52_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A0*4)))
#define JECS_CSU_ECPRIPARA52_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A1*4)))
#define JECS_CSU_ECPRIPARA52_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A2*4)))
#define JECS_CSU_ECPRIPARA52_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A3*4)))
#define JECS_CSU_ECPRIPARA52_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A4*4)))
#define JECS_CSU_ECPRIPARA52_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A5*4)))
#define JECS_CSU_ECPRIPARA52_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A6*4)))
#define JECS_CSU_ECPRIPARA52_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A7*4)))
#define JECS_CSU_ECPRIPARA53_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A8*4)))
#define JECS_CSU_ECPRIPARA53_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7A9*4)))
#define JECS_CSU_ECPRIPARA53_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AA*4)))
#define JECS_CSU_ECPRIPARA53_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AB*4)))
#define JECS_CSU_ECPRIPARA53_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AC*4)))
#define JECS_CSU_ECPRIPARA53_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AD*4)))
#define JECS_CSU_ECPRIPARA53_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AE*4)))
#define JECS_CSU_ECPRIPARA53_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7AF*4)))
#define JECS_CSU_ECPRIPARA54_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B0*4)))
#define JECS_CSU_ECPRIPARA54_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B1*4)))
#define JECS_CSU_ECPRIPARA54_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B2*4)))
#define JECS_CSU_ECPRIPARA54_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B3*4)))
#define JECS_CSU_ECPRIPARA54_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B4*4)))
#define JECS_CSU_ECPRIPARA54_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B5*4)))
#define JECS_CSU_ECPRIPARA54_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B6*4)))
#define JECS_CSU_ECPRIPARA54_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B7*4)))
#define JECS_CSU_ECPRIPARA55_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B8*4)))
#define JECS_CSU_ECPRIPARA55_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7B9*4)))
#define JECS_CSU_ECPRIPARA55_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BA*4)))
#define JECS_CSU_ECPRIPARA55_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BB*4)))
#define JECS_CSU_ECPRIPARA55_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BC*4)))
#define JECS_CSU_ECPRIPARA55_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BD*4)))
#define JECS_CSU_ECPRIPARA55_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BE*4)))
#define JECS_CSU_ECPRIPARA55_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7BF*4)))
#define JECS_CSU_ECPRIPARA56_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C0*4)))
#define JECS_CSU_ECPRIPARA56_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C1*4)))
#define JECS_CSU_ECPRIPARA56_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C2*4)))
#define JECS_CSU_ECPRIPARA56_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C3*4)))
#define JECS_CSU_ECPRIPARA56_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C4*4)))
#define JECS_CSU_ECPRIPARA56_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C5*4)))
#define JECS_CSU_ECPRIPARA56_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C6*4)))
#define JECS_CSU_ECPRIPARA56_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C7*4)))
#define JECS_CSU_ECPRIPARA57_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C8*4)))
#define JECS_CSU_ECPRIPARA57_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7C9*4)))
#define JECS_CSU_ECPRIPARA57_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CA*4)))
#define JECS_CSU_ECPRIPARA57_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CB*4)))
#define JECS_CSU_ECPRIPARA57_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CC*4)))
#define JECS_CSU_ECPRIPARA57_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CD*4)))
#define JECS_CSU_ECPRIPARA57_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CE*4)))
#define JECS_CSU_ECPRIPARA57_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7CF*4)))
#define JECS_CSU_ECPRIPARA58_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D0*4)))
#define JECS_CSU_ECPRIPARA58_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D1*4)))
#define JECS_CSU_ECPRIPARA58_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D2*4)))
#define JECS_CSU_ECPRIPARA58_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D3*4)))
#define JECS_CSU_ECPRIPARA58_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D4*4)))
#define JECS_CSU_ECPRIPARA58_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D5*4)))
#define JECS_CSU_ECPRIPARA58_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D6*4)))
#define JECS_CSU_ECPRIPARA58_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D7*4)))
#define JECS_CSU_ECPRIPARA59_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D8*4)))
#define JECS_CSU_ECPRIPARA59_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7D9*4)))
#define JECS_CSU_ECPRIPARA59_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DA*4)))
#define JECS_CSU_ECPRIPARA59_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DB*4)))
#define JECS_CSU_ECPRIPARA59_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DC*4)))
#define JECS_CSU_ECPRIPARA59_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DD*4)))
#define JECS_CSU_ECPRIPARA59_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DE*4)))
#define JECS_CSU_ECPRIPARA59_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7DF*4)))
#define JECS_CSU_ECPRIPARA60_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E0*4)))
#define JECS_CSU_ECPRIPARA60_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E1*4)))
#define JECS_CSU_ECPRIPARA60_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E2*4)))
#define JECS_CSU_ECPRIPARA60_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E3*4)))
#define JECS_CSU_ECPRIPARA60_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E4*4)))
#define JECS_CSU_ECPRIPARA60_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E5*4)))
#define JECS_CSU_ECPRIPARA60_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E6*4)))
#define JECS_CSU_ECPRIPARA60_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E7*4)))
#define JECS_CSU_ECPRIPARA61_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E8*4)))
#define JECS_CSU_ECPRIPARA61_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7E9*4)))
#define JECS_CSU_ECPRIPARA61_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7EA*4)))
#define JECS_CSU_ECPRIPARA61_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7EB*4)))
#define JECS_CSU_ECPRIPARA61_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7EC*4)))
#define JECS_CSU_ECPRIPARA61_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7ED*4)))
#define JECS_CSU_ECPRIPARA61_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7EE*4)))
#define JECS_CSU_ECPRIPARA61_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7EF*4)))
#define JECS_CSU_ECPRIPARA62_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F0*4)))
#define JECS_CSU_ECPRIPARA62_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F1*4)))
#define JECS_CSU_ECPRIPARA62_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F2*4)))
#define JECS_CSU_ECPRIPARA62_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F3*4)))
#define JECS_CSU_ECPRIPARA62_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F4*4)))
#define JECS_CSU_ECPRIPARA62_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F5*4)))
#define JECS_CSU_ECPRIPARA62_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F6*4)))
#define JECS_CSU_ECPRIPARA62_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F7*4)))
#define JECS_CSU_ECPRIPARA63_0                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F8*4)))
#define JECS_CSU_ECPRIPARA63_1                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7F9*4)))
#define JECS_CSU_ECPRIPARA63_2                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FA*4)))
#define JECS_CSU_ECPRIPARA63_3                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FB*4)))
#define JECS_CSU_ECPRIPARA63_4                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FC*4)))
#define JECS_CSU_ECPRIPARA63_5                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FD*4)))
#define JECS_CSU_ECPRIPARA63_6                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FE*4)))
#define JECS_CSU_ECPRIPARA63_7                    (*((volatile uint32_t *)(JECS_CSU_BASE+0x7FF*4)))


#endif
